<?php
/**
 * Created by PhpStorm.
 * User: dxPro
 * Date: 16/02/16
 * Time: 12:33
 */

namespace DXIM;

class AddOn {

    protected $addon_key = null;
    protected $addon_name = null;
    protected $addon_path = null;

    protected $options_header = null;
    protected $options_body = '';

    /**
     * AddOn constructor.
     */
    public function __construct($key, $name, $path) {
        $this->addon_key = $key;
        $this->addon_name = $name;
        $this->addon_path = $path;

        $plugin_data = get_file_data($path, array('Version' => 'Version'), false);

        add_filter('wpcs_settings_menu', [$this, '_settings']);

        new \Updater($name, $plugin_data['Version'],'wpcsupdateaddons/'.$this->addon_key);
        #new \Updater($name, $plugin_data['Version'],'wpcsupdatetest/'.$this->addon_key);

    }

    public function _settings($menu) {
        $this->_set_options();
        if(empty($this->options_body)) return $menu;

        $menu['addon']['items'][$this->addon_key] = ['label' => $this->addon_name, 'callback' => [&$this,'_draw_options_body']];
        return $menu;
    }

    /**
     * @return null
     */
    private function _draw_options_header() {
        if(empty($this->options_header)) return null;

        $html = '<h3 class="section_header addon_header" rel="'.$this->addon_key.'">Add On: '.$this->options_header.'</h3>';

        return $html;
    }

    /**
     *
     */
    public function _draw_options_body() {
        if(empty($this->options_body)) return null;

        #$html = '<section class="wpcarsync_admin_section addon_section" rel="'.$this->addon_key.'">';
            $html = $this->options_body;
        #$html .= '</section>';

        print $html;
    }

    /**
     *
     */
    public function _set_options() {}

    /**
     * draw AddOn Options
     * @return string|null
     */
    public function _draw_options() {
        $this->_set_options();

        if(empty($this->options_header) || empty($this->options_body)) return null;
        elseif(empty($this->addon_key)) { print "AddOn Key is null"; return null; }

        $html = $this->_draw_options_header();
        $html .= $this->_draw_options_body();

        print $html;
    }

    /**
     * @return string
     */
    public function _please_upgrade() {
        return '<div class="">Für dieses AddOn benötigen Sie eine <a href="'.DXIM_PluginWebAddress.'" target="_blank">Pro - Lizenz</a>.</div>';
    }


}