<?php
/**
 * Created by PhpStorm.
 * User: dxPro
 * Date: 07/01/16
 * Time: 17:21
 */

namespace DXIM;


class Customizer {


    protected static $instance = null;
    protected $mods = [];


    /**
     *
     * @return Customizer
     */
    public static function getInstance() {
        if(self::$instance === null) {
            self::$instance = new self;
        }
        return self::$instance;
    }

    /**
     *
     */
    public function __construct() {
        add_action( 'customize_register', array(&$this,'_customizer'));
        add_action('wp_head',array(&$this,'_css'));

        $this->mods = $this->loadMods();
    }

	/**
	 * @return array|mixed
	 */
    public function getMods() { return $this->mods; }

    /**
     *
     */
    public function _css() {
        $mods = $this->mods;
        foreach($mods as $key => $value) {
            if(empty($value)) unset($mods[$key]);
        }
        $mods_defaults = [

            // general
            'general_container_width' => 1400,
            'general_primary_color' => '#333',
            'general_primary_color_font' => null,
            'general_secondary_color' => '#D3D3D3',
            'general_secondary_color_font' => null,
            'general_border_color'=>'#D3D3D3',

            // button
            'button_color_bg'=>null,
            'button_color'=>null,
            'button_color_bg_hover' => null,
            'button_color_hover'=>null,

            // form
            'form_bg_color' => '#fff',
            'form_inner_color' => null,
            'form_active_color' => '#ababab',
            'form_active_inner_color' => '#fff',
            'form_handle_icon_color' => '#E8E7E6',
            'form_border_color' => '#D3D3D3'

        ];
        $mods = array_merge($mods_defaults, $mods);

        #wpcs_p($mods);

        $html = '<style type="text/css">'."\n";
        $html .= "
            :root {                 
                --wpcs-theme-container-width:".$mods['general_container_width']."px;
                
                --wpcs-theme-primary-color:".$mods['general_primary_color'].";
                --wpcs-theme-primary-color-font:".$mods['general_primary_color_font'].";               
                --wpcs-theme-secondary-color:".$mods['general_secondary_color'].";                
                --wpcs-theme-secondary-color-font:".$mods['general_secondary_color_font'].";                             
                --wpcs-theme-border-color:".$mods['general_border_color'].";
                
                --wpcs-button-color-bg:".$mods['button_color_bg'].";
                --wpcs-button-color:".$mods['button_color'].";
                --wpcs-button-color-bg-hover:".$mods['button_color_bg_hover'].";
                --wpcs-button-color-hover:".$mods['button_color_hover'].";
                                
                --wpcs-form-bg-color:".$mods['form_bg_color'].";
                --wpcs-form-inner-color:".$mods['form_inner_color'].";
                --wpcs-form-active-color:".$mods['form_active_color'].";
                --wpcs-form-active-inner-color:".$mods['form_active_inner_color'].";
                --wpcs-form-handle-icon-color:".$mods['form_handle_icon_color'].";
                --wpcs-form-border-color:".$mods['form_border_color'].";
            }";

        $html .= '</style>'."\n";

        print $html;
    }

    /**
     * @param $color
     * @param $color_ref
     * @return mixed
     */
    private function loadMods() {
        $allmods = get_theme_mods();
        $mods = $allmods['wpcs'] ?? null;

        #wpcs_p($mods);

        if(!isset($mods['general_secondary_color'])) $mods['general_secondary_color'] = null;
        if(!isset($mods['general_primary_color'])) $mods['general_primary_color'] = null;
        if(!isset($mods['general_border_color'])) $mods['general_border_color'] = null;
        if(!isset($mods['general_primary_color_font'])) $mods['general_primary_color_font'] = null;
        if(!isset($mods['general_secondary_color_font'])) $mods['general_secondary_color_font'] = null;

        if(empty($mods['button_color'])) $mods['button_color'] = $mods['general_primary_color_font'];
        if(empty($mods['button_color_bg'])) $mods['button_color_bg'] = $mods['general_primary_color'];

        if(empty($mods['button_color_hover'])) $mods['button_color_hover'] = $mods['general_secondary_color_font'];
        if(empty($mods['button_color_bg_hover'])) $mods['button_color_bg_hover'] = $mods['general_secondary_color'];

        if(empty($mods['form_border_color'])) $mods['form_border_color'] = $mods['general_border_color'];

        return $mods;
    }

    /**
     * @param $wp_customize
     */
    public function _customizer($wp_customize) {

        // panel
        $wp_customize->add_panel( 'wpcs', array(
            'title' => 'WPCarSync',
            'description' => 'Passen sie mit den folgenden Optionen das Plugin an ihr Theme an.',
            'priority' => 160
        ));

        $this->general($wp_customize);
        $this->buttons($wp_customize);
        $this->forms($wp_customize);
        $this->pdf($wp_customize);
    }


    /**
     * @param $wp_customize
     * @return mixed
     */
    private function pdf(&$wp_customize) {

        $wp_customize->add_section('wpcs_pdf', [
            'title' => 'PDF-Exposé',
            'panel' => 'wpcs'
        ]);

        //
        $wp_customize->add_setting( 'wpcs[pdf_headline_color]' , array('default' => '#000000') );
        $wp_customize->add_control( new \WP_Customize_Color_Control( $wp_customize, 'wpcs_pdf_headline_color', array(
            'label'      => 'Farbe Headlines',
            'section'    => 'wpcs_pdf',
            'settings'   => 'wpcs[pdf_headline_color]',
        ) ) );

        //
        $wp_customize->add_setting( 'wpcs[pdf_text_color]' , array('default' => '#000000') );
        $wp_customize->add_control( new \WP_Customize_Color_Control( $wp_customize, 'wpcs_pdf_text_color', array(
            'label'      => 'Farbe Text',
            'section'    => 'wpcs_pdf',
            'settings'   => 'wpcs[pdf_text_color]',
        ) ) );

        //
        $wp_customize->add_setting( 'wpcs[pdf_rect_color]' , array('default' => '#333333') );
        $wp_customize->add_control( new \WP_Customize_Color_Control( $wp_customize, 'wpcs_pdf_rect_color', array(
            'label'      => 'Hintergrund Farbe Rechteck Element',
            'section'    => 'wpcs_pdf',
            'settings'   => 'wpcs[pdf_rect_color]',
        ) ) );

        //
        $wp_customize->add_setting( 'wpcs[pdf_rect_font_color]' , array('default' => '#ffffff') );
        $wp_customize->add_control( new \WP_Customize_Color_Control( $wp_customize, 'wpcs_pdf_rect_font_color', array(
            'label'      => 'Schriftfarbe Rechteck Element',
            'section'    => 'wpcs_pdf',
            'settings'   => 'wpcs[pdf_rect_font_color]',
        ) ) );

        //
        $wp_customize->add_setting( 'wpcs[pdf_footer_bg_color]' , array('default' => '#333333') );
        $wp_customize->add_control( new \WP_Customize_Color_Control( $wp_customize, 'wpcs_pdf_footer_bg_color', array(
            'label'      => 'Hintergrundfarbe Footer',
            'section'    => 'wpcs_pdf',
            'settings'   => 'wpcs[pdf_footer_bg_color]',
        ) ) );

        //
        $wp_customize->add_setting( 'wpcs[pdf_footer_text_color]' , array('default' => '#ffffff') );
        $wp_customize->add_control( new \WP_Customize_Color_Control( $wp_customize, 'wpcs_pdf_footer_text_color', array(
            'label'      => 'Hintergrundfarbe Footer Schrift',
            'section'    => 'wpcs_pdf',
            'settings'   => 'wpcs[pdf_footer_text_color]',
        ) ) );

        return $wp_customize;
    }

    /**
     * @param $wp_customize
     * @return mixed
     */
    private function forms(&$wp_customize) {

        $wp_customize->add_section('wpcs_forms', [
            'title' => 'Formulare',
            'panel' => 'wpcs'
        ]);

        //
        $wp_customize->add_setting( 'wpcs[form_bg_color]' , array() );
        $wp_customize->add_control( new \WP_Customize_Color_Control( $wp_customize, 'wpcs_form_bg_color', array(
            'label'      => 'Formular Element Hintergrund',
            'section'    => 'wpcs_forms',
            'settings'   => 'wpcs[form_bg_color]',
        ) ) );

        //
        $wp_customize->add_setting( 'wpcs[form_inner_color]' , array() );
        $wp_customize->add_control( new \WP_Customize_Color_Control( $wp_customize, 'wpcs_form_inner_color', array(
            'label'      => 'Formular Element Schriftfarbe',
            'section'    => 'wpcs_forms',
            'settings'   => 'wpcs[form_inner_color]',
        ) ) );

        //
        $wp_customize->add_setting( 'wpcs[form_active_color]' , array() );
        $wp_customize->add_control( new \WP_Customize_Color_Control( $wp_customize, 'wpcs_form_active_color', array(
            'label'      => 'Formular Element aktive Farbe',
            'section'    => 'wpcs_forms',
            'settings'   => 'wpcs[form_active_color]',
        ) ) );

        //
        $wp_customize->add_setting( 'wpcs[form_active_inner_color]' , array() );
        $wp_customize->add_control( new \WP_Customize_Color_Control( $wp_customize, 'wpcs_form_active_inner_color', array(
            'label'      => 'Formular Element aktive Farbe innen',
            'section'    => 'wpcs_forms',
            'settings'   => 'wpcs[form_active_inner_color]',
        ) ) );

        //
        $wp_customize->add_setting( 'wpcs[form_handle_icon_color]' , array() );
        $wp_customize->add_control( new \WP_Customize_Color_Control( $wp_customize, 'wpcs_form_handle_icon_color', array(
            'label'      => 'Handle Farbe',
            'section'    => 'wpcs_forms',
            'settings'   => 'wpcs[form_handle_icon_color]',
        ) ) );

        //
        $wp_customize->add_setting( 'wpcs[form_border_color]' , array() );
        $wp_customize->add_control( new \WP_Customize_Color_Control( $wp_customize, 'wpcs_form_border_color', array(
            'label'      => 'Rahmenfarbe',
            'section'    => 'wpcs_forms',
            'settings'   => 'wpcs[form_border_color]',
        ) ) );

        return $wp_customize;
    }

    /**
     * @param $wp_customize
     * @return mixed
     */
    private function general(&$wp_customize) {

        $wp_customize->add_section('wpcs_general', [
            'title' => 'Theme',
            'panel' => 'wpcs'
        ]);

        /**
         * Theme Max Width
         */
        $wp_customize->add_setting( 'wpcs[general_container_width]', array(
            'default' => '1400',
            'type' => 'theme_mod',
            'capability' => 'edit_theme_options',
            'transport' => '',
            'sanitize_callback' => 'sanitize_text_field',
        ) );

        $wp_customize->add_control( 'wpcs[general_container_width]', array(
            'type' => 'number',
            'priority' => 10,
            'section' => 'wpcs_general',
            'label' => 'Seitenbreite boxed',
            'description' => 'Maximalbreite des Themes im Boxed-Layout',
        ) );

        /**
         * Theme Primärfarbe
         */
        $wp_customize->add_setting( 'wpcs[general_primary_color]' , array(
            'default'   => '#333',
        ) );

        $wp_customize->add_control( new \WP_Customize_Color_Control( $wp_customize, 'wpcs_general_primary_color', array(
            'label'      => 'Theme Primärfarbe',
            'section'    => 'wpcs_general',
            'settings'   => 'wpcs[general_primary_color]',
            'description' => 'Zählt als Primärfarbe für Buttons und andere Element, sofern diese nicht extra definiert wurden.'
        ) ) );

        $wp_customize->add_setting( 'wpcs[general_primary_color_font]' , array(
            'default'   => '#fff',
        ) );

        $wp_customize->add_control( new \WP_Customize_Color_Control( $wp_customize, 'wpcs_general_primary_color_font', array(
            'label'      => 'Theme Primärfarbe Text',
            'section'    => 'wpcs_general',
            'settings'   => 'wpcs[general_primary_color_font]',
            'description' => 'Textfarbe passend zu Theme Primärfarbe'
        ) ) );

        /**
         * Theme Sekundärfarbe
         */
        $wp_customize->add_setting( 'wpcs[general_secondary_color]' , array(
            'default'   => '#444',
        ) );

        $wp_customize->add_control( new \WP_Customize_Color_Control( $wp_customize, 'wpcs_general_secondary_color', array(
            'label'      => 'Theme Sekundärfarbe',
            'section'    => 'wpcs_general',
            'settings'   => 'wpcs[general_secondary_color]',
            'description' => 'Pendant zu Primärfarbe, z.B. für Button Mouseover, etc...'
        ) ) );

        $wp_customize->add_setting( 'wpcs[general_secondary_color_font]' , array(
            'default'   => '#fff',
        ) );

        $wp_customize->add_control( new \WP_Customize_Color_Control( $wp_customize, 'wpcs_general_secondary_color_font', array(
            'label'      => 'Theme Sekundärfarbe Text',
            'section'    => 'wpcs_general',
            'settings'   => 'wpcs[general_secondary_color_font]',
            'description' => 'Textfarbe passend zu Theme Sekundärfarbe'
        ) ) );

        /**
         * Theme Linienfarbe
         */
        $wp_customize->add_setting( 'wpcs[general_border_color]' , array(
            'default'   => '#cccccc',
        ) );

        $wp_customize->add_control( new \WP_Customize_Color_Control( $wp_customize, 'wpcs_general_border_color', array(
            'label'      => 'Theme Rahmen- & Linienfarbe',
            'section'    => 'wpcs_general',
            'settings'   => 'wpcs[general_border_color]',
        ) ) );

        return $wp_customize;
    }

    private function buttons(&$wp_customize) {

        $wp_customize->add_section('wpcs_buttons', [
            'title' => 'Buttons',
            'panel' => 'wpcs'
        ]);


        $wp_customize->add_setting( 'wpcs[button_color]' , array(
            //'default'   => '#000000',
        ) );

        $wp_customize->add_control( new \WP_Customize_Color_Control( $wp_customize, 'wpcs_button_color', array(
            'label'      => 'Button Schriftfarbe',
            'section'    => 'wpcs_buttons',
            'settings'   => 'wpcs[button_color]',
        ) ) );

        $wp_customize->add_setting( 'wpcs[button_color_bg]' , array(
            //'default'   => '#000000',
        ) );

        $wp_customize->add_control( new \WP_Customize_Color_Control( $wp_customize, 'wpcs_button_color_bg', array(
            'label'      => 'Button Hintergrundfarbe',
            'section'    => 'wpcs_buttons',
            'settings'   => 'wpcs[button_color_bg]',
        ) ) );


        $wp_customize->add_setting( 'wpcs[button_color_hover]' , array(
            //'default'   => '#000000',
        ) );

        $wp_customize->add_control( new \WP_Customize_Color_Control( $wp_customize, 'wpcs_button_color_hover', array(
            'label'      => 'Button Schriftfarbe Mouseover',
            'section'    => 'wpcs_buttons',
            'settings'   => 'wpcs[button_color_hover]',
        ) ) );


	    $wp_customize->add_setting( 'wpcs[button_color_bg_hover]' , array(
		    //'default'   => '#000000',
	    ) );

	    $wp_customize->add_control( new \WP_Customize_Color_Control( $wp_customize, 'wpcs_button_color_bg_hover', array(
		    'label'      => 'Button Hintergrundfarbe Mouseover',
		    'section'    => 'wpcs_buttons',
		    'settings'   => 'wpcs[button_color_bg_hover]',
	    ) ) );



        // Button class
	    $wp_customize->add_setting( 'wpcs[button_classes]', array(
		    'default' => '',
		    'type' => 'theme_mod',
		    'capability' => 'edit_theme_options',
		    'transport' => '',
		    'sanitize_callback' => 'sanitize_text_field',
	    ) );

	    $wp_customize->add_control( 'wpcs[button_classes]', array(
		    'type' => 'text',
		    'priority' => 10,
		    'section' => 'wpcs_buttons',
		    'label' => __( 'Button CSS Klassen', 'textdomain' ),
		    'description' => 'Fügen Sie CSS Klassen des Themes hinzu, um das Styling des Themes für Buttons zu übernehmen.',
	    ) );



        return $wp_customize;
    }


}