<?php
/**
 * Created by PhpStorm.
 * User: dx
 * Date: 2019-04-03
 * Time: 10:11
 */

namespace DXIM;


use DXIM\theme\LocationData;

class Location {

	protected static $instance = null;

	public $location_id = null;


	/**
	 *
	 * @return Location
	 */
	public static function getInstance() {
		if(self::$instance === null) {
			self::$instance = new self;
		}
		return self::$instance;
	}

	/**
	 *
	 */
	public function __construct() {
	}


	/**
	 * @param \WP_Post $vehicle
	 *
	 * @return mixed
	 */
	public function get_location_by_vehicle(\WP_Post $vehicle) {
		$location_id = $vehicle->dxim_meta['ad_location'][0];
        $ld = new LocationData();
        $term = $ld->getById($location_id);
        if(empty($term)) return [];

        $location = [
            'id' => $term->term_id,
            'company-name' => $term->name,
            'street' => get_term_meta($term->term_id, "street", true),
            'zipcode' => get_term_meta($term->term_id, "zip", true),
            'city' => get_term_meta($term->term_id, "city", true),
            'email' => get_term_meta($term->term_id, "email", true),
        ];
        return $location;
    }

}