<?php

namespace DXIM;

class Mail {

    protected static $instance = null;

    /**
     * @param $subject
     * @param $msg
     * @param $headers
     * @param $attachments
     * @return void
     */
    public function send_admin_mail($subject, $msg, $headers = [], $attachments = []) {
        $options = Admin::getInstance()->getOptions();
        $email = isset($options['email']) && !empty($options['email']) ? $options['email'] : get_bloginfo('admin_email');
        $this->_send($email, $subject, $msg, $headers = [], $attachments = []);

    }

    /**
     * @param $to
     * @param $subject
     * @param $msg
     * @param $headers
     * @param $attachments
     * @return void
     */
    public function send_mail($to, $subject, $msg, $headers = [], $attachments = []) {
        $this->_send($to, $subject, $msg, $headers, $attachments);
    }

    /**
     * @param $to
     * @param $subject
     * @param $msg
     * @param $headers
     * @param $attachments
     * @return void
     */
    private function _send($to, $subject, $msg, $headers = [], $attachments = []) {

        add_filter( 'wp_mail_content_type', array(&$this,'set_html_content_type'));

        wp_mail($to,$subject,$msg,$headers,$attachments);

        remove_filter( 'wp_mail_content_type', array(&$this,'set_html_content_type') );
    }

    /**
     * @return string
     */
    public function set_html_content_type() {
        return 'text/html';
    }


}