<?php
/**
 * Created by PhpStorm.
 * User: dxPro
 * Date: 07/01/16
 * Time: 17:07
 */
namespace DXIM;

class PostType {

    protected static $instance = null;

    public static $post_type_slug = null;

    /**
     *
     * @return PostType
     */
    public static function getInstance() {
        if(self::$instance === null) {
            self::$instance = new self;
        }
        return self::$instance;
    }

    /**
     *
     */
    private function __construct() {
        if(!Admin::getInstance()->_plugin()) return;
        $this->_init_post_type_slug();
        $this->_register();


    }


	/**
	 *
	 */
    private function _init_post_type_slug() {
	    $page = Conf::getInstance()->getVehicleArchivePage();

        // neue version => in options angegebene url
        if(empty($page)) {
            $options = Admin::getInstance()->getOptions();
            $slug = $options['vehicle_post_type_slug'] ?? '';
        }

        // alte version => slug der hinterlegten Seite
        else {
            $slug = get_post_field( 'post_name', $page);
        }

        if(empty($slug)) $slug = "fahrzeugarchiv";
		self::$post_type_slug = $slug;
    }


    /**
     *
     */
    function _register() {

        $labels = array(
            'name'                  => _x( 'Fahrzeuge', 'Post Type General Name', 'text_domain' ),
            'singular_name'         => _x( 'Fahrzeug', 'Post Type Singular Name', 'text_domain' ),
            'menu_name'             => __( 'Fahrzeuge', 'text_domain' ),
            'name_admin_bar'        => __( 'Fahrzeuge', 'text_domain' ),
            'archives'              => __( 'Item Archives', 'text_domain' ),
            'parent_item_colon'     => __( 'Parent Item:', 'text_domain' ),
            'all_items'             => __( 'Alle Fahrzeuge', 'text_domain' ),
            'add_new_item'          => __( 'neues Fahrzeug', 'text_domain' ),
            'add_new'               => __( 'neues Fahrzeug', 'text_domain' ),
            'new_item'              => __( 'neues Fahrzeug', 'text_domain' ),
            'edit_item'             => __( 'Fahrzeug bearbeiten', 'text_domain' ),
            'update_item'           => __( 'Fahrzeug bearbeiten', 'text_domain' ),
            'view_item'             => __( 'Fahrzeug anzeigen', 'text_domain' ),
            'search_items'          => __( 'Suche Fahrzeuge', 'text_domain' ),
            'not_found'             => __( 'Not found', 'text_domain' ),
            'not_found_in_trash'    => __( 'Not found in Trash', 'text_domain' ),
            'featured_image'        => __( 'Featured Image', 'text_domain' ),
            'set_featured_image'    => __( 'Set featured image', 'text_domain' ),
            'remove_featured_image' => __( 'Remove featured image', 'text_domain' ),
            'use_featured_image'    => __( 'Use as featured image', 'text_domain' ),
            'insert_into_item'      => __( 'Insert into item', 'text_domain' ),
            'uploaded_to_this_item' => __( 'Uploaded to this item', 'text_domain' ),
            'items_list'            => __( 'Items list', 'text_domain' ),
            'items_list_navigation' => __( 'Items list navigation', 'text_domain' ),
            'filter_items_list'     => __( 'Filter items list', 'text_domain' ),
        );

        $options = Admin::getInstance()->getOptions();
        $has_archive = !isset($options['vehicle_archive_page']);

        $rewrite = array(
            'slug'                  => self::$post_type_slug,
            'with_front'            => true,
        );

        $args = array(
            'label'                 => __( 'Fahrzeug', 'text_domain' ),
            'description'           => __( 'Fahrzeuge', 'text_domain' ),
            'labels'                => $labels,
            'supports'              => array( 'title', 'editor', 'custom-fields', 'thumbnail' ),
            'hierarchical'          => false,
            'public'                => true,
            'show_ui'               => true,
            'show_in_menu'          => false,
            'menu_position'         => 5,
            'show_in_admin_bar'     => true,
            'show_in_nav_menus'     => true,
            'can_export'            => true,
            'has_archive'           => $has_archive,
            'menu_icon'             => 'dashicons-performance',
            'exclude_from_search'   => true,
            'publicly_queryable'    => true,
            'rewrite'               => $rewrite,
            'capability_type'       => 'page',
        );
        register_post_type( 'vehicle', $args );

    }

}