<?php
/**
 * Created by PhpStorm.
 * User: dxPro
 * Date: 08/01/16
 * Time: 08:35
 */

namespace DXIM;


class Shortcode {

    /**
     * @var null
     */
    protected static $instance = null;

    /** ------------------------------------
     * @return Shortcode
     */
    public static function getInstance() {
        if(self::$instance === null) {
            self::$instance = new self;
        }
        return self::$instance;
    }



    /**
     * Shortcode constructor.
     */
    public function __construct() {
	    if(!Admin::getInstance()->_plugin()) return;
		add_action('wp',array(&$this,'_init'));
        add_action('admin_init',array(&$this,'_init'));
        #$this->_init();
    }


	/**
	 *
	 */
    public function _init() {

	    /**
	     * liefert einen bestimmten Wert eines Fahrzeugs
	     */
		add_shortcode('WPCS_get',array(&$this,'_get'));

        /**
         *
         */
		add_shortcode('WPCS_if',[&$this,'_if']);

	    /**
	     * Darstellung bestimmter Fahrzeuge als Slider oder Grid
	     */
	    add_shortcode('WPCS_Cars',array(&$this,'_cars')); // alte Version
	    add_shortcode('WPCS_cars',array(&$this,'_cars'));

	    /**
	     * Vergleich
	     */
	    add_shortcode('WPCS_compare',array(&$this,'_vehicle_compare'));
        add_shortcode('WPCS_compare_button',array(&$this,'_compare_button'));
        add_shortcode('WPCS_count_vehicles_compared',array(&$this,'_count_vehicles_compared'));

        /**
         * Parken
         */
        add_shortcode('WPCS_vehicles_parked',array(&$this,'_vehicles_parked'));
        add_shortcode('WPCS_count_vehicles_parked',array(&$this,'_count_vehicles_parked'));

        /**
         * SearchRequest
         */
        add_shortcode('WPCS_vsr_save',array(&$this,'_wpcs_vsr_save'));
        add_shortcode('WPCS_vsr_list',array(&$this,'_wpcs_vsr_load_list'));

        /**
         * Ajax Textsearch
         */
        add_shortcode('WPCS_textsearch',[&$this,'_textsearch']);

        /**
         *
         */
        add_shortcode('WPCS_form',array(&$this,'_contact_form'));


        /**
         * SINGLE
         * funcktionieren nur wenn vehicle object vorhanden
         */
	    if(VehicleData::getVehicle() instanceof \WP_Post) {

		    add_shortcode('WPCS_single',array(&$this,'_single'));

		    add_shortcode('WPCS_title',array(&$this,'_single_title'));
		    add_shortcode('WPCS_images',array(&$this,'_single_images'));
            add_shortcode('WPCS_image',array(&$this,'_single_image'));
            add_shortcode('WPCS_video',array(&$this,'_single_video'));
		    add_shortcode('WPCS_buttons',array(&$this,'_single_buttons'));
		    add_shortcode('WPCS_button',array(&$this,'_single_button'));
		    add_shortcode('WPCS_contact',array(&$this,'_single_contact'));
		    add_shortcode('WPCS_data',array(&$this,'_single_specifics'));
		    add_shortcode('WPCS_features',array(&$this,'_single_features'));
		    add_shortcode('WPCS_content',array(&$this,'_single_content'));
		    add_shortcode('WPCS_emission',array(&$this,'_single_emission'));
            add_shortcode('WPCS_emission_data',array(&$this,'_single_emission_data'));
            add_shortcode('WPCS_eec_image',array(&$this,'_single_eec_image'));
		    add_shortcode('WPCS_price',array(&$this,'_single_price'));
            add_shortcode('WPCS_price_rating',array(&$this,'_single_price_rating'));
            add_shortcode('WPCS_financing',array(&$this,'_single_financing'));
            add_shortcode('WPCS_leasing',array(&$this,'_single_leasing'));
            add_shortcode('WPCS_highlights',array(&$this,'_single_highlights'));

            // ähnliche Fahrzeuge
            add_shortcode('WPCS_related',[&$this,'_related']);

        }

        /**
         * ARCHIVE
         */
        add_shortcode('WPCS_archive_link',array(&$this,'_archive_link'));
        add_shortcode('WPCS_archive_title',array(&$this,'_archive_title'));
        add_shortcode('WPCS_archive_image',array(&$this,'_archive_image'));
        add_shortcode('WPCS_archive_buttons',array(&$this,'_archive_buttons'));
        add_shortcode('WPCS_archive_data',array(&$this,'_archive_data'));
        add_shortcode('WPCS_archive_emission',array(&$this,'_archive_emission'));
        add_shortcode('WPCS_archive_eec_image',array(&$this,'_archive_eec_image'));
        add_shortcode('WPCS_archive_price',array(&$this,'_archive_price'));
        add_shortcode('WPCS_archive_price_rating',array(&$this,'_archive_price_rating'));
        add_shortcode('WPCS_archive_highlights',array(&$this,'_archive_highlights'));


	    /**
	     * ARCHIVE
	     */
	    // zeigt das gesamte Archiv-Template
	    add_shortcode('WPCS_archive',array(&$this,'_archive'));

        // Darstellung eines einzelnen Fitlers
        add_shortcode('WPCS_filter',array(&$this,'_filter'));

	    // Filterformular
	    add_shortcode('WPCS_filterform',array(&$this,'_filterform'));

        // Filterformular
        add_shortcode('WPCS_filtersection',array(&$this,'_filtersection'));

        // Filterformular Submit Button
        add_shortcode('WPCS_filterform_submit',array(&$this,'_filterform_submit'));

        // Filterformular Anzahl Ergebnisse während dem Filtervorgang
        add_shortcode('WPCS_filterform_search_count',array(&$this,'_filterform_search_count'));

        // Filterformular Anzahl Ergebnisse während dem Filtervorgang
        add_shortcode('WPCS_filterform_active_filters',array(&$this,'_filterform_active_filters'));

        // zeigt Lade-Icon während Ajax Suche
        add_shortcode('WPCS_filterform_loading',array(&$this,'_filterform_loading'));

        // zeige allgemein Ajax Loader
        add_shortcode('WPCS_loading',array(&$this,'_loading'));

	    // Pagination
	    add_shortcode('WPCS_pagination',array(&$this,'_pagination'));

	    add_shortcode('WPCS_archive_layout_buttons',array(&$this,'_archive_layout'));

        // Pagination Button
        add_shortcode('WPCS_load_more_button',array(&$this,'_load_more_button'));

        // Order Bar
	    add_shortcode('WPCS_orderbar',array(&$this,'_orderbar'));

        add_shortcode('WPCS_order',array(&$this,'_order'));

        add_shortcode('WPCS_orderby',array(&$this,'_orderby'));

	    // zeigt nur die Fahrzeugliste
	    add_shortcode('WPCS_vehicles',array(&$this,'_vehicles'));

	    // zeigt die Anzahl der insgesamt gefunden Fahrzeuge nach dem Filtern an
	    add_shortcode('WPCS_count',array(&$this,'_vehicle_count'));

        // setzt einen link zum archiv
        add_shortcode('WPCS_link_to_archive', [&$this, '_link_to_archive']);

        // Zeigt einen Infotext zum aktuellen Archiv, Basierend auf Marke und Modell an
        add_shortcode('WPCS_archive_description', [&$this, '_archive_description']);

    }


    /**
     * @param $args
     * @return false|string
     */
    public function _link_to_archive($args) {
        return HTML::linkToArchive($args);
    }


    /**
     * @param $args
     * @param $html
     */
    public function _if($args, $html) {

        $raw = false;
        if(isset($args['raw'])) {
            $raw = true;
            unset($args['raw']);
        }

        // prüfe nur, ob Key vorhanden
        if(isset($args[0])) {
            $value = dxim_get_vehicle_cf_value($args[0]);
            if(!empty($value)) return do_shortcode($html);
        }
        // vergleiche Wert
        elseif(is_array($args)) {
            $vehicle = dxim_get_vehicle();

            foreach($args as $key => $search) {
                $value = $raw ? $vehicle->dxim_meta[$key][0] : dxim_get_vehicle_cf_value($key);
                if($value == $search) return do_shortcode($html);
            }
        }

        return null;
    }


	/**
	 * @param $args
	 *
	 * @return int
	 */
    public function _get($args) {
		$key = $args[0];
		$value = dxim_get_vehicle_cf_value($key);
		$html = null;
		#wpcs_p(dxim_get_vehicle());

		if(is_array($value)) {
			$z = 0;
			foreach($value as $tmp) {
				if($z != 0) $html .= ', ';
				$html .= $tmp;
				$z++;
			}
		}
		else $html = $value;

	    return $html;
    }


    /**
     * @param $args
     * @return mixed|void
     */
    public function _cars($args) {

        if(!is_array($args)) $args = [];
        $args['load'] = true;

        $defaults = [
            'posts_per_page' => 12,
            'layout' => 'carousel'
        ];

        $args = array_merge($defaults, $args);
        $args['vehicle_list_type'] = "wpcs_cars";

        return $this->_show_vehicles($args);
    }

    /**
     * @param $args
     * @return mixed|void
     */
    public function _related($args) {
        if(!is_array($args)) $args = [];

        // vehicle muss vorhanden sein
        $vehicle = dxim_get_vehicle();
        if(empty($vehicle)) return null;
        #wpcs_p($vehicle);

        // related by auswerten, wenn nicht vorhanden auf default setzen
        if(isset($args['by'])) $filter = explode(";",$args['by']);
        else $filter = ['make','model'];

        $filters = VehicleFields::getFields();

        $args_cars = $args;                         // build wpcs_cars args
        $args_cars['exclude'] = $vehicle->ID;      // ignore current vehicle in related results
        unset($args_cars['by']);                    // unset unused params by wpcs_cars

        foreach($filter as $tmp) {
            if(!isset($filters[$tmp])) continue;
            $filter_key = $filters[$tmp]['meta_query']['key'];
            $value = $vehicle->$filter_key;
            if(isset($args[$tmp.'_diff'])) {
                $args_cars[$tmp.'_min'] = $value - $args[$tmp.'_diff'];
                $args_cars[$tmp.'_max'] = $value + $args[$tmp.'_diff'];
                unset($args_cars[$tmp.'_diff']);
            }
            else $args_cars[$tmp] = $value;
        }

        $html = $this->_cars($args_cars);
        return $html;
    }


    /**
     * @param array $args
     * @return mixed|void
     */
	public function _show_vehicles($args = []) {
        $options = Admin::getInstance()->getOptions();
        $layout = Session::val('archive_layout');
        if(empty($layout)) $layout = $options['archive_vehicle_layout'];

        $defaults = [
			'posts_per_page' => $options['posts_per_page'],
            'order' => $options['archive_default_order'],
            'orderby' => $options['archive_default_orderby'],
			'layout' => $layout,
            'exclude' => null,
            'include' => null,
		];

		if(!is_array($args)) $args = [];
		$args = array_merge($defaults,$args);

		// set fields to show
		if(isset($args['fields'])) { VehicleData::setFields(explode(";",$args['fields'])); }

        $carousel_args = [];
		$carousel_args['autoplay'] = isset($args['autoplay']) ? intval($args['autoplay']) : 0;
        $carousel_args['speed'] = isset($args['speed']) ? intval($args['speed']) : 5000;
        $carousel_args['slides'] = isset($args['per_slide']) ? intval($args['per_slide']) : null;
        $carousel_args['layout'] = $args['layout'] ?? null;

		// carousel Settings
		if($args['layout'] == 'carousel') {
			foreach($args as $key => $value) {
				if(substr($key,0,11) == 'breakpoint_') {
					#$carousel_args['breakpoints'][intval(str_replace("breakpoint_","",$key))] = intval($value);
					$carousel_args[$key] = $value;
				}
			}
			$args['carousel_args'] = $carousel_args;
		}

		// Slider Settings
		elseif($args['layout'] == 'slider') {
            $carousel_args['slides'] = 1;
            $args['carousel_args'] = $carousel_args;
        }

        //
        if(!empty($args['exclude'])) $args['exclude'] = explode(";",$args['exclude']);
        if(!empty($args['include'])) $args['include'] = explode(";",$args['include']);

        // eigene Fahrzeuge laden (WPCS_cars)
        if(isset($args['load'])) {
            $q = VehicleFilter::getInstance()->queryVehicles($args);
            $vehicles = $q['vehicles'];
            $args['count'] = $q['count'];
        }

        // globale Fahrzeuge anzeigen (WPCS_vehicles)
		else $vehicles = VehicleFilter::getVehicles();

		// Fahrzeugliste HTML erstellen
		if(!empty($vehicles)) {
            $html = Template::drawVehicleList($vehicles, $args);
        }
        else {
            $id = ($args['vehicle_list_type'] == "wpcs_vehicles") ? 'id="wpcs_vehicle_archive"' : null;
            $no_vehicles_found_html = WPCSString::getString('msg_no_vehicles_found');
            $html = '<h2 '.$id.' class="wpcs_vehicle_list wpcs_no_vehicles_found">'.apply_filters(DXIM_FILTER_ARCHIVE_VEHICLE_LIST_NO_RESULTS, $no_vehicles_found_html).'</h2>';
        }

		// reset fields to show
		if(isset($args['fields'])) { VehicleData::resetFields(); }

		// return
		return apply_filters(DXIM_FILTER_SHORTCODE_WPCS_CARS,$html,$vehicles,$args);
	}


	/**
	 * @param $args
	 *
	 * @return array
	 */
	private function _transform_args_to_vehicle_filters($args) {
		if(!is_array($args)) return [];

		$new_args = [];
		$filters = VehicleFilter::getFilters();

		foreach($args as $key => $value) {

			// kein WPCS Filter (z.b. post_per_page, oder, ...)
			if(isset($filters[$key])) {
				$new_args[$key] = $value;
			}
			elseif(substr($key,0,3) == 'cf_') {
			    $new_args[$key] = $value;
            }

		}

		return $new_args;
	}



    /** ----------------------------------------------------------------------------------------------------------------
     * Fahrzeug Vergleich
     * @return string
     */
    public function _vehicle_compare() {
        $options = Admin::getInstance()->getOptions();
        if(isset($options['compare_disabled'])) return null;
        return Compare::getInstance()->drawVehicleComparison();
    }

    /**
     * @return string
     */
    public function _compare_button($args) {
        return dxim_single_compare_button($args);
    }

    public function _count_vehicles_compared() {
        return Compare::getInstance()->drawCount();
    }



    /** ----------------------------------------------------------------------------------------------------------------
     * Fahrzeug Vergleich
     * @return string
     */
    public function _vehicles_parked() {
        return Park::getInstance()->drawVehiclesParked();
    }

    public function _count_vehicles_parked() {
        return Park::getInstance()->drawCount();
    }


	/** ----------------------------------------------------------------------------------------------------------------
	 * ARCHIVE
	 */

	/**
	 * @param array $defaults
	 *
	 * @return null|string
	 */
    public function _archive($args = []) {

	    // set fields to show
	    if(isset($args['fields'])) { VehicleData::setFields(explode(";",$args['fields'])); }

	    // render archive
        $html = Template::drawVehicleArchive();

	    // reset fields to show
	    if(isset($args['fields'])) { VehicleData::resetFields(); }

		return $html;
    }


    public function _archive_description($args) {
        return Template::drawArchiveDescription($args);
    }


	/**
	 * @param $defaults
	 *
	 * @return null
	 */
    public function _vehicles($args) {

        if(!is_array($args)) $args = [];
        // Änderung am 1.8.22
        // warum war das auskommentiert?
        #else unset($args['posts_per_page']);

        if(!isset($args['infinite'])) {
            $options = Admin::getInstance()->getOptions();
            $args['infinite'] = $options['archive_page_navigation'] == "infinite_scroll" ? 1 : 0;
        }

        $args['vehicle_list_type'] = "wpcs_vehicles";

        return $this->_show_vehicles($args);
    }


    /**
     * @return null|string
     */
    public function _filter($args) {
        return dxim_createFilterFormElement($args);
    }

	/**
	 * @return null|string
	 */
    public function _filterform($args) {
    	return dxim_vehicleFilterForm($args);
    }


    /**
     * @return null|string
     */
    public function _filtersection($args) {
        if(!is_array($args)) $args = [];
        $args['no_submit_button'] = 1;
        return dxim_vehicleFilterForm($args);
    }

    /**
     * @param $args
     * @return string
     */
    public function _filterform_submit($args) {
        return VehicleFilter::getInstance()->drawSubmitButton($args);
    }

    /**
     * @return string
     */
    public function _filterform_search_count() {
        return VehicleFilter::getInstance()->drawSearchCount();
    }

    /**
     * @return string
     */
    public function _filterform_active_filters() {
        return VehicleFilter::getInstance()->drawActiveFilters();
    }

    /**
     *
     */
    public function _filterform_loading() {
        return FilterForm::getInstance()->drawAjaxLoading();
    }

    /**
     *
     */
    public function _loading($args = []) {
        return FilterForm::getInstance()->drawAjaxLoading($args);
    }

	/**
	 * @return null|string
	 */
    public function _pagination() {
    	return dxim_pagination();
    }

    /**
     * @return null
     */
    public function _archive_layout() {
        return VehicleHtml::drawVehicleArchiveLayoutSelector();
    }


    /**
     * @return null|string
     */
    public function _load_more_button($args) {
        return Html::load_more_button($args);
    }

	/**
	 * @return null|string
	 */
    public function _orderbar($args) {
    	return dxim_vehicleOrderBar($args);
    }

    /**
     * @return null|string
     */
    public function _order($args) {
        return dxim_createOrder($args);
    }

    /**
     * @return null|string
     */
    public function _orderby($args) {
        return dxim_createOrderby($args);
    }

	/**
	 * @param $args
	 *
	 * @return string
	 */
    public function _vehicle_count($args) {
    	return dxim_vehicleCount($args);
    }

    public function _textsearch($args) {
        return TextSearch::getInstance()->draw_search($args);
    }

    /** ----------------------------------------------------------------------------------------------------------------
     * SINGLE
     */

	/**
	 * @return null
	 */
	public function _single($args) {
		global $post;

		$post = VehicleData::getVehicle();
		if(empty($post)) return null;

        // set fields to show
        if(isset($args['fields'])) { VehicleData::setFields(explode(";",$args['fields'])); }

        setup_postdata($post);
        $html = dxim_vehicleSingle();
        wp_reset_postdata();

        // reset fields to show
        if(isset($args['fields'])) { VehicleData::resetFields(); }



		return $html;
	}

	/**
	 * displays vehicle title HTML
	 * @return string
	 */
	public function _single_title() { return dxim_single_title(); }

	/**
	 * displays vehicle images HTML
	 * @return mixed|void
	 */
	public function _single_images($args) {
        if(!is_array($args)) $args = [];
        return dxim_single_images($args);
    }

    public function _single_image($args) {
        if(!is_array($args)) $args = [];
        return dxim_single_image($args);
    }

    public function _single_video($atts = []) {
	    return dxim_single_video($atts);
	}

	/**
	 * displays vehicle buttons HTML
	 * @return mixed|void
	 */
	public function _single_buttons($args) {
		if(!is_array($args)) $args = [];
		return dxim_single_buttons($args);
	}

	/**
	 * displays vehicle buttons HTML
	 * @return mixed|void
	 */
	public function _single_button($args) {
		if(!is_array($args)) $args = [];
		return dxim_single_button($args);
	}


	/**
	 * displays vehicle specifics HTML
	 * @return mixed|void
	 */
	public function _single_specifics($args) {
	    $fields = isset($args['fields']) ? explode(";",$args['fields']) : [];
	    return dxim_single_data($fields);
	}

	/**
	 * displays vehicle features HTML
	 * @return mixed|void
	 */
	public function _single_features($args) {
		if(!is_array($args)) $args = [];
		return dxim_single_features($args);
	}

	/**
	 * displays vehicle contact HTML
	 * @return mixed|void
	 */
	public function _single_contact() { return dxim_single_contact(); }

	/**
	 * displays vehicle form HTML
	 * @return mixed|void
	 */
	#public function _single_form() { return dxim_single_form(); }

    public function _contact_form($args) {
        return Form::getInstance()->contactForm($args);
    }

	/**
	 * displays vehicle Post Content HTML
	 * @return mixed|void
	 */
	public function _single_content() { return dxim_single_content(); }

	/**
	 * displays vehicle form HTML
	 * @return mixed|void
	 */
	public function _single_emission($args) {
		if(!is_array($args)) $args = [];
		return dxim_single_emission($args);
	}

    public function _single_emission_data($args) {
        if(!is_array($args)) $args = [];
        return dxim_single_emission_data($args);
    }

    public function _single_eec_image($args) {
        if(!is_array($args)) $args = [];
        return dxim_single_eec_image($args);
    }

	/**
	 * displays vehicle form HTML
	 * @return mixed|void
	 */
	public function _single_price() { return dxim_single_price(); }

    /**
     *
     */
	public function _single_financing() { return dxim_single_financing(); }
	public function _single_leasing() { return dxim_single_leasing(); }

    /**
     * @return string|null
     */
	public function _single_highlights() { return dxim_single_highlights(); }

    /**
     * @return mixed|void
     */
    public function _single_price_rating() { return dxim_single_price_rating(); }


	/** ----------------------------------------------------------------------------------------------------------------
     * ARCHIVE
     */
    public function _archive_link() { return dxim_archive_link(); }

	public function _archive_title() { return dxim_archive_title(); }

    public function _archive_image($args) {
        if(!is_array($args)) $args = [];
        return dxim_archive_image($args);
    }

    public function _archive_data() { return dxim_archive_data(); }

    public function _archive_emission($args = []) { return dxim_archive_emission($args); }

    public function _archive_eec_image() { return dxim_archive_eec_image(); }

    public function _archive_price () { return dxim_archive_price(); }

    public function _archive_price_rating () { return dxim_archive_price_rating(); }

    public function _archive_highlights() { return dxim_archive_highlights(); }

    public function _archive_buttons() { return dxim_archive_buttons(); }


    /**
     * VehicleSearchRequest
     */
    public function _wpcs_vsr_save() {
        return VehicleSearchRequest::getInstance()->_draw_save_request();
    }

    public function _wpcs_vsr_load_list() {
        $hash = $_GET['t'] ?? null;
        return VehicleSearchRequest::getInstance()->_draw_search_list($hash);
    }
}