<?php

namespace DXIM;

class TextSearch {


    protected static $instance = null;


    /**
     *
     * @return TextSearch
     */
    public static function getInstance() {
        if(self::$instance === null) {
            self::$instance = new self;
        }
        return self::$instance;
    }

    /**
     * Compare constructor.
     */
    public function __construct() {
        add_action('wp_ajax_wpcs_textsearch', array($this,'_ajax'));
        add_action('wp_ajax_nopriv_wpcs_textsearch', array($this,'_ajax'));
    }

    /**
     *
     */
    public function _ajax() {
        $string = $_POST['searchstring'];
        $args = $_POST['args'];

        $response = [];

        $vehicles = $this->search($string);
        $count = count($vehicles);

        if($count < 1) {
            $response['status'] = 0;
        }
        else {
            $html = $this->drawResultList($vehicles, $args);

            $response['status'] = 1;
            $response['html'] = $html;
        }


        // return JSON
        header('Content-Type: application/json');
        die(json_encode($response));

    }

    public function search($string) {
        $query = new \WP_Query( array( 's' => $string, 'posts_per_page' => -1, 'post_type' => 'vehicle' ) );
        $vehicles = $query->posts;
        return $vehicles;
    }


    public function drawResultList($vehicles, $args = []) {
        if(!is_array($args)) $args = [];
        $defaults = ['layout' => 'textsearch'];
        $args = array_merge($defaults, $args);
        $max_vehicles = 10;

        $html = '<div class="vehicles_wrapper">';
        $z = 0;
        foreach($vehicles as $vehicle) {
            if($z >= $max_vehicles) break;
            $vehicle = VehicleData::initDataObject($vehicle);
            $html .= CustomTemplate::getInstance()->get_template_content('loop/textsearch', ['vehicle' => $vehicle]);
            $z++;
        }

        $html .= '</div>';

        $html .= '<div class="search_info">'.$z.' von '.count($vehicles).' gefundenen Fahrzeugen</div>';

        return $html;
    }


    /**
     * @return string
     */
    public function draw_search($args) {
        if(!is_array($args)) $args = [];
        $defaults = ['placeholder' => "Suche Fahrzeug"];
        $args = array_merge($defaults, $args);
        $args['type'] = "wpcs_textsearch";
        $args['layout'] = "list";

        return Html::textsearch($args);
    }

}