<?php

/**
 * Created by PhpStorm.
 * User: dxPro
 * Date: 07/01/16
 * Time: 17:21
 */

namespace DXIM;


use DXIM\theme\Brand;
use DXIM\theme\Division;
use DXIM\theme\DivisionData;
use DXIM\theme\Location;
use DXIM\theme\LocationData;
use DXIM\theme\Offer;
use DXIM\theme\OfferGroup;
use DXIM\theme\Person;
use DXIM\theme\Tag;

class Admin {

    public static $pageSlug = 'wpcarsync';
    protected static $instance = null;
    protected static $optionKey = 'dxim_options';

    protected $notices = array('error' => array(), 'updated' => array());
    protected $options = null;
    public $error_on_save = null;

    protected $msg_feedback = [];
    protected $msg_warning = [];
    protected $msg_notice = [];

    protected $modules = [];

    /**
     *
     * @return Admin
     */
    public static function getInstance() {
        if (self::$instance === null) {
            self::$instance = new self;
        }
        return self::$instance;
    }

    public function set_feedback($headline, $content = "") {
        $this->msg_feedback[] = "<h2>".$headline."</h2>".$content;
    }

    public function set_warning($headline, $content = "") {
        $this->msg_warning[] = "<h2>".$headline."</h2>".$content;
    }

    public function set_notice($headline, $content = "") {
        $this->msg_notice[] = "<h2>".$headline."</h2>".$content;
    }

    public function get_modules() { return apply_filters('wpcs_admin_modules',$this->modules); }


    /**
     *
     */
    public function __construct() {

        $options = $this->getOptions();

        $debug = isset($options['debug']) ? intval($options['debug']) : 0;
        if (!defined('WPCS_Debug')) define('WPCS_Debug', $debug);

        $l = $this->gl();
        if (!defined('WPCS_PRO')) define('WPCS_PRO', $l->pro);
        if (!defined('WPCS_DEMO')) define('WPCS_DEMO', $l->name == "Demo Version");

        if (isset($_GET['wpcsld'])) {
            if ($_GET['wpcsld'] == $options['wpcs_key']) {
                wpcs_p(get_option('wpcs_last_lc_params'));
                wpcs_p(get_option('wpcs_last_lc_result'));
                wp_die();
            }
        }

        Select2Data::getInstance();

        $this->modules = [
            'division' => [
                'type' => 'taxonomy', 'label' => 'Abteilungen', 'taxonomy' => \DXIM\theme\Division::$taxonomy, 'pro' => 1, 'has_settings' => 0,
                'description' => 'Abteilungen Ihrer Standorte verwalten, Mitarbeiter Abteilungen zuweisen', 'icon' => 'dashicons-admin-home'
            ],
            'offer' => [
                'type' => 'post_type', 'label' => 'Angebote', 'post_type' => \DXIM\theme\Offer::$post_type, 'pro' => 1, 'has_settings' => 1,
                'description' => 'Neuwagenangebote anlegen und präsentieren', 'icon' => 'dashicons-money-alt'
            ],
            'offergroup' => [
                'type' => 'taxonomy', 'label' => 'Aktionen', 'taxonomy' => \DXIM\theme\OfferGroup::$taxonomy, 'pro' => 1, 'has_settings' => 1,
                'description' => 'Eine Aktion umfasst immer mehrere Angebote gebündelt', 'icon' => 'dashicons-money-alt'
            ],
            'vehicle' => [
                'type' => 'post_type', 'label' => 'Fahrzeuge', 'post_type' => 'vehicle', 'pro' => 0, 'has_settings' => 0,
                'description' => 'Die importieren Fahrzeug - Daten', 'icon' => 'dashicons-car'
            ],
            'footnote' => [
                'type' => 'post_type', 'label' => 'Fußnoten', 'post_type' => Footnote::$post_type, 'pro' => 1, 'has_settings' => 0,
                'description' => 'Fußnoten zu Angeboten zentral erfassen und wieder verwenden', 'icon' => 'dashicons-editor-paragraph'
            ],
            'lead' => [
                'type' => 'post_type', 'label' => 'Leads', 'post_type' => Lead::$post_type, 'pro' => 1, 'has_settings' => 0,
                'description' => 'Alle Anfragen von Kontaktformularen, Suchanfragen, Reservierungen, etc an einem Ort',  'icon' => 'dashicons-filter'
            ],
            'brand' => [
                'type' => 'taxonomy', 'label' => 'Marken', 'taxonomy' => \DXIM\theme\Brand::$taxonomy, 'pro' => 1, 'has_settings' => 1,
                'description' => 'Verwaltung und Präsentation Ihrer Vertragsmarken und Servicemarken', 'icon' => 'dashicons-car'
            ],
            'model' => [
                'type' => 'post_type', 'label' => 'Modelle', 'post_type' => \DXIM\theme\Model::$post_type, 'pro' => 1, 'has_settings' => 1,
                'description' => 'Modellübersicht aller Modelle Ihrer Marken', 'icon' => 'dashicons-car'
            ],
            'tag' => [
                'type' => 'taxonomy', 'label' => 'Schlagwörter', 'taxonomy' => \DXIM\theme\Tag::$taxonomy, 'pro' => 1, 'has_settings' => 0,
                'description' => 'Versehen Sie Angebote, Stellen, etc. mit Schlagworten und nutzen Sie diese als Filter',  'icon' => 'dashicons-flag'
            ],
            'service' => [
                'type' => 'post_type', 'label' => 'Serviceleistungen', 'post_type' => \DXIM\theme\Service::$post_type, 'pro' => 1, 'has_settings' => 1,
                'description' => 'Standortspezifische Präsentation ihrer Serviceleistungen und Anfrage',  'icon' => 'dashicons-admin-generic'
            ],
            'location' => [
                'type' => 'taxonomy', 'label' => 'Standorte', 'taxonomy' => \DXIM\theme\Location::$taxonomy, 'pro' => 0, 'has_settings' => 1,
                'description' => 'Verwaltung aller Standorte, inkl. Zentrale und einzelner Niederlassungen', 'icon' => 'dashicons-networking'
            ],
            'job' => [
                'type' => 'post_type', 'label' => 'Stellenangebote', 'post_type' => \DXIM\theme\Job::$post_type, 'pro' => 1, 'has_settings' => 0,
                'description' => 'Standortspezifische Stellenangebote verwalten', 'icon' => 'dashicons-businesswoman'

            ],
            'search_request' => [
                'type' => 'post_type', 'label' => 'Suchaufträge', 'post_type' => 'wpcs_search_request', 'pro' => 0, 'has_settings' => 0,
                'description' => 'Suchanfragen durch Benutzer der Fahrzeugbörse einsehen', 'icon' => 'dashicons-search'
            ],
            'team' => [
                'type' => 'post_type', 'label' => 'Team', 'post_type' => \DXIM\theme\Person::$post_type, 'pro' => 1, 'has_settings' => 0,
                'description' => 'Verwaltung Ihres Teams an allen Standorten, Zuordnung einzelner spezifischer Ansprechpartner für Service, Verkauf, etc.',
                'icon' => 'dashicons-groups'
            ],
        ];

        add_action('admin_init', array(&$this, 'handleRequest'));

        add_action('admin_notices', array(&$this, '_admin_notices'));
        add_action('admin_enqueue_scripts', function ($hook) {
            #print "+++".$hook;

            if ($hook == 'toplevel_page_wpcarsync' || $hook == 'admin_page_wpcs_checkout_settings' || $hook == 'post.php' || $hook == 'post-new.php' || $hook == "edit.php") {
                wp_enqueue_script('wpcsselect', DXIM_PluginUrl . '/js/wpcsselect.js', array('jquery'), DXIM_PluginVersion);
                wp_enqueue_script('wpcarsync-admin', DXIM_PluginUrl . '/js/wpcarsync_admin.js', array('jquery-ui-sortable', 'jquery-ui-draggable', 'wpcsselect'), DXIM_PluginVersion);
                wp_enqueue_script('wpcs-theme', DXIM_PluginUrl . '/js/wpcs_theme.js', array('jquery'), DXIM_PluginVersion, true);
                wp_enqueue_script('wpcarsync-admin-theme', DXIM_PluginUrl . '/js/wpcs_admin_theme.js', array('jquery'), DXIM_PluginVersion);

                wp_enqueue_style('wpcarsync-admin', DXIM_PluginUrl . '/css/wpcarsync_admin.css', null, DXIM_PluginVersion);
                //wp_enqueue_style('wpcarsync-meta-box', DXIM_PluginUrl . '/css/wpcarsync_metabox.css', null, DXIM_PluginVersion);
            } elseif ($hook == "edit-tags.php" || $hook == "term.php" || $hook == "profile.php" || $hook == "user-edit.php") {
                wp_enqueue_style('wpcarsync-admin', DXIM_PluginUrl . '/css/wpcarsync_admin.css', null, DXIM_PluginVersion);
                wp_enqueue_script('wpcarsync-admin-theme', DXIM_PluginUrl . '/js/wpcs_admin_theme.js', array('jquery'), DXIM_PluginVersion);
                wp_enqueue_script('wpcs-theme', DXIM_PluginUrl . '/js/wpcs_theme.js', array('wpcs'), DXIM_PluginVersion, true);
            }
        });

        // Check License
        if (!$this->_plugin()) {
            $this->set_warning("Lizenz ungültig","Bitte prüfen Sie Ihre Lizenz.");
        }

        // Update abschließen
        $instructions_read = get_option('wpcs_instructions_read');
        if (version_compare($instructions_read, DXIM_PluginVersion, '<')) {
            $update_info = "";
            try {
                $update_info = file_get_contents(DXIM_PluginWebAddress . '/wpcsupdate2/updateinfo.txt');
            } catch (Exception $e) {
            }
            $this->set_notice("Update abgeschlossen!", $update_info );
        }

        /**
         * WPCS Admin Menu
         */
        add_action('admin_menu', function () {
            add_menu_page(DXIM_PluginName, DXIM_PluginName, 'manage_options', self::$pageSlug, array(&$this, '_newAdminPage'), DXIM_PluginUrl . '/img/wpcs_admin_menu_icon.png', 30);

            $quickaccess = $this->getOptions('quickaccess');
            foreach($this->get_modules() as $module_slug => $module) {
                if(!isset($quickaccess[$module_slug])) continue;

                if($module['type'] == "taxonomy") {
                    $link = 'edit-tags.php?taxonomy='.$module['taxonomy'];
                }
                else {
                    $link = "edit.php?post_type=".$module['post_type'];
                }
                add_submenu_page(self::$pageSlug, $module['label'], $module['label'], 'manage_options', $link);
            }
        }, 9);

        /**
         * set WPCS Admin Menu as parent for custom taxonomies
         */
        add_filter('parent_file', function ($parent_file) {
            $current = get_current_screen();
            $wpcs_screens = [];
            foreach($this->get_modules() as $module) {
                $screen_name = $module['type'] == "taxonomy" ? "edit-".$module['taxonomy'] : $module['post_type'];
                $wpcs_screens[] = $screen_name;
            }

            if (in_array($current->id, $wpcs_screens)) return 'wpcarsync';
            return $parent_file;
        });


        add_action('manage_vehicle_posts_custom_column', [&$this, '_vehicle_columns_content'], 10, 2);
        add_filter('manage_vehicle_posts_columns', [&$this, '_vehicle_columns']);

        // ajax url
        add_action('admin_head', function () {
            // Custom JS Ausgabe
            print "<script>";
            print "var wpcs_ajax_url = '" . admin_url('admin-ajax.php') . "';";
            print "</script>";

            // custom css
            print '<style>';

            print '
            .wpcs_notice { background:white; padding:20px; border-left:5px solid green; }
			#adminmenu #toplevel_page_wpcarsync img { width:20px; opacity:1;}
			#adminmenu #toplevel_page_wpcarsync span.pro { margin-left:5px; background:#FE0E6F; color:white; padding:2px; border-radius:5px; font-size:70%; }
			.wpcs_notice.error { border-left-color:red; }
		    .wpcs_notice.warning { border-left-color:orange; }
		    ';
            print '</style>';
        });

        $this->_cl();
    }

    /**
     * @param $data
     */
    public function saveOptions($data, $checkLicence = false) {

        // filter vor dem speichern (dient zumn Vergleich ob sich Felder verändert haben)
        $old_filters = $this->getOptions('active_filters') ?? [];
        if (!is_array($old_filters)) $old_filters = [];

        // filter die gespeichert werden sollen
        $data['active_filters'] = $data['active_filters'] ?? [];
        // wenn min oder max Feld verwendet, muss das originale Feld ebenfalls verwendet werden
        foreach ($data['active_filters'] as $key) {
            $ending = substr($key, -4);
            if ($ending == "_min" || $ending == "_max") $data['active_filters'][] = str_replace(['_min', '_max'], "", $key);
        }
        // doppelte Felder entfernen
        $data['active_filters'] = array_unique($data['active_filters']);


        // save mobile.de account
        if (!empty($data['new_user']) && !empty($data['new_user_pass'])) {

            $data['accounts'][$data['new_user']]['user'] = trim($data['new_user']);
            $data['accounts'][$data['new_user']]['password'] = trim($data['new_user_pass']);
            $data['accounts'][$data['new_user']]['location'] = trim($data['new_user_location']);
            $data['accounts'][$data['new_user']]['type'] = 'mobile.de';

            unset($data['new_user']);
            unset($data['new_user_pass']);
            unset($data['new_user_location']);
        }

        // save csv extended account
        if (!empty($data['new_csv_path'])) {
            $user = trim($data['new_csv_user']);
            $data['accounts'][$user]['user'] = $user;
            $data['accounts'][$user]['path_csv'] = trim($data['new_csv_path']);
            $data['accounts'][$user]['path_config'] = trim($data['new_csv_config_path']);
            $data['accounts'][$user]['zip_name'] = trim($data['new_csv_zip_name']);
            $data['accounts'][$user]['name'] = trim($data['new_csv_name']);
            $data['accounts'][$user]['type'] = 'csv';

            unset($data['new_csv_name'], $data['new_csv_path'], $data['new_csv_config_path'], $data['new_csv_user'], $data['new_csv_zip_name']);
        }

        // save car cloud account
        if (!empty($data['carcloud']['api_key'])) {
            $data['accounts']['carcloud']['user'] = "carcloud";
            $data['accounts']['carcloud']['name'] = "Car Cloud";
            $data['accounts']['carcloud']['type'] = "carcloud";
        }

        // save new carshotspro account
        if (!empty($data['carshotspro']['new_app_token'])) {
            if (CarShotsPROApi::getInstance()->connect($data['carshotspro']['new_app_token'])) {
                unset($data['carshotspro']['new_app_token']);
            } else {
                $this->error_on_save['csp_new_app_token'] = CarShotsPROApi::getInstance()->getError();
            }
        }

        // carshotspro settings
        // leere winkel nicht speichern
        if (isset($data['carshotspro']['mapping']) && is_array($data['carshotspro']['mapping'])) {
            foreach ($data['carshotspro']['mapping'] as $account_id => $array) {
                foreach ($array['angle'] as $slug => $nr) {
                    $nr = intval($nr);
                    if (empty($nr)) unset($data['carshotspro']['mapping'][$account_id]['angle'][$slug]);
                }
            }
        }

        update_option(self::$optionKey, $data);

        // sicherstellen das options neu gealden werden
        $this->options = [];
        $this->getOptions();

        CustomTemplate::getInstance()->convert_old_templates();

        // Filter Tabelle neu bauen?
        $new_filters = $data['active_filters'];
        $diff1 = array_diff($new_filters, $old_filters);
        $diff2 = array_diff($old_filters, $new_filters);
        if (!empty($diff1) || !empty($diff2)) {
            $f = Filter::getInstance();
            $f->setFilters();
            FilterTable::getInstance()->resetFilterTable();
            $f->deleteMissingFilters();
        }

        // lizenz neu auswerten
        if ($checkLicence) {
            $this->_cl(1);
        }

        do_action(DXIM_OPTIONS_SAVED);
    }

    /**
     * @return mixed|void
     */
    public function getOptions($key = null) {
        if (empty($this->options)) $this->options = get_option(self::$optionKey);
        if (!is_array($this->options)) $this->options = [];

        if ($key == null) return $this->options;
        else return $this->options[$key] ?? '';
    }


    /**
     *
     */
    public function _clear_options() {
        delete_option(self::$optionKey);
        delete_option('wpcs_license_info');
        delete_option('wpcs_lc');
        delete_option('wpcs_templates');
        delete_option('wpcs_instructions_read');
        delete_option('wpcs_import_active');
        delete_option('wpcs_last_lc_params');
        delete_option('wpcs_last_lc_result');
        delete_option('wpcs_last_import_log');
        delete_option('wpcs_filter_cache');
        delete_option('wpcs_import_queue');
        delete_option('wpcs_checkout_options');
        delete_option('wpcs_import_status');
        delete_option('wpcs_csp_api_info');

        $this->options = null;
    }



    /**
     * @param $old_options
     * @param $new_options
     *
     * @return mixed
     */
    private function _compare_options_after_update($old_options, $new_options) {

        if (!isset($new_options['accounts']) && isset($old_options['user'])) {
            $z = 0;
            foreach ($old_options['user'] as $username) {
                $new_options['accounts'][$username]['user'] = $username;
                $new_options['accounts'][$username]['password'] = $old_options['password'][$z];
                $new_options['accounts'][$username]['location'] = 0;
                $new_options['accounts'][$username]['type'] = 'mobile.de';
                $z++;
            }
        }

        return $new_options;
    }

    /** ------------------------------
     *
     */
    public function handleRequest() {
        if (!isset($_REQUEST['key'])) $_REQUEST['key'] = null;
        if (!isset($_REQUEST['page'])) $_REQUEST['page'] = null;
        if (!$_REQUEST['key'] == self::$pageSlug && !$_REQUEST['page'] == self::$pageSlug) return false;

        // save options
        if (isset($_POST['dxim_admin_save'])) {
            // merge old version
            $options = $this->getOptions();
            if (isset($options['options_version']) && version_compare($options['options_version'], DXIM_PluginVersion, '<')) {
                $_POST['dxim'] = $this->_compare_options_after_update($options, $_POST['dxim']);
            }

            // save options
            $checkLicense = intval($_POST['check_license']) > 0 ? true : false;
            $this->saveOptions($_POST['dxim'], $checkLicense);
            if ($checkLicense) print '<script>window.location.href="' . $this->_getAdminPage() . '&section_slug='.$_POST['section_slug'].'&slug='.$_POST['slug'].'";</script>';

            //
            $this->_set_instructions();

            $this->set_feedback("Einstellungen gespeichert!");
        }

        // Import Settings string
        if (isset($_POST['import_settings_start'])) {
            $array = json_decode(stripslashes($_POST['import_settings_string']), true);
            if (!empty($array)) {
                // save main options
                Admin::getInstance()->saveOptions($array['main_options']);

                // save all other
                foreach ($array as $key => $data) {
                    if ($key == "main_options") continue;
                    update_option($key, $data);
                }
                $this->set_feedback("Die Einstellungen wurden importiert");
            } else $this->set_warning("Import-String konnte nicht gelesen werden");
        }

        // mobile.de Account löschen
        if (isset($_GET['deleteAccount'])) {
            $this->deleteAccount($_GET['deleteAccount']);
        }

        // delete connected CarShotsPRO Account
        if (isset($_GET['deleteCspAccount'])) {
            CarShotsPROApi::getInstance()->deleteApiInfo($_GET['deleteCspAccount']);
        }

        // resettet alle import hashes, so dass beim nächsten Sync alle Fahrzeuge geupdated werden (nur CSV)
        if (isset($_GET['wpcs_admin_reset_import_hashes'])) {
            $v = new Vehicle();
            $v->_reset_import_hashes();
            $this->set_feedback("Hashes wurden zurüchgesetzt!", "Beim nächsten Import werden alle Fahrzeuge upgedatet.");
        }

        // bereinige dateisystem nicht mehr benötigtwe Fahrzeugbilder
        if (isset($_GET['wpcs_admin_cleanup_filesystem'])) {
            $files = Cleaner::getInstance()->cleanup_vehicle_dir();
            if (!empty($files)) {
                $string = "";
                foreach ($files as $file) {
                    $string .= $file . "<br />";
                }
                $this->set_feedback("Gelöschte Dateien", $string);
            } else {
                $this->set_feedback("Keine Dateien zum Bereinigen gefunden");
            }
        }

        // einstellungen reset
        if (isset($_GET['reset']) && $_GET['reset'] == "1") {
            $this->_reset_plugin();
        }
    }

    /**
     *
     */
    private function _set_instructions() {
        update_option('wpcs_instructions_read', DXIM_PluginVersion);
    }

    /**
     * @return string
     */
    public function _getAdminPage() {
        return admin_url('admin.php?page=' . self::$pageSlug);
    }


    /**
     *
     */
    private function _reset_plugin() {
        $this->_kill_domain();
        $this->_clear_options();
    }


    /**
     * @param $fields
     *
     * @return array|mixed|object
     */
    private function _api($method) {
        $opt = $this->getOptions();
        $key = $opt['wpcs_key'] ?? '';
        $order_id = $opt['wpcs_order_id'] ?? '';
        $fa = get_option('wpcs_fa');

        $d = home_url();
        $d = str_replace(["https://", "http://", "www."], "", $d);
        if (empty($d)) return false;

        $fields = [
            'd' => $d,
            'license' => $key,
            'k' => $key,
            'order_id' => $order_id,
            'method' => $method,
            'plugin_version' => DXIM_PluginVersion,
            'fa' => $fa,
            'cv' => VehicleFilter::getCount(),
            'csr' => VehicleSearchRequest::getInstance()->count(),
            'pro' => WPCS_PRO
        ];

        update_option('wpcs_last_lc_params', $fields);

        $server = "https://wpcsverify.wordpresstools.de";
        #$server = "http://wpcsverify";
        $res = wp_remote_post($server, [
            'body' => $fields
        ]);

        if (is_wp_error($res)) {
            wp_die($res->get_error_message());
            exit;
        }

        update_option('wpcs_last_lc_result', $res);

        return json_decode($res['body']);
    }


    /**
     *
     */
    private function _kill_domain() {
        $res = $this->_api('kill_domain');
    }

    /**
     * @return bool
     */
    private function _is_license_data_up_to_date() {
        $l = $this->gl();
        if (version_compare($l->plugin_version, DXIM_PluginVersion) == 0) return true;
        else false;
    }


    /**
     * @return bool
     */
    private function _cl($forceRefresh = false) {
        $error = false;

        $fa = get_option('wpcs_fa');
        if ($fa == null) {
            $fa = time();
            update_option('wpcs_fa', $fa);
        }

        $now = time();
        $lc = get_option('wpcs_lc');
        $ci = 86400;
        $nc = $lc + $ci;

        //        print "now: ".date('d.m.Y H:i:s',$now)."\n";
        //        print "last: ".date('d.m.Y H:i:s',$lc)."\n";
        //        print "next: ".date('d.m.Y H:i:s',$nc)."\n";

        // kein check notwendig, wenn...
        if (
            $nc > $now && // nächster check noch nicht notwendig
            !empty($this->gl()) && // lizenzdaten liegen vor
            //$this->_is_license_data_up_to_date() && // gespeicherte lizenzdaten nicht älter als plugin version
            !$forceRefresh
        ) {
            return true;
        }

        // update time
        update_option('wpcs_lc', time());

        // check
        $res = $this->_api('validateLicense');

        // error occured
        if (!is_object($res)) {
            $error = true;
        }

        //delete_option('wpcs_license_info');

        if (!$error) {
            update_option('wpcs_license_info', $res);
        }
    }

    /**
     * @return mixed|void
     */
    public function gl() {
        #wpcs_p(get_option('wpcs_license_info'));
        $l = get_option('wpcs_license_info');
        if (empty($l)) $l = new \stdClass();

        $l->name = $l->name ?? null;
        $l->expires = $l->expires ?? null;
        $l->license_version = $l->license_version ?? null;
        $l->license = $l->license ?? null;
        $l->license_msg = $l->license_msg ?? null;
        $l->plugin = $l->plugin ?? null;
        $l->pro = $l->pro ?? 0;

        return $l;
    }

    public function _plugin() {
        $l = $this->gl();
        return $l->plugin;
    }

    public function _license() {
        $l = $this->gl();
        return $l->license;
    }

    public function _updates() {
        $l = $this->gl();
        if (!isset($l->updates_until)) return true;
        return ($l->updates_until < time()) ? false : true;
    }


    /**
     * @return void
     */
    public function _newAdminPage() {

        $options = $this->getOptions();
        if (!isset($options['options_version'])) $options['options_version'] = 0;

        $menu = [
            'modules' => [
                'label' => 'Module', 'icon' => 'dashicons-screenoptions',
                'settings_page' => "modules", 'has_submenu' => false,
                'items' => $this->modules
            ],
            'settings' => [
                'label' => 'Einstellungen', 'icon' => 'dashicons-admin-settings', 'has_submenu' => true,
                'items' => [
                    'general' => ['label' => 'Allgemein'],
                    'vehicle_archive' => ['label' => 'Fahrzeug-Archivansicht'],
                    'vehicle_single' => ['label' => 'Fahrzeug-Einzelansicht'],
                    'searchrequests' => ['label' => 'Suchaufträge'],
                    'filterform' => ['label' => 'Filterformular'],
                    'vehicle_compare' => ['label' => 'Vergleich & Parken'],
                    'contactform' => ['label' => 'Kontaktformular'],
                    'labels' => ['label' => 'Beschriftungen & Texte'],
                ]
            ],
            'accounts' => [
                'label' => 'Accounts', 'icon' => 'dashicons-admin-users', 'has_submenu' => true,
                'items' => [
                    'wpcs' => ['label' => 'WPCarSync Lizenz'],
                    'mobile' => ['label' => 'Mobile.de Import'],
                    'csv' => ['label' => 'CSV Import'],
                    'carshotspro' => ['label' => 'CarShotsPRO'],
                    // Achtung! Bei CarCloud Anzahl Fahrzeuge 0 wurde keine Bereinigung ausgeführt
                    #'carcloud' => ['label' => 'Car-Cloud.de'],
                    'paypal' => ['label' => 'Paypal IPN'],
                ]
            ],
            'admin' => [
                'label' => 'Admin', 'icon' => 'dashicons-admin-generic', 'has_submenu' => false,
                'settings_page' => "admin",
                'items' => []
            ],
            'addon' => [
                'label' => 'AddOns', 'icon' => 'dashicons-admin-plugins', 'has_submenu' => true,
                'items' => [
                ]
            ],
        ];

        $menu = apply_filters('wpcs_settings_menu',$menu);

        $current_section_slug = $_REQUEST['section_slug'] ?? "settings";
        $current_slug = $_REQUEST['slug'] ?? "general";

        /**
         * ab hier Standard Settings Page
         */
        print '<form method="post" id="wpcarsync_admin_form" action="' . $this->_getAdminPage() . '">';
        print '<div class="wrap dxim_admin_wrapper">';

            // sidebar
            print '<div id="wpcs_admin_sidebar">';

                // Logo
                print '<img id="logo" src="' . DXIM_PluginLogo . '" />';

                print '<div id="wpcs_menu_wrapper">';

                    /**
                     * externe settings page
                     */
                    if(isset($_REQUEST['wpcs_settings_page'])) {
                        $this->_settings_page_menu($_REQUEST['wpcs_settings_page']);
                    }

                    /**
                     * Default Menu
                     */
                    else {
                        print '<ul id="wpcs_admin_menu">';

                        foreach($menu as $section_slug => $section) {
                            $content_section = count($section['items']) == 1 || isset($section['settings_page']) ? "content_section" : "menu_anchor";
                            $active = $current_section_slug == $section_slug ? "active" : "";
                            print '<li data-section="'.$section_slug.'" data-url="" class="is_section '.$content_section.' '.$active.'">';
                            print '<span class="dashicons '.$section['icon'].'"></span>';
                            print '<span class="title">'.$section['label'].'</span>';

                            if(count($section['items']) > 0 && $section['has_submenu']) {
                                print '<ul>';
                                foreach($section['items'] as $slug => $item) {
                                    $active = $current_slug == $slug ? "active" : "";
                                    $url = $item['url'] ?? '';
                                    print '<li class="content_section is_item '.$active.'" data-url="'.$url.'" data-section="'.$section_slug.'" data-slug="'.$slug.'">';
                                        print '<span class="title">'.$item['label'].'</span>';
                                    print '</li>';
                                    }
                                print '</ul>';
                            }

                            print '</li>';
                        }

                        print '</ul>';

                        print '<a href="#" class="button button-primary" id="wpcarsync_form_submit">Einstellungen speichern</a> ';

                        print '<input type="hidden" name="dxim_admin_save" value="1" />';
                        print '<input type="hidden" name="check_license" id="wpcs_check_license_field" value="0" />';
                        print '<input type="hidden" name="check_csp_api" id="wpcs_check_csp_api" value="0" />';
                        print '<input type="hidden" name="key" value="' . self::$pageSlug . '" />';
                        print '<input type="hidden" name="dxim[lastSyncTime]" value="' . @$options['lastSyncTime'] . '" />';
                        print '<input type="hidden" name="dxim[options_version]" value="' . DXIM_PluginVersion . '" />';
                        print '<input type="hidden" name="section_slug" value="' . $current_section_slug . '" />';
                        print '<input type="hidden" name="slug" value="' . $current_slug . '" />';

                    }
                print '</div>'; // menu wrapper

            print '</div>'; // sidebar

            // content
            print '<div id="wpcs_admin_content">';

            /**
             * Header
             */
                print '<div id="wpcs_admin_header">';

                    print '<div id="wpcs_admin_header_status">';

                        // Anzeige aktiver Import
                        $lastSyncTime = $options['lastSyncTime'] ?? "";
                        $sync_active = Sync::getInstance()->isSyncActive();
                        $display_sync_active = $sync_active ? 'block' : 'none';
                        $display_sync_inactive = $sync_active ? 'none' : 'block';
                        $sync_status = Sync::getInstance()->getSyncStatus();

                        print '<div id="wpcs_last_sync_status" style="display:'.$display_sync_inactive.';">';
                            $last_sync_value = !empty($lastSyncTime) ? date('d.m.Y H:i',$lastSyncTime ) : "nie";
                            print 'letzte Synchronisierung: <strong class="value">'.$last_sync_value.'</strong>';
                        print '</div>';

                        print '<div id="wpcs_sync_status" style="display:' . $display_sync_active . ';">';
                            print '<span class="dashicons dashicons-update wpcs_import_active_icon"></span> <span class="wpcs_import_active_text">' . $sync_status['vehicles_left'] . '</span>';
                            print 'Account: <span class="wpcs_import_active_account_text">' . $sync_status['account'] . '</span>';
                            print '<a class="cancel_import_btn" href="' . $this->_getAdminPage() . '&wpcs_cancel_import=1&section_slug='.$current_section_slug.'&slug='.$current_slug.'">Import abbrechen</a>';
                        print '</div>';

                    print '</div>'; // header links

                    print '<div id="wpcs_admin_header_links">';
                        // Version
                        print '<strong>Version ' . DXIM_PluginVersion . '</strong>';
                        // Link
                        print '<a href="' . DXIM_PluginWebAddress . '" target="_blank">' . DXIM_PluginWebsiteName . '</a>';
                        // Doku
                        print '<a href="' . DXIM_PluginDocumentation . '"  target="_blank">Dokumentation</a>';
                    print '</div>'; // header links

            print '</div>'; // admin_header


                /**
                 * Feedback
                 */
                if(!empty($this->msg_feedback)) {
                    print '<div class="wpcs_admin_feedback feedback">';
                        foreach($this->msg_feedback as $string) { print $string; }
                    print "</div>";
                }

                /**
                 * Notice
                 */
                if(!empty($this->msg_notice)) {
                    print '<div class="wpcs_admin_feedback info">';
                        foreach($this->msg_notice as $string) { print $string; }
                    print "</div>";
                }

                /**
                 * Warning
                 */
                if(!empty($this->msg_warning)) {
                    print '<div class="wpcs_admin_feedback warning">';
                        foreach($this->msg_warning as $string) { print $string; }
                    print "</div>";
                }



            $draw_content_section = function($item, $slug, $section_slug) use ($current_slug, $current_section_slug) {
                $display = ($current_slug == $slug && $current_section_slug == $section_slug) ? "block" : "";
                print '<section style="display:'.$display.';" class="'.$section_slug.'_'.$slug.'" data-section="'.$section_slug.'" data-item="'.$slug.'">';
                if(isset($item['callback'])) {
                    $func_name = $item['callback'][1];
                    $class = $item['callback'][0];
                }
                else {
                    $func_name = "draw_".$section_slug."_".$slug."_settings";
                    $class = 'DXIM\AdminSetting';
                }

                if(method_exists($class,$func_name)) {
                    ob_start();
                    call_user_func([$class,$func_name]);
                    print ob_get_clean();
                }
                else print "Bitte ".$class."::".$func_name." implementieren";
                print '</section>';
            };

            /**
             * settings
             */
            print '<div id="wpcs_admin_settings">';

                // externe settings page
                if(isset($_REQUEST['wpcs_settings_page'])) {
                    $this->_settings_page($_REQUEST['wpcs_settings_page']);
                    print '<input type="hidden" name="wpcs_settings_page" value="'.$_REQUEST['wpcs_settings_page'].'" />';
                }

                // settings anhand menu
                else {
                    foreach($menu as $section_slug => $section) {
                        if(isset($section['settings_page'])) $draw_content_section($section, $section['settings_page'], $section_slug);
                        foreach($section['items'] as $slug => $item) {
                            $has_settings = (!isset($item['has_settings'])) ? true : $item['has_settings'];
                            if(!$has_settings) continue;
                            $draw_content_section($item, $slug, $section_slug);
                        }
                    }
                }




            print '</div>'; // settings


        print '</div>'; // content

        print '<div class="clear"></div>';
        print '</div>'; // wrap

        print '</form>';

    }

    /**
     * externe Settings Page
     * @return void
     */
    public function _settings_page_menu($page) {

        // CSV Settings
        if($page == "csv_config") {
            print '<a href="'.$this->_getAdminPage().'&section_slug=accounts&slug=csv" class="button">zurück</a>';
        }

        //Import / Export
        elseif($page == "import_export") {
            print '<a href="'.$this->_getAdminPage().'&section_slug=admin&slug=admin" class="button">zurück</a>';
        }

        do_action('wpcs_settings_page_menu', $page);
    }

    /**
     * @param $page
     * @return void
     */
    private function _settings_page($page) {

        // CSV Config
        if ($page == "csv_config") {
            $acc_id = $_REQUEST['account_config'] ?? null;
            print AdminSetting::drawCSVAccountConfig($acc_id, $options);
        }

        // Import / Export der Settings
        elseif ($page == "import_export") {
            print AdminSetting::drawImportExportSettings();
        }

        do_action('wpcs_settings_page', $page);

    }


    /**
     * @param $accountName
     */
    private function deleteAccount($accountName) {
        $options = $this->getOptions();

        // account löschen
        $a = Account::getInstance();
        $a->delete_account($accountName, $options);

        // csv account location mapping löschen
        delete_option('wpcs_csv_locations_' . $accountName);

        // csv account eigenes feldmapping löschen
        delete_option('wpcs_csv_cf_' . $accountName);

        // optionen speichern
        $this->saveOptions($options);

        $section_slug = $_REQUEST['section_slug'] ?? "";
        $slug = $_REQUEST['slug'] ?? "";

        // zurück zu den einstellungen
        wp_redirect($this->_getAdminPage().'&section_slug='.$section_slug."&slug=".$slug);
    }



    /**
     *
     */
    public function _admin_notices() {

        // Notice after Update
        // Plugin Einstellungen müssen an neue Plugin Version angepasst werden
        $instructions_read = get_option('wpcs_instructions_read');
        if (version_compare($instructions_read, DXIM_PluginVersion, '<')) {
            $class = 'wpcs_notice warning';
            $message = '<h3>WPCarSync Install / Update</h3>';
            $message .= 'Gehen sie nun zu den <a href="' . $this->_getAdminPage() . '">Einstellungen</a> um Update/Installation abzuschließen';
            print '<div class="' . $class . '">' . $message . '</div>';
        }
    }

    /**
     * @return string
     */
    public function set_html_content_type() {
        return 'text/html';
    }

    public function _go_pro() {
        $html = '<a href="' . DXIM_PluginWebAddressPro . '" class="button button-primary" target="_blank">Weitere Infos zu PRO!</a>';
        return $html;
    }

    /**
     * @param $columns
     * @return mixed
     */
    public function _vehicle_columns($columns) {
        $columns['seller_inventory_key'] = __('interne Nummer');
        $columns['wpcs_sync'] = __('Sync');

        $cspApiInfo = CarShotsPROApi::getInstance()->getApiInfo();
        if (!empty($cspApiInfo)) $columns['wpcs_csp'] = __('CarShotsPRO');

        return $columns;
    }

    /**
     * @param $column
     * @param $post_id
     */
    public function _vehicle_columns_content($column, $post_id) {

        if ($column == 'seller_inventory_key') {
            print get_post_meta($post_id, 'seller_inventory_key', true);
        }

        if ($column == 'wpcs_sync') {
            $sync_disabled = intval(get_post_meta($post_id, 'wpcs_sync_disabled', true));
            $label = "aktiv";
            $class = "active";

            if ($sync_disabled) {
                $label = "inaktiv";
                $class = "inactive";
            }

            print '<a href="#" data-vehicle-id="' . $post_id . '" class="wpcs_toggle_sync ' . $class . '"><span>' . $label . '</span></a>';
        }

        if ($column == "wpcs_csp") {
            $account_id = get_post_meta($post_id, 'ad_account', true);
            $settings = $this->options['carshotspro']['mapping'][$account_id] ?? "";
            if (empty($settings['csp_account']) || $settings['csp_account'] == "#") print "Account nicht konfiguriert";
            else {
                print '<a href="#" class="wpcs_vehicle_list_csp_create_job" data-vehicle-id="' . $post_id . '">Job starten</a> ';
                print '<span class="dashicons dashicons-image-rotate wpcs_spin"></span>';
                print '<div class="wpcs_vehicle_list_csp_status">status</div>';
            }
        }
    }
}
