<?php
/**
 * Created by PhpStorm.
 * User: dx
 * Date: 04.07.18
 * Time: 12:16
 */

namespace DXIM;


class Conf {

	protected static $instance = null;


	/**
	 *
	 * @return Conf
	 */
	public static function getInstance() {
		if(self::$instance === null) {
			self::$instance = new self;
		}
		return self::$instance;
	}

	public function __construct() {

	}


	/**
	 * @return mixed|string
	 */
	public function getVehicleSinglePage() {
		$options = Admin::getInstance()->getOptions();
		$page = $options['vehicle_single_page'] ?? "";
		if($page == '#' || empty($page)) return null;
		return $page;
	}


	/**
	 * @return bool
	 */
	public function isVehicleSinglePage() {
	    $obj = get_queried_object();

	    if(empty($obj) || !is_a($obj,'WP_Post')) return false;

        if($obj->post_type == "vehicle") return true;

		$current_id = $obj->ID ?? 0;
		if($current_id < 1) return false;

		$ref_page = $this->getVehicleSinglePage();

		if(!$ref_page || !$current_id) return false;

		return get_queried_object()->ID == $this->getVehicleSinglePage();
	}


	/**
	 * @return mixed|string
	 */
	public function getVehicleArchivePage() {
		$options = Admin::getInstance()->getOptions();
		$page = $options['vehicle_archive_page'] ?? '';

		if($page == '#' || empty($page)) return "";
		return $page;
	}

    /**
     * @return false|string
     */
    public function getVehicleArchiveUrl() {
        $page_id = $this->getVehicleArchivePage();
        // neue methode => echtes pt archive
        if(empty($page_id)) return get_post_type_archive_link('vehicle');
        // alte methode
        else return get_permalink($page_id);
    }

	/**
	 * @return bool
	 */
	public function isVehicleArchivePage() {
        $page_id = $this->getVehicleArchivePage();

        // neue methode
        if(empty($page_id) && is_post_type_archive('vehicle')) {
            return true;
        }

        // alte methode
        else {
            $current_id = get_queried_object()->ID ?? null;
            if($current_id == null) return false;
            $ref_page = $this->getVehicleSinglePage();

            if(!$ref_page || !$current_id) return false;

            return $current_id == $this->getVehicleArchivePage();
        }

	}

}