<?php

namespace DXIM;

class CarShotsPRO {

	protected static $instance = null;
    protected $optionName = "csp_api_info";
    protected $error = null;

    protected $default_angles = [
        'front-left' => 1, 'rear-right' => 2, 'side-left' => 3, 'front-seats-left' => 4, 'steering-wheel' => 5, 'trunk' => 6
    ];

    protected $angles = [
        'front-left' => ['label' => 'Vorne links'],
        'front' => ['label' => 'Vorne'],
        'front-right' => ['label' => 'Vorne rechts'],
        'side-left' => ['label' => 'linke Seite'],
        'side-right' => ['label' => 'rechte Seite'],
        'rear' => ['label' => 'Hinten'],
        'rear-left' => ['label' => 'Hinten links'],
        'rear-right' => ['label' => 'Hinten rechts'],
        'front-wheel-left' => ['label' => 'Vorderrad links'],
        'front-seats-left' => ['label' => 'Vordersitze links'],
        'steering-wheel' => ['label' => 'Lenkrad'],
        'trunk' => ['label' => 'Kofferraum'],
    ];


    /**
	 *
	 * @return CarShotsPRO
	 */
	public static function getInstance() {
		if(self::$instance === null) {
			self::$instance = new self;
		}
		return self::$instance;
	}


    public function getError() { return $this->error; }

    public function getAngles() { return $this->angles; }

    public function getDefaultMapping() { return $this->default_angles; }


    /**
     * @param $image_name
     * @param $image_type
     * @return array|false
     */
    public function getImages($post_id, $image_type) {
	    $file_names = get_post_meta($post_id, "images_filesystem_csp", true);
		$files = [];
		if(!empty($file_names)) {
		    foreach($file_names as $file_name) {
			    $ext = substr($file_name,-3);
			    if($image_type == "csp" && $ext == "png") continue;
			    elseif($image_type == "csp_crop" && $ext == "jpg") continue;
			    $files[] = trailingslashit(CarShotsPROImport::getInstance()->get_url()).$file_name;
		    }
	    }

		return $files;
	}
}

/**
 *
 */
define('CARSHOTSPRO_URL', 'https://www.carshotspro.com');
define('CARSHOTSPRO_APP', 'https://app.carshotspro.com');
define('CARSHOTSPRO_API', 'https://app.carshotspro.com');
#define('CARSHOTSPRO_API', 'http://photoapp');

/**
 * HOOKS
 */
define('CARSHOTSPRO_POOL_FILE_NAME', 'carshotspro_pool_file_name');
define('CARSHOTSPRO_FIND_VEHICLE', 'carshotspro_find_vehicle');
define('CARSHOTSPRO_CREATE_JOB_KEY', 'carshotspro_create_job_key');