<?php
/**
 * Created by PhpStorm.
 * User: dxPro
 * Date: 10/01/16
 * Time: 12:37
 */

namespace DXIM;


class Features {

    public static $featureCategories = [
        'drive' => 'Antrieb und Fahrwerk',
        'safety' => 'Sicherheit',
        'emission' => 'Umwelt',
        'comfort' => 'Komfort und Innenausstattung',
        'assistance' => 'Fahrerassistenz',
        'multimedia' => 'Multimedia',
        'exterior' => 'Exterieur',
        'wheels' => 'Räder und Bereifung',
        'other' => 'Sonstige'
    ];

    /**
     * @var array
     */
    public static $features = [
        ['key' => 'ABS', 'label' => 'ABS', 'col' => 33, 'cat' => 'safety'],
        ['key' => 'AUXILIARY_HEATING', 'label' => 'Standheizung', 'col' => 65, 'cat' => 'comfort'],
        ['key' => 'COLDSTORE', 'label' => 'Kühlbox', 'col' => 90, 'cat' => 'comfort'],
        ['key' => 'DRIVERS_SLEEPING_COMPARTMENT', 'label' => 'Fahrerschlafplatz', 'col' => 72, 'cat' => 'comfort'],
        ['key' => 'ESP', 'label' => 'ESP', 'col' => 32, 'cat' => 'safety'],
        ['key' => 'FULL_SERVICE_HISTORY', 'label' => 'Scheckheftgepflegt', 'col' => 46, 'cat' => 'other'],
        ['key' => 'HU_AU_NEU', 'label' => 'HU neu', 'col' => 108, 'cat' => 'other'],
        ['key' => 'KITCHEN', 'label' => 'Küche', 'col' => 89, 'cat' => 'comfort'],
        ['key' => 'METALLIC', 'label' => 'Metallic', 'col' => 27, 'cat' => 'exterior'],
        ['key' => 'NAVIGATION_SYSTEM', 'label' => 'Navigationssystem', 'col' => 37, 'cat' => 'multimedia'],
        ['key' => 'PARTICULATE_FILTER_DIESEL', 'label' => 'Partikelfilter', 'col' => 102, 'cat' => 'emission'],
        ['key' => 'RENTING_POSSIBLE', 'label' => 'Vermietung möglich', 'col' => 81, 'cat' => 'other'],
        ['key' => 'RETARDER', 'label' => 'Retarder/Intarder', 'col' => 71, 'cat' => 'safety'],
        ['key' => 'SECONDARY_AIR_CONDITIONING', 'label' => 'Standklimaanlage','col' => 126, 'cat' => 'comfort'],
        ['key' => 'SLEEP_SEATS', 'label' => 'Schlafsitze', 'col' => 91, 'cat' => 'comfort'],
        ['key' => 'TV', 'label' => 'TV', 'col' => 73, 'cat' => 'comfort'],
        ['key' => 'WC', 'label' => 'WC', 'col' => 74, 'cat' => 'comfort'],
        ['key' => 'PARKING_SENSORS', 'label' => 'Einparkhilfe', 'col' => 103, 'cat' => 'assistance'],
        ['key' => 'AIR_SUSPENSION', 'label' => 'Luftfederung', 'col' => 83, 'cat' => 'drive'],
        ['key' => 'ALARM_SYSTEM', 'label' => 'Alarmanlage', 'col' => 247, 'cat' => 'safety'],
        ['key' => 'ALLOY_WHEELS', 'label' => 'Leichtmetallfelgen', 'col' => 31, 'cat' => 'wheels'],
        ['key' => 'ALL_SEASON_TIRES', 'label' => 'Allwetterreifen', 'col' => 226, 'cat' => 'wheels'],
        ['key' => 'AMBIENT_LIGHTING', 'label' => 'Ambiente-Beleuchtung','col' => 214, 'cat' => 'comfort'],
        ['key' => 'ANDROID_AUTO', 'label' => 'Android Auto', 'col' => 221, 'cat' => 'multimedia'],
        ['key' => 'ARM_REST', 'label' => 'Armlehne', 'col' => 257, 'cat' => 'comfort'],
        ['key' => 'AUTOMATIC_RAIN_SENSOR', 'label' => 'Regensensor','col' => 193, 'cat' => 'assistance'],
        ['key' => 'BIODIESEL_SUITABLE', 'label' => 'Biodiesel geeignet', 'col' => 45, 'cat' => 'emission'],
        ['key' => 'BLIND_SPOT_MONITOR', 'label' => 'Totwinkel-Assistent', 'cat' => 'assistance'],
        ['key' => 'BLUETOOTH', 'label' => 'Bluetooth','col' => 174, 'cat' => 'multimedia'],
        ['key' => 'CARGO_BARRIER', 'label' => 'Gepäckraumabtrennung', 'col' => 238, 'cat' => 'comfort'],
        ['key' => 'CARPLAY', 'label' => 'Apple CarPlay', 'col' => 222, 'cat' => 'multimedia'],
        ['key' => 'CD_MULTICHANGER', 'label' => 'Multi-CD-Wechsler', 'cat' => 'multimedia'],
        ['key' => 'CD_PLAYER', 'label' => 'CD-Spieler','col' => 176, 'cat' => 'multimedia'],
        ['key' => 'CENTRAL_LOCKING', 'label' => 'Zentralverriegelung', 'col' => 39, 'cat' => 'comfort'],
        ['key' => 'COLLISION_AVOIDANCE', 'label' => 'Notbremsassistent', 'col' => 253, 'cat' => 'safety'],
        ['key' => 'DIGITAL_COCKPIT', 'label' => 'Volldigitales Kombiinstrument', 'col' => 219, 'cat' => 'comfort'],
        ['key' => 'DIMMING_INTERIOR_MIRROR', 'label' => 'Innenspiegel autom. abblendend', 'col' => 249, 'cat' => 'comfort'],
        ['key' => 'DISABLED_ACCESSIBLE', 'label' => 'Behindertengerecht', 'col' => 19, 'cat' => 'other'],
        ['key' => 'DISTANCE_WARNING_SYSTEM', 'label' => 'Abstandswarner', 'col' => 254, 'cat' => 'assistance'],
        ['key' => 'E10_ENABLED', 'label' => 'E10-geeignet', 'col' => 119, 'cat' => 'emission'],
        ['key' => 'ELECTRIC_ADJUSTABLE_SEATS', 'label' => 'Elektr. Sitzeinstellung','col' => 177, 'cat' => 'comfort'],
        ['key' => 'ELECTRIC_BACKSEAT_ADJUSTMENT', 'label' => 'Elektr. Sitzeinstellung, hinten', 'col' => 216, 'cat' => 'comfort'],
        ['key' => 'ELECTRIC_EXTERIOR_MIRRORS', 'label' => 'Elektr. Seitenspiegel','col' => 171, 'cat' => 'comfort'],
        ['key' => 'ELECTRIC_HEATED_REAR_SEATS', 'label' => 'Sitzheizung hinten', 'col' => 215, 'cat' => 'comfort'],
        ['key' => 'ELECTRIC_HEATED_SEATS', 'label' => 'Sitzheizung', 'col' => 101, 'cat' => 'comfort'],
        ['key' => 'ELECTRIC_TAILGATE', 'label' => 'Elektr. Heckklappe', 'col' => 261, 'cat' => 'exterior'],
        ['key' => 'ELECTRIC_WINDOWS', 'label' => 'Elektr. Fensterheber', 'col' => 40, 'cat' => 'comfort'],
        ['key' => 'EMERGENCY_CALL_SYSTEM', 'label' => 'Notrufsystem', 'col' => 270, 'cat' => 'safety'],
        ['key' => 'EXPORT', 'label' => 'Für Gewerbe, Ex-/Import', 'col' => 111, 'cat' => 'other'],
        ['key' => 'FATIGUE_WARNING_SYSTEM', 'label' => 'Müdigkeitswarner', 'col' => 268, 'cat' => 'safety'],
        ['key' => 'FOLD_FLAT_PASSENGER_SEAT', 'label' => 'Umklappbarer Beifahrersitz','col' => 218, 'cat' => 'comfort'],
        ['key' => 'FOUR_WHEEL_DRIVE', 'label' => 'Allradantrieb', 'col' => 41, 'cat' => 'drive'],
        ['key' => 'FRONT_FOG_LIGHTS', 'label' => 'Nebelscheinwerfer','col' => 189, 'cat' => 'exterior'],
        ['key' => 'GLARE_FREE_HIGH_BEAM', 'label' => 'Blendfreies Fernlicht', 'col' => 285, 'cat' => 'exterior'],
        ['key' => 'HANDS_FREE_PHONE_SYSTEM', 'label' => 'Freisprecheinrichtung','col' => 179, 'cat' => 'multimedia'],
        ['key' => 'HEADLIGHT_WASHER_SYSTEM', 'label' => 'Scheinwerferreinigung','col' => 212, 'cat' => 'exterior'],
        ['key' => 'HEAD_UP_DISPLAY', 'label' => 'Head-Up Display','col' => 178, 'cat' => 'comfort'],
        ['key' => 'HEATED_STEERING_WHEEL', 'label' => 'Beheizbares Lenkrad', 'col' => 248, 'cat' => 'comfort'],
        ['key' => 'HEATED_WINDSHIELD', 'label' => 'Beheizbare Frontscheibe', 'col' => 258, 'cat' => 'comfort'],
        ['key' => 'HIGH_BEAM_ASSIST', 'label' => 'Fernlichtassistent','col' => 213, 'cat' => 'assistance'],
        ['key' => 'HILL_START_ASSIST', 'label' => 'Berganfahrassistent', 'col' => 259, 'cat' => 'assistance'],
        ['key' => 'HYBRID_PLUGIN', 'label' => 'Plug-in-Hybrid', 'col' => 206, 'cat' => 'emission'],
        ['key' => 'IMMOBILIZER', 'label' => 'Elektr. Wegfahrsperre', 'col' => 36, 'cat' => 'safety'],
        ['key' => 'INTEGRATED_MUSIC_STREAMING', 'label' => 'Musikstreaming integriert', 'col' => 224, 'cat' => 'multimedia'],
        ['key' => 'ISOFIX', 'label' => 'Isofix','col' => 186, 'cat' => 'safety'],
        ['key' => 'KEYLESS_ENTRY', 'label' => 'Schlüssellose Zentralverriegelung', 'col' => 280, 'cat' => 'comfort'],
        ['key' => 'LANE_DEPARTURE_WARNING', 'label' => 'Spurhalteassistent', 'col' => 250, 'cat' => 'assistance'],
        ['key' => 'LEATHER_STEERING_WHEEL', 'label' => 'Lederlenkrad', 'col' => 264, 'cat' => 'comfort'],
        ['key' => 'LIGHT_SENSOR', 'label' => 'Lichtsensor','col' => 188, 'cat' => 'comfort'],
        ['key' => 'LUMBAR_SUPPORT', 'label' => 'Lordosenstütze', 'col' => 265, 'cat' => 'comfort'],
        ['key' => 'MASSAGE_SEATS', 'label' => 'Massagesitze', 'col' => 267, 'cat' => 'comfort'],
        ['key' => 'MULTIFUNCTIONAL_WHEEL', 'label' => 'Multifunktionslenkrad','col' => 181, 'cat' => 'comfort'],
        ['key' => 'NIGHT_VISION_ASSIST', 'label' => 'Nachtsicht-Assistent', 'col' => 269, 'cat' => 'assistance'],
        ['key' => 'NONSMOKER_VEHICLE', 'label' => 'Nichtraucher-Fahrzeug', 'col' => 194, 'cat' => 'other'],
        ['key' => 'ON_BOARD_COMPUTER', 'label' => 'Bordcomputer','col' => 175, 'cat' => 'comfort'],
        ['key' => 'PADDLE_SHIFTERS', 'label' => 'Schaltwippen', 'col' => 272, 'cat' => 'comfort'],
        ['key' => 'PANORAMIC_GLASS_ROOF', 'label' => 'Panorama-Dach','col' => 185, 'cat' => 'comfort'],
        ['key' => 'PASSENGER_SEAT_ISOFIX_POINT', 'label' => 'Isofix Beifahrersitz', 'col' => 237, 'cat' => 'safety'],
        ['key' => 'PERFORMANCE_HANDLING_SYSTEM', 'label' => 'Sportfahrwerk','col' => 172, 'cat' => 'drive'],
        ['key' => 'POWER_ASSISTED_STEERING', 'label' => 'Servolenkung', 'col' => 44, 'cat' => 'comfort'],
        ['key' => 'RANGE_EXTENDER', 'label' => 'Range Extender', 'col' => 236, 'cat' => 'emission'],
        ['key' => 'ROOF_RAILS', 'label' => 'Dachreling','col' => 195, 'cat' => 'exterior'],
        ['key' => 'SKI_BAG', 'label' => 'Skisack','col' => 182, 'cat' => 'comfort'],
        ['key' => 'SMOKERS_PACKAGE', 'label' => 'Raucherpaket','col' => 217, 'cat' => 'comfort'],
        ['key' => 'SOUND_SYSTEM', 'label' => 'Soundsystem', 'col' => 274, 'cat' => 'multimedia'],
        ['key' => 'SPEED_LIMITER', 'label' => 'Geschwindigkeitsbegrenzer', 'col' => 309, 'cat' => 'assistance'],
        ['key' => 'SPORT_PACKAGE', 'label' => 'Sportpaket','col' => 173, 'cat' => 'comfort'],
        ['key' => 'SPORT_SEATS', 'label' => 'Sportsitze','col' => 184, 'cat' => 'comfort'],
        ['key' => 'START_STOP_SYSTEM', 'label' => 'Start/Stopp-Automatik', 'col' => 192, 'cat' => 'emission'],
        ['key' => 'STEEL_WHEELS', 'label' => 'Stahlfelgen', 'col' => 232, 'cat' => 'wheels'],
        ['key' => 'SUMMER_TIRES', 'label' => 'Sommerreifen', 'col' => 227, 'cat' => 'wheels'],
        ['key' => 'SUNROOF', 'label' => 'Schiebedach', 'col' => 38, 'cat' => 'comfort'],
        ['key' => 'TAXI', 'label' => 'Taxi', 'col' => 18, 'cat' => 'other'],
        ['key' => 'TIRE_PRESSURE_MONITORING', 'label' => 'Reifendruckkontrolle', 'col' => 271, 'cat' => 'safety'],
        ['key' => 'TOUCHSCREEN', 'label' => 'Touchscreen', 'col' => 277, 'cat' => 'multimedia'],
        ['key' => 'TRACTION_CONTROL_SYSTEM', 'label' => 'Traktionskontrolle','col' => 191, 'cat' => 'safety'],
        ['key' => 'TRAFFIC_SIGN_RECOGNITION', 'label' => 'Verkehrszeichenerkennung', 'col' => 279, 'cat' => 'assistance'],
        ['key' => 'USB', 'label' => 'USB', 'col' => 278, 'cat' => 'multimedia'],
        ['key' => 'VEGETABLEOILFUEL_SUITABLE', 'label' => 'Pflanzenöl geeignet', 'col' => 121, 'cat' => 'emission'],
        ['key' => 'VENTILATED_SEATS', 'label' => 'Sitzbelüftung','col' => 256, 'cat' => 'comfort'],
        ['key' => 'VOICE_CONTROL', 'label' => 'Sprachsteuerung', 'col' => 275, 'cat' => 'multimedia'],
        ['key' => 'WARRANTY', 'label' => 'Garantie', 'col' => 30, 'cat' => 'other'],
        ['key' => 'WIFI_HOTSPOT', 'label' => 'WLAN / Wifi Hotspot', 'col' => 225, 'cat' => 'multimedia'],
        ['key' => 'WINTER_PACKAGE', 'label' => 'Winterpaket', 'col' => 220, 'cat' => 'comfort'],
        ['key' => 'WINTER_TIRES', 'label' => 'Winterreifen', 'col' => 228, 'cat' => 'wheels'],
        ['key' => 'WIRELESS_CHARGING', 'label' => 'Induktionsladen für Smartphones', 'col' => 223, 'cat' => 'multimedia'],
        ['key' => 'BOX', 'label' => 'Koffer', 'col' => 123, 'cat' => 'exterior'],
        ['key' => 'CATALYTIC_CONVERTER', 'label' => 'Katalysator', 'col' => 47, 'cat' => 'emission'],
        ['key' => 'DISABLED_CONVERSION', 'label' => 'Behinderten-Umbau', 'cat' => 'other'],
        ['key' => 'ELECTRIC_STARTER', 'label' => 'Elektrostarter', 'col' => 49, 'cat' => 'comfort'],
        ['key' => 'KICKSTARTER', 'label' => 'Kickstarter', 'col' => 48, 'cat' => 'comfort'],
        ['key' => 'ROLL_OVER_BAR', 'label' => 'Sturzbügel','col' => 124, 'cat' => 'safety'],
        ['key' => 'WINDSHIELD', 'label' => 'Scheibe','col' => 125, 'cat' => 'exterior'],
        ['key' => 'AWNING', 'label' => 'Markise','col' => 132, 'cat' => 'exterior'],
        ['key' => 'BED', 'label' => 'Festbett','col' => 130, 'cat' => 'comfort'],
        ['key' => 'BIODIESEL_CONVERSION', 'label' => 'Biodieselumrüstung', 'cat' => 'emission'],
        ['key' => 'BUNK_BED', 'label' => 'Etagenbett','col' => 129, 'cat' => 'comfort'],
        ['key' => 'CIRCULAR_SEATING_ARRANGEMENT', 'label' => 'Rundsitzgruppe','col' => 136, 'cat' => 'comfort'],
        ['key' => 'DAMAGE_BY_HAIL', 'label' => 'Hagelschaden','col' => 138, 'cat' => 'other'],
        ['key' => 'MIDDLE_SEATING_ARRANGEMENT', 'label' => 'Mittelsitzgruppe','col' => 135, 'cat' => 'comfort'],
        ['key' => 'REAR_GARAGE', 'label' => 'Heckgarage','col' => 131, 'cat' => 'exterior'],
        ['key' => 'SEP_SHOWER', 'label' => 'Separate Dusche','col' => 133, 'cat' => 'comfort'],
        ['key' => 'SIDE_SEATING_ARRANGEMENT', 'label' => 'Seitensitzgruppe','col' => 137, 'cat' => 'comfort'],
        ['key' => 'SOLAR_ENERGY_SYSTEM', 'label' => 'Solaranlage','col' => 134, 'cat' => 'comfort'],
        ['key' => 'CRANE', 'label' => 'Kran', 'col' => 70, 'cat' => 'comfort'],
        ['key' => 'DISC_BRAKE', 'label' => 'Scheibenbremse', 'col' => 84, 'cat' => 'safety'],
        ['key' => 'EBS', 'label' => 'EBS', 'col' => 80, 'cat' => 'safety'],
        ['key' => 'TAIL_LIFT', 'label' => 'Ladebordwand', 'col' => 75, 'cat' => 'exterior'],
        ['key' => 'COMPRESSOR', 'label' => 'Kompressor', 'col' => 82, 'cat' => 'comfort'],
        ['key' => 'MUNICIPAL', 'label' => 'Kommunalfahrzeug', 'col' => 69, 'cat' => 'other'],
        ['key' => 'DIVIDER', 'label' => 'Trennwand', 'col' => 79, 'cat' => 'comfort'],
        ['key' => 'BSS', 'label' => 'BSS', 'col' => 86, 'cat' => 'other'],
        ['key' => 'CENTRAL_LUBRICANT_APPLICATION', 'label' => 'ZSA', 'col' => 88, 'cat' => 'other'],
        ['key' => 'QUICK_CHANGE_ATTACHMENT', 'label' => 'Schnellwechseleinrichtung', 'col' => 87, 'cat' => 'other'],
        ['key' => 'ROAD_LICENCE', 'label' => 'Straßenzulassung', 'col' => 128, 'cat' => 'other'],
        ['key' => 'CABIN', 'label' => 'Kabine', 'col' => 66, 'cat' => 'exterior'],
        ['key' => 'FRONT_HYDRAULICS', 'label' => 'Fronthydraulik', 'col' => 85, 'cat' => 'drive'],
        ['key' => 'FRONT_JACK', 'label' => 'Frontheber', 'col' => 92, 'cat' => 'drive'],
        ['key' => 'PROTECTION_ROOF', 'label' => 'Schutzdach', 'col' => 67, 'cat' => 'exterior'],
        ['key' => 'FULL_FAIRING', 'label' => 'Vollverkleidung', 'col' => 68, 'cat' => 'exterior'],
        ['key' => 'SUPER_SINGLE_WHEELS', 'label' => 'Super-Single-Bereifung', 'col' => 127, 'cat' => 'wheels'],
        ['key' => 'UREA_TANK_AD_BLUE', 'label' => 'Harnstofftank (AdBlue)', 'col' => 122, 'cat' => 'emission'],
        ['key' => 'VEGETABLEOILFUEL_CONVERSION', 'label' => 'Pflanzenölumrüstung', 'cat' => 'emission'],
    ];

    /**
     * @param $key
     * @return mixed|void
     */

    public static function getFeatures() {
        $feature = array_column(self::$features,'label','key');
        // Hook zum manuellen modifizieren des Herstellernamens
        return $feature;
    }

    public static function getFeaturesGrouped() {
        $features = [];
        foreach(self::$features as $tmp) {
            $features[$tmp['cat']][$tmp['key']] = $tmp['label'];
        }
        return $features;
    }


}