<?php
/**
 * Created by PhpStorm.
 * User: dx
 * Date: 2019-03-27
 * Time: 13:19
 */

namespace DXIM;


class Select2Data {

	protected $data_source = null;
	protected static $instance = null;

	/**
	 *
	 * @return Admin
	 */
	public static function getInstance() {
		if(self::$instance === null) {
			self::$instance = new self;
		}
		return self::$instance;
	}


	/**
	 * Select2Data constructor.
	 */
	public function __construct() {

		$this->data_source = isset($_POST['data_source']) ? $_POST['data_source'] : null;

		add_action('wp_ajax_select2data',[&$this,'_get']);
	}

	/**
	 *
	 */
	public function _get() {
		$data = null;
		#wpcs_p($_POST);

		// make
		if($this->data_source == 'make') $data = Make::$makes;

		// model
		elseif($this->data_source == 'model') $data = Model::$models[$_POST['depends']];

		// class
		elseif($this->data_source == 'class') $data = VehicleClass::$classes;

		// category
		elseif($this->data_source == 'category') $data = Category::$categories[$_POST['depends']];

		$response = $this->_transform($data, $_POST['term']);

		// return
		header('Content-Type: application/json');
		die(json_encode($response));
	}


	/**
	 * @param $data
	 * @param $term
	 *
	 * @return array
	 */
	private function _transform($data, $term) {
		$response = [];
		foreach($data as $make) {
			$id = $make['key'];
			$text = $make['label'];

			$pos = stripos($text,$term);
			if($pos !== false || empty($term))
				$response[] = [
					'id' => $id, 'text' => $text
				];
		}

		return $response;
	}


	/**
	 * @param $liveData
	 *
	 * @return array
	 */
	public static function transformLiveData($liveData, $prepend = []) {
		$data = [];
		if(!empty($prepend)) $data[] = ['id' => $prepend['id'], 'text' => $prepend['text'] ];

		foreach($liveData as $key => $tmp) {
			$label = !empty($tmp['label']) ? $tmp['label'] : $key;
			$data[] = [
				'id' => $key,
				'text' => $label,
				//'text' => $tmp['label'].' ('.$tmp['amount'].')'
			];
		}
		return $data;
	}



}