<?php


namespace DXIM;


class FilterElementMultipleCheckbox {

    private $filterKey = null;


    public function __construct($filterKey) {
        $this->filterKey = $filterKey;
    }

    private function _get_values() {

        $field = VehicleFields::getField($this->filterKey);
        $depends = $field['data_source']['depends'] ?? null;
        $depends_on_value = null;
        if(!empty($depends)) {
            $formData = VehicleFilter::getInstance()->getFormData();
            $depends_on_value = $formData[$depends] ?? $field['data_source']['depends_default'];
        }
        $values = $field['value'] ?? []; // nur noch fallback für alte Filter Hooks => neuer Wert ist immer fillable->defaults
        if(empty($values)) {
            $keys = Filter::getInstance()->getFilterValues($this->filterKey,[]);
            $values = VehicleFilter::getInstance()->getFilterValuesByKeys($keys, $this->filterKey, $depends_on_value);
        }

        return $values;
    }

    /**
     * @param $values
     * @param $filterkey
     * @param $current_value
     */
    public function draw($selectedValues) {
        if (!is_array($selectedValues)) $selectedValues = [$selectedValues];

        $html = '<div class="wpcs_multiple_checkbox" data-filter="' . $this->filterKey . '">';
        foreach ($this->_get_values() as $key => $label) {
            if ($key == "" || $key == "#" || empty($label)) continue;
            $class = (is_array($selectedValues) && in_array($key, $selectedValues)) ? "selected" : null;
            $html .= '<div class="box"><div class="wpcs_selectable ' . $class . '" data-value="' . $key . '"></div><label>' . $label . '</label></div>';
        }

        $html .= '<input type="hidden" class="wpcs_element_value" name="' . $this->filterKey . '" value="' . $key . '" />';
        $html .= '</div>';

        return $html;
    }


}