<?php


namespace DXIM;


class FilterElementRadio {

    private $filterKey = null;


    public function __construct($filterKey) {
        $this->filterKey = $filterKey;
    }

    private function _get_values() {

        $field = VehicleFields::getField($this->filterKey);
        $values = $field['value'] ?? [];
        unset($values['#']);

        if(empty($values)) {
            $keys = Filter::getInstance()->getFilterValues($this->filterKey,[]);
            $values = VehicleFilter::getInstance()->getFilterValuesByKeys($keys, $this->filterKey);
        }

        return $values;
    }

    /**
     * @param $values
     * @param $filterkey
     * @param $current_value
     */
    public function draw($selectedValue) {

        $html = null;

        foreach ($this->_get_values() as $value => $label) {
            $checked = ($selectedValue == $value) ? "checked" : null;
            $html .= '<input type="radio" class="radio" name="' . $this->filterKey . '" value="' . $value . '" ' . $checked . ' /> ' . $label . '<br />';
        }

        return $html;
    }


}