<?php


namespace DXIM;


class FilterElementRange {

    private $filterKey = null;


    public function __construct($filterKey) {
        $this->filterKey = $filterKey;
    }

    /**
     * @return array
     */
    private function _get_values() {

        $field = VehicleFields::getField($this->filterKey);
        $field_name = $field['meta_query']['key'];
        #wpcs_p($field_name);

        $minMax = Filter::getInstance()->getMinMax($field_name);
        #$minMax = Filter::getInstance()->getMinMax($this->filterKey);

        $values['range']['min'] = $minMax['min'];
        $values['range']['max'] = $minMax['max'];
        $values['start'][0] = $minMax['min'];
        $values['start'][1] = $minMax['max'];

        return $values;
    }

    /**
     * @param $values
     * @param $filterkey
     * @param $current_value
     */
    public function draw($filter_value_1, $filter_value_2) {
        $options = Admin::getInstance()->getOptions();
        $filter = VehicleFields::getField($this->filterKey);
        $filter['filter_conf'] = array_merge($filter['filter_conf'] ?? [], $this->_get_values());

        $filter_1 = $this->filterKey . "_min";
        $filter_2 = $this->filterKey . "_max";
        $unit = $filter['unit'] ?? null;
        $formatting = $filter['html_formatting'] ?? false;

        $html = null;
        if (!isset($filter['filter_conf']['range'])) {
            $html .= "keine Werte vorhanden";
        } else {
            $settings = $filter['filter_conf'];
            $start_val = intval($filter_value_1) > 0 ? $filter_value_1 : $settings['start'][0];
            $end_val = intval($filter_value_2) > 0 ? $filter_value_2 : $settings['start'][1];
            $step = $settings['step'] ?? 1;

            if ($settings['range']['min'] == $settings['range']['max']) {
                #$html .= '<script>jQuery(\'.dxim_filter[data-filter-name="' . $this->filterKey . '"]\').hide();</script>';
                if($settings['range']['max'] > 0) {
                    $settings['range']['min'] = 0;
                    $start_val = $filter_value_1 = 0;
                }
                else return null;
            }

            $html .= '<div 
                class="dxim_filter_range" 
                data-key="' . $this->filterKey . '" 
                data-start="' . $start_val . '" 
                data-end="' . $end_val . '" 
                data-filter-1="' . $filter_1 . '" 
                data-filter-2="' . $filter_2 . '"
                data-step="' . $step . '"
                data-unit="'.$unit.'"
                data-formatting="'.$formatting.'"
            >';
            $html .= '<div id="wpcs_fs_' . $this->filterKey . '"></div>';
            $html .= '<input type="hidden" id="wpcs_fv_' . $filter_1 . '" name="' . $filter_1 . '" value="' . $filter_value_1 . '" />';
            $html .= '<input type="hidden" id="wpcs_fv_' . $filter_2 . '" name="' . $filter_2 . '" value="' . $filter_value_2 . '" />';
            if ($options['ff_labels'] == "inside") $html .= '<span class="label_inside">' . $filter['label'] . ': </span>';
            $html .= '<div class="label_wrapper">';
            $html .= '<span class="filter_slider_label first" id="wpcs_fl_' . $filter_1 . '">'. $filter_value_1 . '</span>';
            $html .= '<span class="filter_slider_label last" id="wpcs_fl_' . $filter_2 . '">' . $filter_value_2 . '</span>';
            $html .= '</div>';
            $html .= '</div>';

            $html .= "<script>";
            $html .= "wpcs_slider_ranges['" . $this->filterKey . "'] = " . json_encode($settings['range']) . ";";
            $html .= '</script>';
        }
    return $html;
    }


}