<?php


namespace DXIM;


class FilterElementSelect {

    private $filterKey = null;


    public function __construct($filterKey) {
        $this->filterKey = $filterKey;
    }


    /**
     * @param $values
     * @param $filterkey
     * @param $current_value
     */
    public function draw($current_value, $args = []) {
        $filter = VehicleFields::getField($this->filterKey);
        $filter_depends = $filter['data_source']['depends'] ?? null;
        $depends = $this->formData[$filter_depends] ?? null;

        if (isset($args['multiple'])) $multiple = intval($args['multiple']);
        else $multiple = (!isset($filter['multiple']) || intval($filter['multiple']) > 0) ? 1 : 0;

        $selected = is_array($current_value) ? implode(",", $current_value) : $current_value;
        $att_depends = isset($filter_depends) ? 'data-depends="' . $filter_depends . '"' : null;
        $nothing_selected_label = VehicleFilter::getInstance()->_get_nothing_selected_label($filter['label'], $this->filterKey);

        if (is_array($current_value)) $label = count($current_value) . " ausgewählt";
        elseif (!empty($current_value)) $label = VehicleFilter::getInstance()->getReadableValue($this->filterKey, $current_value, $depends);
        else $label = $nothing_selected_label;

        $html = '<div class="wpcsselect" data-field="' . $this->filterKey . '" data-nothing-selected="' . $nothing_selected_label . '" data-multiple="' . $multiple . '" name="' . $this->filterKey . '" ' . $att_depends . '>';
            $html .= '<div class="wpcs_select_handle">' . $label . '</div>';
            $html .= '<div class="wpcs_select_loading"></div>';
            $html .= '<div class="wpcs_select_arrow"></div>';
            #$html .= '<input type="hidden" name="' . $this->filterKey . '" value="' . $selected . '" id="wpcs_select_value_' . $this->filterKey . '" />';
            $html .= '<input type="hidden" name="' . $this->filterKey . '" value="' . $selected . '" class="wpcs_select_value" />';
            $html .= '<div class="data"></div>';
        $html .= '</div>';

        return $html;
    }


}