<?php


namespace DXIM;


class FilterElementSlider {

    private $filterKey = null;


    public function __construct($filterKey) {
        $this->filterKey = $filterKey;
    }

    private function _get_values() {
        $field = VehicleFields::getField($this->filterKey);
        $field_name = $field['meta_query']['key'];
        $minMax = Filter::getInstance()->getMinMax($field_name);
        #$minMax = Filter::getInstance()->getMinMax($this->filterKey);
        $values['range']['min'] = $minMax['min'];
        $values['range']['max'] = $minMax['max'];

        return $values;
    }

    /**
     * @param $values
     * @param $filterkey
     * @param $current_value
     */
    public function draw($current_value) {
        $options = Admin::getInstance()->getOptions();

        $filter = VehicleFields::getField($this->filterKey);
        $filter['filter_conf'] = array_merge($filter['filter_conf'], $this->_get_values());
        $formatting = $filter['html_formatting'] ?? 0;
        $unit = $filter['unit'] ?? null;

        $min_max_exception = substr($this->filterKey,-4);
        if($min_max_exception == "_max") $filter['filter_conf']['default_value'] = 'max';
        elseif($min_max_exception == "_min") $filter['filter_conf']['default_value'] = 'min';

        $html = null;
        if (empty($filter['filter_conf']['range'])) {
            $html .= "keine Werte vorhanden";
        } else {
            $settings = $filter['filter_conf'];
            $default_value = $settings['range'][$settings['default_value']];
            $start_val = intval($current_value) > 0 ? $current_value : $default_value;
            $step = $settings['step'] ?? 1;

            if ($settings['range']['min'] == $settings['range']['max']) {
                $html .= '<script>jQuery(\'.dxim_filter[data-filter-name="' . $this->filterKey . '"]\').hide();</script>';
            } else {
                $html .= '<div class="dxim_filter_slider" 
                    data-key="' . $this->filterKey . '" 
                    data-min="' . $settings['range']['min'] . '" 
                    data-max="' . $settings['range']['max'] . '" 
                    data-start="' . $start_val . '" 
                    data-default="'.$default_value.'" 
                    data-step="' . $step . '"
                    data-unit="'.$unit.'"
                    data-formatting="'.$formatting.'"
                >';
                $html .= '<div id="wpcs_fs_' . $this->filterKey . '"></div>';
                $html .= '<input type="hidden" id="wpcs_fv_' . $this->filterKey . '" name="' . $this->filterKey . '" value="' . $start_val . '" />';
                if ($options['ff_labels'] == "inside") $html .= '<span class="label_inside">' . $filter['label'] . ': </span>';
                $html .= '<div class="label_wrapper">';
                $html .= '<span class="filter_slider_label" id="wpcs_fl_' . $this->filterKey . '_current">' . $start_val . '</span>';
                $html .= '</div>';
                $html .= '</div>';

                $html .= "<script>";
                $html .= "wpcs_slider_ranges['" . $this->filterKey . "'] = " . json_encode($settings['range']) . ";";
                $html .= '</script>';
            }
        }

        return $html;
    }


}