<?php
/**
 * Created by PhpStorm.
 * User: dxPro
 * Date: 08/01/16
 * Time: 08:35
 */

namespace DXIM;


class Cleaner {

    protected static $instance = null;
    protected $error = null;


    public function getError() { return $this->error; }

    /**
     *
     * @return Cleaner
     */
    public static function getInstance() {

        if (self::$instance === null) {
            self::$instance = new self;
        }
        return self::$instance;
    }

    /**
     * Sync constructor.
     */
    public function __construct() {

    }

    /**
     * @return void
     */
    public function cleanup_vehicle_dir() {
        global $wpdb;
        $images_dir = FilesystemImport::getInstance()->get_import_dir();
        $sql = 'SELECT m.meta_value as image_id FROM '.$wpdb->prefix.'posts p LEFT JOIN '.$wpdb->prefix.'postmeta m ON (p.ID = m.post_id)
                WHERE 1 = 1
                AND p.post_type = "vehicle"
                AND p.post_status = "publish"
                AND m.meta_key = "image_id"
                ';
        $result = $wpdb->get_results($sql);
        $images = array_map(function ($item) { return $item->image_id; }, $result);
        $deleted_files = [];
        $d = dir($images_dir);
        while (false !== ($entry = $d->read())) {
            if(!is_file($images_dir."/".$entry)) continue;
            $basename = preg_replace('/_([0-9]{1,2})\.(jpg|png)/', "", $entry);

            if(!in_array($basename, $images)) {
                #print "lösche $entry<br />";
                unlink($images_dir."/".$entry);
                $deleted_files[] = $entry;
            }
        }
        $d->close();

        return $deleted_files;
    }



    /**
     * @return void
     */
    public function cleanup() {
        $dir = WPCS_UPLOADS_DIR.'/imports';
        if(!is_dir($dir)) return;

        $keep_days = 7;
        $keep_until = time() - (86400 * $keep_days);

        foreach(scandir($dir) as $folder) {
            if($folder == "." || $folder == "..") continue;
            if($folder < $keep_until) {
                $tmpDir = $dir."/".$folder;
                $files = scandir($tmpDir);
                foreach($files as $file) {
                    if(is_file($tmpDir."/".$file)) unlink($tmpDir."/".$file);
                }
                rmdir($tmpDir);
            }
        }
        Sync::extLog("Bereinige Importverzeichnis");
    }



}