<?php
/**
 * Created by PhpStorm.
 * User: dxPro
 * Date: 08/01/16
 * Time: 08:35
 */

namespace DXIM;


class Delete {

    protected static $instance = null;


    /**
     *
     * @return Delete
     */
    public static function getInstance() {

        if (self::$instance === null) {
            self::$instance = new self;
        }
        return self::$instance;
    }

    /**
     * Sync constructor.
     */
    private function __construct() {

    }

    /**
     * Fahrzeuge, die nicht den übergebenen accounts gehören,
     * werden vor dem löschen geschützt, in dem ihnen die ID des aktuellen Imports zugewiesen wird
     * @param $import_id
     * @param $accounts
     * @return void
     */
    public function limitTo($import_id, $accounts) {
        if(empty($accounts)) return;
        global $wpdb;

        $stringify = array_map(function($a) { return "'".$a."'"; }, $accounts);
        $in = implode(",",$stringify);
        if(empty($in)) return;

        $sql = '
            SELECT '.$wpdb->prefix.'posts.ID         
            FROM '.$wpdb->prefix.'posts 
            LEFT JOIN '.$wpdb->prefix.'postmeta ON ( '.$wpdb->prefix.'posts.ID = '.$wpdb->prefix.'postmeta.post_id ) 
            WHERE 1 = 1
            AND ('.$wpdb->prefix.'postmeta.meta_key = "ad_account" AND '.$wpdb->prefix.'postmeta.meta_value NOT IN ('.$in.'))
            AND '.$wpdb->prefix.'posts.post_type = "vehicle"
            AND '.$wpdb->prefix.'posts.post_status = "publish"
        ';
        $results = $wpdb->get_results($sql, ARRAY_A);

        $ids = array_map(function($i) { return $i['ID']; }, $results);
        if(empty($ids)) return;

        $sql = "UPDATE ".$wpdb->prefix."postmeta SET meta_value = '".$import_id."' WHERE meta_key = 'import_id' AND post_id IN (".implode(",", $ids).")";
        $wpdb->query($sql);
    }


    /**
     * @param $import_id
     * @return string
     */
    private function _create_sql($import_id) {
        global $wpdb;

        $sql = "SELECT SQL_CALC_FOUND_ROWS ID FROM ".$wpdb->prefix."posts
        WHERE (
          ID NOT IN (
            SELECT post_id
            FROM ".$wpdb->prefix."postmeta
            WHERE meta_key = 'import_id'
          ) 
          OR ID IN (
            SELECT post_id
            FROM ".$wpdb->prefix."postmeta
            WHERE meta_key = 'import_id' AND meta_value != '".$import_id."'
          )
        )
        AND ".$wpdb->prefix."posts.post_type = 'vehicle'
        AND ".$wpdb->prefix."posts.post_status = 'publish'";

        return $sql;
    }


    /**
     * @param $import_id
     * @return void
     */
    public function setup($import_id) {
        global $wpdb;

        // alle Fahrzeuge, die nicht dem aktuellen Import angehören, löschen
        $sql = $this->_create_sql($import_id);
        $wpdb->query($sql, ARRAY_A );

        // get max count from last seaarch
        $found_rows = $wpdb->get_results("SELECT FOUND_ROWS() as count", ARRAY_A);
        $query['count'] = $found_rows[0]['count'];

        Import::getInstance()->vehicles_count($query['count']);
        return true;
    }

    /**
     * @param $import_id
     * @return void
     */
    public function getVehicle($import_id) {

        global $wpdb;
        $sql = $this->_create_sql($import_id)." LIMIT 1";
        $q = $wpdb->get_results($sql, ARRAY_A);
        $vehicle_id = $q[0]['ID'] ?? null;
        if(is_null($vehicle_id)) return null;

        return [
            'import_data' => [
                'do' => 'delete', 'ID' => $vehicle_id
            ]
        ];

    }



}