<?php

/**
 * Created by PhpStorm.
 * User: dx
 * Date: 2019-04-03
 * Time: 10:11
 */

namespace DXIM\theme;

class BrandData {

    public function getAll($args = []) {
        if(!is_array($args)) $args = [];
        $defaults = ['service' => 0, 'include' => ""];
        $args = array_merge($defaults,$args);
        $query = ['taxonomy' => Brand::$taxonomy,'hide_empty' => false,'orderby' => 'meta_value_num','order' => 'ASC','meta_key' => 'order'];

        $meta_query = [];

        // auf standort beschränken
        if($args['include']) {
            if(!is_array($args['include'])) $ids = explode(",", $args['include']);
            else $ids = $args['include'];
            $query['include'] = $ids;
        }

        // "nur service" - Marken ausblenden
        if($args['service'] < 1) {
            $mq = ['key' => 'brand_type', 'value' => '0'];
            $meta_query[] = $mq;
        }

        $query['meta_query'] = $meta_query;
        return get_terms($query);
    }


    public function getById($term_id) {
        $term = get_term_by("id", $term_id, Brand::$taxonomy);
        return !empty($term) ? $term : [];
    }

    /**
     * @param $slug
     * @return array|false|\WP_Error|\WP_Term|null
     */
    public function getBrandBySlug($slug) {
        return get_term_by("slug", $slug, Brand::$taxonomy);
    }
}
