<?php
/**
 * Created by PhpStorm.
 * User: dx
 * Date: 2019-04-03
 * Time: 10:11
 */

namespace DXIM\theme;

class BrandShortcode {

	protected static $instance = null;

	/**
	 *
	 * @return BrandShortcode
	 */
	public static function getInstance() {
		if(self::$instance === null) {
			self::$instance = new self;
		}
		return self::$instance;
	}

	/**
	 *
	 */
	private function __construct() {	}

    /**
     * @return void
     */
    public function init() {
        add_shortcode("WPCS_brand_filter", [&$this,'_draw_filter_brands']);
        add_shortcode("WPCS_brand_logos", [&$this,'_draw_logos']);
        add_shortcode("WPCS_brand_team", [&$this,'_draw_team']);
        add_shortcode("WPCS_brand_content", [&$this,'_draw_content']);
        add_shortcode("WPCS_brand_logo", [&$this,'_draw_logo']);
        add_shortcode("WPCS_brand_offers", [&$this,'_draw_offers']);
        add_shortcode("WPCS_brand_models", [&$this,'_draw_models']);
        add_shortcode("WPCS_brand_offers_link", [&$this,'_draw_offers_link']);
    }



    /**
     * @param $args
     * @return false|string
     */
    public function _draw_logos($args) {
        if(!is_array($args)) $args = [];
        return BrandTemplate::getInstance()->draw_brand_logos($args);
    }


    public function _draw_team($args) {
        $brand = Brand::getInstance()->get_brand($args);
        return BrandTemplate::getInstance()->draw_brand_team($brand, $args);
    }

    public function _draw_models($args) {
        $brand = Brand::getInstance()->get_brand($args);
        return BrandTemplate::getInstance()->draw_brand_models($brand, $args);
    }

    public function _draw_content($args) {
        $brand = Brand::getInstance()->get_brand($args);
        return BrandTemplate::getInstance()->draw_brand_content($brand, $args);
    }

    public function _draw_logo($args) {
        $brand = Brand::getInstance()->get_brand($args);
        return BrandTemplate::getInstance()->draw_brand_logo($brand, $args);
    }

    public function _draw_offers($args) {
        $brand = Brand::getInstance()->get_brand($args);
        return BrandTemplate::getInstance()->draw_brand_offers($brand, $args);
    }

    public function _draw_offers_link($args) {
        $brand = Brand::getInstance()->get_brand($args);
        return BrandTemplate::getInstance()->draw_brand_offers_link($brand, $args);
    }



    /**
     * @param $args
     * @return void
     */
    public function _draw_filter_brands($args) {
        $bd = new BrandData();
        $brands = $bd->getAll();
        $active_filters = Brand::getInstance()->get_filter() ?? [];

        $html = '<div class="wpcs_theme_filters brands">';
        foreach($brands as $brand) {
            $html .= '<div class="theme_filter offer_filter brand">';
            $checked = (in_array($brand->term_id, $active_filters)) ? "checked" : "";
            $html .= '<input type="checkbox" class="wpcs_checkbox" name="filter_brand[]" value="'.$brand->term_id.'" '.$checked.' />';
            $html .= '<span class="label">'.$brand->name.'</span>';
            $html .= '</div>';
        }
        $html .= '</div>';

        return $html;
    }
}