<?php
/**
 * Created by PhpStorm.
 * User: dx
 * Date: 2019-04-03
 * Time: 10:11
 */

namespace DXIM\theme;

class Division {

	protected static $instance = null;

    public static $taxonomy = "wpcs_division";


	/**
	 *
	 * @return Division
	 */
	public static function getInstance() {
		if(self::$instance === null) {
			self::$instance = new self;
		}
		return self::$instance;
	}

	/**
	 *
	 */
	private function __construct() {

	}

    public function init() {
        if(!WPCS_PRO) return;
        $this->_register_taxonomy();

        DivisionShortcode::getInstance()->init();
    }

    function _register_taxonomy() {

        $labels = array(
            'name'                       => _x( 'Abteilungen', 'Taxonomy General Name', 'wpcs' ),
            'singular_name'              => _x( 'Abteilung', 'Taxonomy Singular Name', 'wpcs' ),
            'menu_name'                  => __( 'Abteilungen', 'wpcs' ),
            'all_items'                  => __( 'Alle Abteilungen', 'wpcs' ),
            'parent_item'                => __( 'Parent Abteilung', 'wpcs' ),
            'parent_item_colon'          => __( 'Parent Abteilung:', 'wpcs' ),
            'new_item_name'              => __( 'neue Abteilung', 'wpcs' ),
            'add_new_item'               => __( 'neue Abteilung', 'wpcs' ),
            'edit_item'                  => __( 'Abteilung bearbeiten', 'wpcs' ),
            'update_item'                => __( 'Abteilung editieren', 'wpcs' ),
            'view_item'                  => __( 'Abteilung anzeigen', 'wpcs' ),
            'separate_items_with_commas' => __( 'Separate items with commas', 'wpcs' ),
            'add_or_remove_items'        => __( 'Add or remove items', 'wpcs' ),
            'choose_from_most_used'      => __( 'Choose from the most used', 'wpcs' ),
            'popular_items'              => __( 'Popular Items', 'wpcs' ),
            'search_items'               => __( 'Search Items', 'wpcs' ),
            'not_found'                  => __( 'Not Found', 'wpcs' ),
            'no_terms'                   => __( 'No items', 'wpcs' ),
            'items_list'                 => __( 'Items list', 'wpcs' ),
            'items_list_navigation'      => __( 'Items list navigation', 'wpcs' ),
        );
        $args = array(
            'labels'                     => $labels,
            'hierarchical'               => true,
            'public'                     => false,
            'show_ui'                    => true,
            'show_admin_column'          => true,
            'show_in_nav_menus'          => true,
            'show_tagcloud'              => true,
        );
        register_taxonomy( self::$taxonomy, array( Person::$post_type ), $args );

    }

}