<?php
/**
 * Created by PhpStorm.
 * User: dx
 * Date: 2019-04-03
 * Time: 10:11
 */

namespace DXIM\theme;

class JobData {

    /**
     * @param $post_id
     * @return false|\WP_Error|\WP_Term[]
     */
    public function get_locations($post_id) {
        return get_the_terms($post_id, Location::$taxonomy);
    }

    public function get_tags($post_id) {
        return get_the_terms($post_id, Tag::$taxonomy);
    }

    /**
     * @param $args
     * @return int[]|\WP_Post[]
     */
    public function get_jobs($args) {
        if(!is_array($args)) $args = [];
        $defaults = ['location' => 0, 'types' => ""];
        $args = array_merge($defaults, $args);

        $query = ['post_type' => Job::$post_type, 'post_status' => 'publish', 'orderby' => 'title', 'order' => 'ASC'];
        if(isset($args['posts_per_page'])) $query['posts_per_page'] = $args['posts_per_page'];

        $tax_query = [];
        $meta_query = [];

        // Location Filter
        if(!empty($args['location'])) {
            $locations = explode(",", $args['location']);
            $tax_query[] = ['taxonomy' => Location::$taxonomy, 'terms' => $locations];
        }

        // employmentType Filter
        if(!empty($args['types'])) {
            $types = explode(",",$args['types']);
            $meta_query[] = [
                'key' => 'employmentType', 'value' => $types, 'compare' => 'IN'
            ];
        }

        $query['tax_query'] = $tax_query;
        $query['meta_query'] = $meta_query;

        $q = new \WP_Query($query);
        return $q->posts;
    }


}