<?php
/**
 * Created by PhpStorm.
 * User: dx
 * Date: 2019-04-03
 * Time: 10:11
 */

namespace DXIM\theme;

use DXIM\CustomTemplate;

class JobShortcode {

	protected static $instance = null;


	/**
	 *
	 * @return JobShortcode
	 */
	public static function getInstance() {
		if(self::$instance === null) {
			self::$instance = new self;
		}
		return self::$instance;
	}

	/**
	 *
	 */
	private function __construct() {}

    /**
     * @return void
     */
    public function init() {
        add_shortcode("WPCS_job_filter_tags", [&$this,'_draw_filter_tags']);
        add_shortcode("WPCS_job_team", [&$this,'_draw_job_team']);
        add_shortcode("WPCS_job_image", [&$this,'_draw_job_image']);
        add_shortcode("WPCS_job_tags", [&$this,'_draw_job_tags']);
        add_shortcode("WPCS_jobs", [&$this,'_draw_jobs']);

        add_shortcode('WPCS_job_filter_types', [&$this,'_draw_filter_types']);

        add_shortcode("WPCS_jobs_archive", [&$this,'_draw_jobs_archive']);
    }

    /**
     * @param $args
     * @return string
     */
    public function _draw_jobs($args) {
        $jd = new JobData();
        $jobs = $jd->get_jobs($args);

        return JobTemplate::getInstance()->draw_jobs($jobs, $args);
    }

    public function _draw_jobs_archive($args) {
        return JobTemplate::getInstance()->draw_jobs_archive($args);
    }

    /**
     * @param $args
     * @return false|string
     */
    public function _draw_job_team($args) {
        $job = Job::getInstance()->get_current();
        return JobTemplate::getInstance()->draw_job_team($job, $args);
    }

    public function _draw_job_image($args) {
        $job = Job::getInstance()->get_current();
        return JobTemplate::getInstance()->draw_job_image($job, $args);
    }

    public function _draw_job_tags($args) {
        $job = Job::getInstance()->get_current();
        return JobTemplate::getInstance()->draw_job_tags($job, $args);
    }

    /**
     * @param $args
     * @return string|null
     */
    public function _draw_filter_tags($args) {
        $tag_string = "";
        $j = new TagData();
        $tags = $j->get_tags_by_meta('is_job_filter');
        foreach($tags as $tag) {
            $tag_string .= $tag->slug.",";
        }
        return TagShortcode::getInstance()->_draw_filter_tags(['tags' => $tag_string]);
    }

    /**
     * @return string
     */
    public function _draw_filter_types() {
        $types = Job::getInstance()->get_employment_types();
        $html = '<div class="wpcs_theme_filters locations">';
        $active_types = Job::getInstance()->get_filter()['types'] ?? [];

        foreach($types as $type => $label) {
            $html .= '<div class="theme_filter">';
            $checked = (in_array($type, $active_types)) ? "checked" : "";
            $html .= '<input type="checkbox" class="wpcs_checkbox" name="filter_job_type[]" value="'.$type.'" '.$checked.' />';
            $html .= '<span class="label">'.$label.'</span>';
            $html .= '</div>';
        }

        $html .= '</div>';

        return $html;
    }


}