<?php
/**
 * Created by PhpStorm.
 * User: dx
 * Date: 2019-04-03
 * Time: 10:11
 */

namespace DXIM\theme;


use DXIM\CustomTemplate;

class JobTemplate {

	protected static $instance = null;


	/**
	 *
	 * @return JobTemplate
	 */
	public static function getInstance() {
		if(self::$instance === null) {
			self::$instance = new self;
		}
		return self::$instance;
	}

	/**
	 *
	 */
	private function __construct() {}

    public function init() { }


    /**
     * @param $jobs
     * @param $args
     * @return string
     */
    public function draw_jobs($jobs, $args = []) {
        if(!is_array($args)) $args = [];
        $defaults = ['layout' => 'list', 'grid' => 3, 'per_slide' => 2];
        $args = array_merge($defaults, $args);

        $template = $args['template'] ?? $args['layout'];

        if(empty($jobs)) return CustomTemplate::getInstance()->get_template_content('theme/job/no_jobs_found');

        return CustomTemplate::getInstance()->get_template_content('theme/job/'.$template, ['jobs' => $jobs, 'args' => $args]);
    }

    public function draw_jobs_archive($args) {
        if(!is_array($args)) $args = [];
        $defaults = ['layout' => 'list', 'grid' => 2];
        $args = array_merge($defaults, $args);
        $template = $args['template'] ?? $args['layout'];
        $jobs = [];

        while ( have_posts() ) {
            the_post();
            global $post;
            $jobs[] = $post;
        }

        return \DXIM\CustomTemplate::getInstance()->get_template_content('theme/job/'.$template, ['jobs' => $jobs, 'args' => $args]);
    }


    /**
     * @param $job
     * @param $args
     * @return false|string
     */
    public function draw_job_team($job, $args) {
        if(!is_array($args)) $args = [];
        $defaults = [];
        $args = array_merge($defaults, $args);

        $jd = new JobData();
        $locations = $jd->get_locations($job->ID);

        $ld = new LocationData();
        $locations = $ld->buildTree($locations);

        $pd = new PersonData();
        $locations_persons = [];
        foreach($locations as $array) {
            $locations_tmp = !empty($array['childs']) ? $array['childs'] : [$array['parent']];
            foreach($locations_tmp as $location) {
                $person_id = get_term_meta($location->term_id, "contact_person_jobs", true);
                if(empty($person_id) && $location->parent > 0) $person_id = get_term_meta($location->parent, "contact_person_jobs", true);
                if(empty($person_id)) continue;
                $persons = $pd->getPersons(['id' => $person_id]) ?? null;
                $locations_persons[$location->term_id] = $persons;
            }
        }

        $template = $args['template'] ?? 'persons_locations';
        return CustomTemplate::getInstance()->get_template_content('theme/person/'.$template,['locations' => $locations, 'locations_persons' => $locations_persons, 'args' => $args]);

    }

    /**
     * @param $job
     * @param $args
     * @return false|string
     */
    public function draw_job_image($job, $args) {
        if(!is_array($args)) $args = [];
        $defaults = ['layout' => 'select'];
        $args = array_merge($defaults, $args);

        $template = $args['template'] ?? 'image.php';
        return CustomTemplate::getInstance()->get_template_content('theme/job/'.$template,['job' => $job, 'args' => $args]);
    }

    public function draw_job_tags($job, $args) {
        if(!is_array($args)) $args = [];
        $defaults = [];
        $args = array_merge($defaults, $args);

        $template = $args['template'] ?? 'tags.php';
        return CustomTemplate::getInstance()->get_template_content('theme/job/'.$template,['job' => $job, 'args' => $args]);
    }


}