<?php
/**
 * Created by PhpStorm.
 * User: dxPro
 * Date: 08/01/16
 * Time: 09:47
 */

namespace DXIM\theme;

class LocationSchema {

    private $location = null;
    private $parent = null;

    public function __construct($location) {
        $this->location = $location;
        $this->parent = get_term($location->parent, Location::$taxonomy);
    }

    public function create() {

        $data = [
            '@context' => "https://schema.org",
            '@type' => "AutomotiveBusiness",
            "name" => $this->parent->name,
            "address" => $this->_get_address(),
            "telephone" => $this->_get_phone(),
            "url" => get_term_link($this->location->term_id)
        ];

        return $data;
    }

    private function _get_address() {
        $location = $this->location;
        $data[] = [
            "@type" => "PostalAddress",
            "streetAddress" => get_term_meta($location->term_id, "street", true),
            "addressLocality" => get_term_meta($location->term_id, "city", true),
            "postalCode" => get_term_meta($location->term_id, "zipcode", true),
            "addressCountry" => "DE",
        ];

        return $data;
    }

    private function _get_phone() {
        $base = get_term_meta($this->location->term_id, "phone_base", true);
        if(empty($base)) return null;

        if(substr($base,0,4) != "0049" && substr($base,0,3) !== "+49" && substr($base,0,1) == "0") {
            $base = "+49".substr($base,1);
        }

        $nr = get_term_meta($this->location->term_id, "phone", true);
        $phone = $base.$nr;
        return $phone;
    }

}