<?php

/**
 * Created by PhpStorm.
 * User: dx
 * Date: 2019-04-03
 * Time: 10:11
 */

namespace DXIM\theme;


use DXIM\CustomTemplate;

class ModelShortcode {

    protected static $instance = null;


    /**
     *
     * @return ModelShortcode
     */
    public static function getInstance() {
        if (self::$instance === null) {
            self::$instance = new self;
        }
        return self::$instance;
    }

    /**
     *
     */
    private function __construct() {
    }

    public function init() {
        // Darstellung von Personen zu einem Modell
        add_shortcode("WPCS_model_team", [&$this, '_draw_team']);

        // Darstellung Model Titel inkl. Marke
        add_shortcode("WPCS_model_title", [&$this, '_draw_title']);

        //
        add_shortcode('WPCS_model_image', [&$this, '_draw_image']);

        add_shortcode('WPCS_model_tags', [&$this, '_draw_tags']);

        // Darstellung Model Titel inkl. Marke
        add_shortcode("WPCS_model_selection", [&$this, '_draw_selection']);

        // Darstellung Angebote zu einem Model
        add_shortcode("WPCS_model_offers", [&$this, '_draw_offers']);

        // Darstellung Lagerfahrzeuge per WPCS_cars
        add_shortcode("WPCS_model_cars", [&$this, '_draw_cars']);
        add_shortcode("WPCS_model_cars_link", [&$this, '_draw_cars_link']);

        add_shortcode("WPCS_model_mandatory_text", [&$this, '_draw_mandatory_text']);
    }

    /**
     * @param $args
     * @return int|mixed|\WP_Post|null
     */
    private function _get_model($args) {
        $model = null;
        if (!empty($args['id'])) {
            $d = new ModelData();
            $model = $d->getById($args['id']);
        } else $model = Model::getInstance()->getCurrent();
        return $model;
    }

    public function _draw_team($args) {
        $model = $this->_get_model($args);
        return ModelTemplate::getInstance()->draw_team($model, $args);
    }

    public function _draw_title($args) {
        $model = $this->_get_model($args);
        return ModelTemplate::getInstance()->draw_title($model, $args);
    }

    public function _draw_image($args) {
        $model = $this->_get_model($args);
        return ModelTemplate::getInstance()->draw_image($model, $args);
    }

    public function _draw_tags($args) {
        $model = $this->_get_model($args);
        return ModelTemplate::getInstance()->draw_tags($model, $args);
    }

    public function _draw_selection($args) {
        if (!is_array($args)) $args = [];

        // Brand anhand des globalen Models holen
        if (!isset($args['brand_id'])) {
            $model = $this->_get_model($args);
            if (empty($model)) return "Bitte brand_id - Parameter angeben";
            $md = new ModelData();
            $brand = $md->get_brand($model->ID);
            $args['brand_id'] = $brand->term_id ?? 0;
        }

        return ModelTemplate::getInstance()->draw_selection($args);
    }

    public function _draw_mandatory_text($args) {
        $model = $this->_get_model($args);
        return ModelTemplate::getInstance()->draw_mandatory_text($model, $args);
    }

    public function _draw_offers($args) {
        $model = $this->_get_model($args);
        return ModelTemplate::getInstance()->draw_offers($model, $args);
    }

    public function _draw_cars($args) {
        $model = $this->_get_model($args);
        return ModelTemplate::getInstance()->draw_cars($model, $args);
    }

    public function _draw_cars_link($args) {
        $model = $this->_get_model($args);
        return ModelTemplate::getInstance()->draw_cars_link($model, $args);
    }
}
