<?php
/**
 * Created by PhpStorm.
 * User: dx
 * Date: 2019-04-03
 * Time: 10:11
 */

namespace DXIM\theme;

class OfferShortcode {

	protected static $instance = null;


	/**
	 *
	 * @return OfferShortcode
	 */
	public static function getInstance() {
		if(self::$instance === null) {
			self::$instance = new self;
		}
		return self::$instance;
	}

	/**
	 *
	 */
	private function __construct() {}

    /**
     * @return void
     */
    public function init() {
        add_shortcode("WPCS_offer_filter_payments", [&$this,'_draw_filter_payments']);
        add_shortcode("WPCS_offer_filter_tags", [&$this,'_draw_filter_tags']);

        add_shortcode("WPCS_offer_team", [&$this,'_draw_team']);
        add_shortcode("WPCS_offer_mandatory_text", [&$this,'_draw_mandatory_text']);
        add_shortcode("WPCS_offer_image", [&$this,'_draw_image']);
        #add_shortcode("WPCS_offer_title", [&$this,'_draw_title']);
        add_shortcode("WPCS_offer_prices", [&$this,'_draw_prices']);
        add_shortcode("WPCS_offers", [&$this,'_draw_offers']);
        add_shortcode("WPCS_offer_price", [&$this,'_draw_price']);
        add_shortcode("WPCS_offer_leasing", [&$this,'_draw_leasing']);
        add_shortcode("WPCS_offer_financing", [&$this,'_draw_financing']);

        add_shortcode("WPCS_offers_archive", [&$this,'_draw_offers_archive']);
    }


    private function _get_offer($args) {
        $offer = null;
        if(!empty($args['id'])) {
            $d = new OfferData();
            $offer = $d->getById($args['id']);
        } else $offer = Offer::getInstance()->getCurrent();
        return $offer;
    }

    /**
     * @param $args
     * @return false|string
     */
    public function _draw_offers($args) {
        $od = new OfferData();
        $tag = [];
        if(!is_array($args)) $args = [];

        // GET FIlter auswerten
        if(isset($_GET['filter_tag'])) {
            foreach($_GET['filter_tag'] as $group => $tags) {
                $tag[$group] = $tags;
            }
        }

        // Tags die als Parameter übergeben wurden auswerten
        if(is_array($args)) {
            foreach($args as $key => $value) {
                if(strpos($key, "tag_group_") !== false) {
                    $group_name = str_replace("tag_group_", "", $key);
                    $tag[$group_name] = $value;
                    unset($args[$key]);
                }
            }

            if(isset($args['tag'])) {
                $tag['default'] = $args['tag'];
            }

        }

        $args['tag'] = $tag;

        $offers = $od->get_offers($args);

        if(empty($offers)) return "Keine Angebote vorhanden";
        return OfferTemplate::getInstance()->draw_offers($offers, $args);
    }

    public function _draw_offers_archive($args) {
        return OfferTemplate::getInstance()->draw_offers_archive($args);
    }


    public function _draw_team($args) {
        $offer = $this->_get_offer($args);
        return OfferTemplate::getInstance()->draw_team($offer, $args);
    }

    public function _draw_image($args) {
        $offer = $this->_get_offer($args);
        return OfferTemplate::getInstance()->draw_image($offer, $args);
    }

//    public function _draw_title($args) {
//        $offer = $this->_get_offer($args);
//        return OfferTemplate::getInstance()->draw_title($offer, $args);
//    }

    public function _draw_mandatory_text($args) {
        $offer = $this->_get_offer($args);
        return OfferTemplate::getInstance()->draw_mandatory_text($offer, $args);
    }

    public function _draw_prices($args) {
        $offer = $this->_get_offer($args);
        return OfferTemplate::getInstance()->draw_prices($offer, $args);
    }

    public function _draw_price($args) {
        $offer = $this->_get_offer($args);
        return OfferTemplate::getInstance()->draw_price($offer, $args);
    }

    public function _draw_leasing($args) {
        $offer = $this->_get_offer($args);
        return OfferTemplate::getInstance()->draw_leasing($offer, $args);
    }

    public function _draw_financing($args) {
        $offer = $this->_get_offer($args);
        return OfferTemplate::getInstance()->draw_financing($offer, $args);
    }


    public function _draw_filter_payments($args) {
        $active_filters = Offer::getInstance()->get_filter()['payments'] ?? [];

        $html = '<div class="wpcs_theme_filters brands">';
        foreach(Offer::$payments as $key => $array) {
            $html .= '<div class="theme_filter offer_filter payment">';
                $checked = (in_array($array['fieldname'], $active_filters)) ? "checked" : "";
                $html .= '<input type="checkbox" class="wpcs_checkbox" name="wpcs_payment[]" value="'.$array['fieldname'].'" '.$checked.' />';
                $html .= '<span class="label">'.$array['label'].'</span>';
            $html .= '</div>';
        }
        $html .= '</div>';

        return $html;
    }

    public function _draw_filter_tags($args) {
        $tag_string = "";
        $j = new TagData();
        $tags = $j->get_tags_by_meta('is_offer_filter');
        foreach($tags as $tag) {
            $tag_string .= $tag->slug.",";
        }
        return TagShortcode::getInstance()->_draw_filter_tags(['tags' => $tag_string]);
    }


}