<?php
/**
 * Created by PhpStorm.
 * User: dx
 * Date: 2019-04-03
 * Time: 10:11
 */

namespace DXIM\theme;

class OfferGroupShortcode {

	protected static $instance = null;

	/**
	 *
	 * @return OfferGroupShortcode
	 */
	public static function getInstance() {
		if(self::$instance === null) {
			self::$instance = new self;
		}
		return self::$instance;
	}

	/**
	 *
	 */
	private function __construct() {}

    /**
     * @return void
     */
    public function init() {

        add_shortcode("WPCS_offergroups", [&$this,'_offer_groups']);

        add_shortcode("WPCS_offergroup_offers", [&$this,'_draw_offers']);

        add_shortcode('WPCS_offergroup_image', [&$this,'_draw_image']);

        add_shortcode('WPCS_offergroup_description', [&$this,'_draw_content']);

    }

    /**
     * @param $args
     * @return false|string
     */
    public function _offer_groups($args) {
        return OfferGroupTemplate::getInstance()->draw_offer_groups($args);
    }

    /**
     * @param $args
     * @return false|string
     */
    public function _draw_image($args) {
        $term = OfferGroup::getInstance()->get_current();
        return OfferGroupTemplate::getInstance()->draw_image($term, $args);
    }

    /**
     * @param $args
     * @return false|string
     */
    public function _draw_content($args) {
        $term = OfferGroup::getInstance()->get_current();
        return OfferGroupTemplate::getInstance()->draw_content($term, $args);
    }

    /**
     * @param $args
     * @return mixed
     */
    public function _draw_offers($args) {
        return OfferGroupTemplate::getInstance()->draw_offers($args);
    }


}