<?php
/**
 * Created by PhpStorm.
 * User: dx
 * Date: 2019-04-03
 * Time: 10:11
 */

namespace DXIM\theme;


use DXIM\CustomTemplate;

class OfferGroupTemplate {

	protected static $instance = null;


	/**
	 *
	 * @return OfferGroupTemplate
	 */
	public static function getInstance() {
		if(self::$instance === null) {
			self::$instance = new self;
		}
		return self::$instance;
	}

	/**
	 *
	 */
	private function __construct() {}

    public function init() {    }

    public function draw_offer_groups($args) {
        if(!is_array($args)) $args = [];
        $defaults = ['layout' => "grid",'grid' => 3];
        $args = array_merge($defaults, $args);
        $template = $args['template'] ?? $args['layout'];

        $od = new OfferGroupData();
        $offerGroups = $od->getAll();

        return CustomTemplate::getInstance()->get_template_content('theme/offergroup/'.$template, ['offerGroups' => $offerGroups, 'args' => $args]);
    }


    /**
     * @return void
     */
    public function draw_offers($args) {
        if(!is_array($args)) $args = [];
        $defaults = ['layout' => 'grid', 'grid' => 2];
        $args = array_merge($defaults, $args);
        $template = $args['template'] ?? $args['layout'];
        $offers = [];

        while ( have_posts() ) {
            the_post();
            global $post;
            $offers[] = $post;
        }

        return \DXIM\CustomTemplate::getInstance()->get_template_content('theme/offer/'.$template, ['offers' => $offers, 'args' => $args]);

    }


    /**
     * @param $location
     * @param $args
     * @return false|string
     */
    public function draw_image($term, $args = []) {
        $template = $args['template'] ?? 'image';
        return CustomTemplate::getInstance()->get_template_content('theme/offergroup/'.$template, ['term' => $term]);
    }

    public function draw_content($term, $args = []) {
        $template = $args['template'] ?? 'description';
        return CustomTemplate::getInstance()->get_template_content('theme/offergroup/'.$template, ['term' => $term]);
    }

}