<?php
/**
 * Created by PhpStorm.
 * User: dx
 * Date: 2019-04-03
 * Time: 10:11
 */

namespace DXIM\theme;

class Person {

	protected static $instance = null;

    public static $post_type = "wpcs_person";

	/**
	 *
	 * @return Person
	 */
	public static function getInstance() {
		if(self::$instance === null) {
			self::$instance = new self;
		}
		return self::$instance;
	}

	/**
	 *
	 */
	private function __construct() {}

    public function init() {
        if(!WPCS_PRO) return;

        add_action('wp_ajax_wpcs_person_search',[&$this,'_ajax_person_search']);
        add_action('wp_ajax_nopriv_wpcs_person_search',[&$this,'_ajax_person_search']);

        PersonShortcode::getInstance()->init();

        $this->_register_post_type();

    }

    public function _ajax_person_search() {
        $pd = new PersonData();
        $persons = $pd->getPersons(['title' => $_POST['searchstring']]);
        $args = $_POST['args'];

        $response['status'] = 1;
        $response['html'] = PersonTemplate::getInstance()->draw_persons($persons, $args);

        // return JSON
        header('Content-Type: application/json');
        die(json_encode($response));
    }

    public function _register_post_type() {

        $labels = array(
            'name'                  => _x( 'Personen', 'Post Type General Name', 'wpcs' ),
            'singular_name'         => _x( 'Persone', 'Post Type Singular Name', 'wpcs' ),
            'menu_name'             => __( 'Personen', 'wpcs' ),
            'name_admin_bar'        => __( 'Personen', 'wpcs' ),
            'archives'              => __( 'Personen', 'wpcs' ),
            'attributes'            => __( 'Personen Attributes', 'wpcs' ),
            'parent_item_colon'     => __( 'Parent Personen', 'wpcs' ),
            'all_items'             => __( 'Alle Personen', 'wpcs' ),
            'add_new_item'          => __( 'neue Person', 'wpcs' ),
            'add_new'               => __( 'anlegen', 'wpcs' ),
            'new_item'              => __( 'anlegen', 'wpcs' ),
            'edit_item'             => __( 'editieren', 'wpcs' ),
            'update_item'           => __( 'update', 'wpcs' ),
            'view_item'             => __( 'anzeigen', 'wpcs' ),
            'view_items'            => __( 'anzeigen', 'wpcs' ),
            'search_items'          => __( 'suchen', 'wpcs' ),
            'not_found'             => __( 'nicht gefunden', 'wpcs' ),
            'not_found_in_trash'    => __( 'Not found in Trash', 'wpcs' ),
            'featured_image'        => __( 'Featured Image', 'wpcs' ),
            'set_featured_image'    => __( 'Set featured image', 'wpcs' ),
            'remove_featured_image' => __( 'Remove featured image', 'wpcs' ),
            'use_featured_image'    => __( 'Use as featured image', 'wpcs' ),
            'insert_into_item'      => __( 'Insert into item', 'wpcs' ),
            'uploaded_to_this_item' => __( 'Uploaded to this item', 'wpcs' ),
            'items_list'            => __( 'Items list', 'wpcs' ),
            'items_list_navigation' => __( 'Items list navigation', 'wpcs' ),
            'filter_items_list'     => __( 'Filter items list', 'wpcs' ),
        );


        $args = array(
            'label'                 => __( 'Personen', 'wpcs' ),
            'description'           => __( 'Personen', 'wpcs' ),
            'labels'                => $labels,
            'supports'              => array( 'title', 'thumbnail' ),
            'taxonomies'            => array( 'wpcs_division' ),
            'hierarchical'          => false,
            'public'                => false,
            'show_ui'               => true,
            'show_in_menu'          => false,
            'menu_position'         => 5,
            'show_in_admin_bar'     => true,
            'show_in_nav_menus'     => true,
            'can_export'            => true,
            'has_archive'           => false,
            'exclude_from_search'   => false,
            'publicly_queryable'    => true,
            'rewrite'               => null,
            'capability_type'       => 'page',
        );

        register_post_type( self::$post_type, $args );

    }

}