<?php
/**
 * Created by PhpStorm.
 * User: dx
 * Date: 2019-04-03
 * Time: 10:11
 */

namespace DXIM\theme;

class PersonShortcode {

	protected static $instance = null;


	/**
	 *
	 * @return PersonShortcode
	 */
	public static function getInstance() {
		if(self::$instance === null) {
			self::$instance = new self;
		}
		return self::$instance;
	}

	/**
	 *
	 */
	private function __construct() {}

    public function init() {
        // Darstellung bestimmter Personen
        add_shortcode("WPCS_persons", [&$this,'_draw_persons']);

        // Darstellung bestimmter Personen getrennt nach Standorten
        add_shortcode("WPCS_persons_locations", [&$this,'_draw_persons_locations']);

        // Darstellung von Personen zu einem zugehörigen Fahrzeug (keine Parameter notwendig)
        add_shortcode("WPCS_persons_vehicle", [&$this,'_draw_persons_vehicle']);

        // Volltextsuche nach Personen
        add_shortcode('WPCS_person_search', [&$this,'_draw_person_search']);

    }


    /**
     * zeigt bestimmte Personen an
     * @param $args
     * @return false|string
     */
    public function _draw_persons($args) {
        if(!is_array($args)) $args = [];
        $pd = new PersonData();
        $persons = $pd->getPersons($args);

        // draw person by given slug
        return PersonTemplate::getInstance()->draw_persons($persons, $args);
    }

    /**
     * @param $args
     * @return string
     */
    public function _draw_person_search($args) {
        if(!is_array($args)) $args = [];
        return PersonTemplate::getInstance()->draw_person_search($args);
    }


    /**
     * @param $args
     * @return false|string
     */
    public function _draw_persons_locations($args) {
        if(!is_array($args)) $args = [];

        // draw person by given slug
        return PersonTemplate::getInstance()->draw_persons_locations($args);
    }

    /**
     * zeigt Personen zu einem Fahrzeug an
     * @param $args
     * @return null
     */
    public function _draw_persons_vehicle($args) {
        $pd = new PersonData();
        $settings = Theme::getInstance()->get_settings("vehicle")['person_query'];

        if(intval($settings['location']) > 0) {
            $vehicle = dxim_get_vehicle();
            $settings['location'] = $vehicle->dxim_meta['ad_location'][0] ?? 0;
        }

        $persons = $pd->getPersons($settings);
        $html = '<div id="wpcs_vehicle_persons">';
            foreach($persons as $person) {
                $html .= PersonTemplate::getInstance()->draw_person($person, $args);
            }
        $html .= '</div>';

        return $html;
    }

}