<?php
/**
 * Created by PhpStorm.
 * User: dx
 * Date: 2019-04-03
 * Time: 10:11
 */

namespace DXIM\theme;


use DXIM\CustomTemplate;
use DXIM\Html;

class PersonTemplate {

	protected static $instance = null;


	/**
	 *
	 * @return PersonTemplate
	 */
	public static function getInstance() {
		if(self::$instance === null) {
			self::$instance = new self;
		}
		return self::$instance;
	}

	/**
	 *
	 */
	private function __construct() {}

    public function init() {    }


    /**
     * Darstellung mehrerer Personen
     * @param $persons
     * @param $args
     * @return false|string
     */
    public function draw_persons($persons, $args = []) {
        if(!is_array($args)) $args = [];
        $defaults = ['layout' => 'grid', 'grid' => 3];
        $args = array_merge($defaults, $args);

        $template = $args['template'] ?? "persons_".$args['layout'];
        return CustomTemplate::getInstance()->get_template_content('theme/person/'.$template, ['persons' => $persons, 'args' => $args]);
    }

    /**
     * @param $args
     * @return false|string
     */
    public function draw_person_search($args) {
        if(!is_array($args)) $args = [];
        $defaults = ['placeholder' => "Suche Ansprechpartner", 'grid' => 3];
        $args = array_merge($defaults, $args);
        $args['type'] = "wpcs_person_search";

        return Html::textsearch($args);
    }

    /**
     * @param $persons
     * @param $args
     * @return false|string
     */
    public function draw_persons_locations($args) {
        if(!is_array($args)) $args = [];
        $defaults = ['layout' => 'grid', 'grid' => 2, 'hide_location' => null];
        $args = array_merge($defaults, $args);

        $pd = new PersonData();
        $persons = $pd->getPersons($args);

        #wpcs_p($locations);
        $location_ids = [];
        foreach($persons as $person) {
            $term = $pd->get_location($person->ID);
            if(!$term instanceof \WP_Term) continue;
            $locations_persons[$term->term_id][] = $person;
            if(!in_array($term->term_id, $location_ids)) $location_ids[] = $term->term_id;
        }

        $ld = new LocationData();
        $locations = $ld->getTree(['include' => $location_ids]);

        $template = $args['template'] ?? 'persons_locations';
        return CustomTemplate::getInstance()->get_template_content('theme/person/'.$template,['locations' => $locations, 'locations_persons' => $locations_persons, 'args' => $args]);
    }

    /**
     * Darstellung der eigentlichen einzelnen Person
     * @param \WP_Post $person
     * @param $args
     * @return false|string
     */
    public function draw_person(\WP_Post $person, $args = []) {
        if(!is_array($args)) $args = [];
        $settings = Theme::getInstance()->get_settings('person');
        $defaults = ['layout' => 'horizontal'];
        $settings = array_merge($defaults, $settings);
        $args = array_merge($settings, $args);

        $pd = new PersonData();
        $meta = $pd->get_meta($person->ID);

        $template = $args['template'] ?? 'grid.php';
        return CustomTemplate::getInstance()->get_template_content('theme/person/loop_'.$template, ['person' => $person, 'meta' => $meta, 'args' => $args]);
    }


}