<?php

/**
 * Created by PhpStorm.
 * User: dx
 * Date: 2019-04-03
 * Time: 10:11
 */

namespace DXIM\theme;

class ServiceShortcode {

    protected static $instance = null;


    /**
     *
     * @return ServiceShortcode
     */
    public static function getInstance() {
        if (self::$instance === null) {
            self::$instance = new self;
        }
        return self::$instance;
    }

    /**
     *
     */
    private function __construct() {
    }

    /**
     * @return void
     */
    public function init() {

        add_shortcode("WPCS_service_image", [&$this, '_draw_image']);
        add_shortcode("WPCS_service_team", [&$this, '_draw_team']);
        add_shortcode("WPCS_services", [&$this, '_draw_services']);
    }


    private function _get_service($args) {
        $service = null;
        if (!empty($args['id'])) {
            $d = new ServiceData();
            $service = $d->getById($args['id']);
        } else $service = Service::getInstance()->getCurrent();
        return $service;
    }

    /**
     * @param $args
     * @return false|string
     */
    public function _draw_services($args) {
        $od = new ServiceData();
        if (!is_array($args)) $args = [];

        $services = $od->get_services($args);

        if (empty($services)) return "Keine Services vorhanden";
        return ServiceTemplate::getInstance()->draw_services($services, $args);
    }

    public function _draw_image($args) {
        $service = $this->_get_service($args);
        return ServiceTemplate::getInstance()->draw_image($service, $args);
    }

    public function _draw_team($args) {
        $service = $this->_get_service($args);
        return ServiceTemplate::getInstance()->draw_team($service, $args);
    }

    public function _draw_service_types($args) {
        $service = Service::getInstance()->getCurrent();
        return ServiceTemplate::getInstance()->draw_service_types($job, $args);
    }
}
