<?php

/**
 * Created by PhpStorm.
 * User: dx
 * Date: 2019-04-03
 * Time: 10:11
 */

namespace DXIM\theme;


use Cassandra\Custom;
use DXIM\Admin;
use DXIM\CustomTemplate;
use DXIM\Session;
use DXIM\VehicleFilter;

class ServiceTemplate {

    protected static $instance = null;


    /**
     *
     * @return ServiceTemplate
     */
    public static function getInstance() {
        if (self::$instance === null) {
            self::$instance = new self;
        }
        return self::$instance;
    }

    /**
     *
     */
    private function __construct() {
    }

    public function init() {
    }

    /**
     * @param $service
     * @param $args
     * @return false|string
     */
    public function draw_services($services, $args = []) {
        if (!is_array($args)) $args = [];
        $defaults = ['layout' => 'grid', 'grid' => 3];
        $args = array_merge($defaults, $args);
        $template = $args['template'] ?? $args['layout'];

        return CustomTemplate::getInstance()->get_template_content('theme/service/' . $template, ['services' => $services, 'args' => $args]);
    }

    /**
     * @param $service
     * @param $args
     * @return false|string
     */
    public function draw_image($service, $args) {
        if (!is_array($args)) $args = [];

        $template = $args['template'] ?? 'image.php';
        return CustomTemplate::getInstance()->get_template_content('theme/service/' . $template, ['service' => $service]);
    }

    /**
     * @param $offer
     * @param $args
     * @return false|string
     */
    public function draw_team($service, $args = []) {
        if(!is_array($args)) $args = [];
        $defaults = [];
        $settings = Theme::getInstance()->get_settings('service');
        $settings = array_merge($defaults, $settings);
        $args = array_merge($settings, $args);

        // get brand
        $sd = new ServiceData();
        $locations = $sd->get_locations($service->ID);
        $location_ids = [];
        foreach($locations as $location) {
            $location_ids[] = $location->term_id;
        }

        $ld = new LocationData();
        $query_args = ['include' => $location_ids];
        $locations = $ld->getTree($query_args);

        $pd = new PersonData();
        $locations_persons = [];
        foreach($locations as $array) {
            $locations_tmp = !empty($array['childs']) ? $array['childs'] : [$array['parent']];
            foreach($locations_tmp as $location) {
                $query = [
                    'location' => $location->term_id,
                    'division' => $settings['person_query']['division'],
                    'count' => $settings['person_query']['count'],
                    'random' => $settings['person_query']['random']
                ];

                $persons = $pd->getPersons($query) ?? null;
                $locations_persons[$location->term_id] = $persons;
            }
        }

        $template = $args['template'] ?? 'persons_locations';
        return CustomTemplate::getInstance()->get_template_content('theme/person/'.$template,['locations' => $locations, 'locations_persons' => $locations_persons, 'args' => $args]);
    }
}