<?php
/**
 * Created by PhpStorm.
 * User: dx
 * Date: 2019-04-03
 * Time: 10:11
 */

namespace DXIM\theme;


class Tag {

	protected static $instance = null;

    public static $taxonomy = "wpcs_tag";

    protected $filter = null;

	/**
	 *
	 * @return Tag
	 */
	public static function getInstance() {
		if(self::$instance === null) {
			self::$instance = new self;
		}
		return self::$instance;
	}

	/**
	 *
	 */
	private function __construct() {

	}

    /**
     * @return void
     */
    public function init() {
        if(!WPCS_PRO) return;

        $this->_register_taxonomy();

        TagShortcode::getInstance()->init();

        $this->filter = [];
        if(isset($_GET['filter_tag'])) $this->filter = $_GET['filter_tag'];

    }

    public function get_filter() { return $this->filter; }


    function _register_taxonomy() {

        $labels = array(
            'name'                       => _x( 'Tags', 'Taxonomy General Name', 'wpcs' ),
            'singular_name'              => _x( 'Tag', 'Taxonomy Singular Name', 'wpcs' ),
            'menu_name'                  => __( 'Tags', 'wpcs' ),
            'all_items'                  => __( 'Alle Tags', 'wpcs' ),
            'parent_item'                => __( 'Parent Tag', 'wpcs' ),
            'parent_item_colon'          => __( 'Parent Tag:', 'wpcs' ),
            'new_item_name'              => __( 'neuer Tag', 'wpcs' ),
            'add_new_item'               => __( 'neue Tags', 'wpcs' ),
            'edit_item'                  => __( 'Tag bearbeiten', 'wpcs' ),
            'update_item'                => __( 'Tag editieren', 'wpcs' ),
            'view_item'                  => __( 'Tag anzeigen', 'wpcs' ),
            'separate_items_with_commas' => __( 'Separate items with commas', 'wpcs' ),
            'add_or_remove_items'        => __( 'Add or remove items', 'wpcs' ),
            'choose_from_most_used'      => __( 'Choose from the most used', 'wpcs' ),
            'popular_items'              => __( 'Popular Items', 'wpcs' ),
            'search_items'               => __( 'Search Items', 'wpcs' ),
            'not_found'                  => __( 'Not Found', 'wpcs' ),
            'no_terms'                   => __( 'No items', 'wpcs' ),
            'items_list'                 => __( 'Items list', 'wpcs' ),
            'items_list_navigation'      => __( 'Items list navigation', 'wpcs' ),
        );

        $args = array(
            'labels'                     => $labels,
            'hierarchical'               => false,
            'public'                     => false,
            'show_ui'                    => true,
            'show_admin_column'          => true,
            'show_in_nav_menus'          => true,
            'show_tagcloud'              => true,
        );
        register_taxonomy( self::$taxonomy, array( Offer::$post_type, Model::$post_type, Job::$post_type ), $args );

    }

}