<?php
/**
 * Created by PhpStorm.
 * User: dx
 * Date: 2019-04-03
 * Time: 10:11
 */

namespace DXIM\theme;

class TagShortcode {

	protected static $instance = null;


	/**
	 *
	 * @return TagShortcode
	 */
	public static function getInstance() {
		if(self::$instance === null) {
			self::$instance = new self;
		}
		return self::$instance;
	}

	/**
	 *
	 */
	private function __construct() {}

    /**
     * @return void
     */
    public function init() {
        add_shortcode("WPCS_tag_filter", [&$this,'_draw_filter_tags']);
    }

    /**
     * @param $args
     * @return void
     */
    public function _draw_filter_tags($args) {
        if(!is_array($args)) $args = [];
        $defaults = ['tags' => "", "group" => "default"];
        $args = array_merge($defaults, $args);
        $tag_filter = explode(",", $args['tags']);
        $html = null;

        if(empty($tag_filter[0])) return "Keine Tags angegeben";

        $td = new \DXIM\theme\TagData();
        $tags = $td->getAll();
        $all_active_filters = Tag::getInstance()->get_filter() ?? [];
        $active_filters = $all_active_filters[$args['group']] ?? [];
        if(!empty($tags)) {
            $html .= '<div class="wpcs_theme_filters tags">';
            foreach($tags as $tag) {
                if(!empty($tag_filter[0]) && !in_array($tag->slug, $tag_filter)) continue;

                $html .= '<div class="theme_filter tag_filter tag">';
                    $checked = (in_array($tag->term_id, $active_filters)) ? "checked" : "";
                    $html .= '<input type="checkbox" class="wpcs_checkbox" name="filter_tag['.$args['group'].'][]" value="'.$tag->term_id.'" '.$checked.' />';
                    $html .= '<span class="label">'.$tag->name.'</span>';
                $html .= '</div>';
            }
            $html .= '</div>';
        }

        return $html;
    }


}