<?php

use DXIM\VehicleHtml;

/**
 * @param $array
 */
function wpcs_p($array, $return = false) {
    $html = "<pre>";
    $html .= print_r($array, true);
    $html .= "</pre>";

    if(!$return) print $html;
    else return $html;
}

/**
 * Vehicle Archive
 */

// display pagination on archive page
function dxim_pagination() { return \DXIM\Html::pagination(); }

// Anzahl der Treffer einer Fahrzeugsuche
function dxim_vehicleCount($args = []) { return \DXIM\VehicleHtml::drawVehicleCount($args); }


/**
 * Vehicle Single
 */

// Display Vehicle in single-vehicle.php with default Layout
function dxim_vehicleSingle() { return \DXIM\Template::drawVehicleSingle(); }


/**
 * Filter Form functions
 */

// create single filter form element
function dxim_createFilterFormElement($args) { return \DXIM\VehicleFilter::getInstance()->createFilterFormElement($args); }

// create filter form order element
function dxim_createOrder($args = []) { return \DXIM\VehicleFilter::getInstance()->createOrder($args); }

function dxim_createOrderby($args = []) { return \DXIM\VehicleFilter::getInstance()->createOrderBy($args); }

// create filter form
function dxim_createFilterForm($html, $args = null) { return \DXIM\VehicleFilter::getInstance()->createFilterForm($html, $args); }

// display vehicle filter/search form
function dxim_vehicleFilterForm($args = []) { return \DXIM\VehicleFilter::getInstance()->drawFilterForm($args); }

// Order Bar entkoppelt vom Filter Form
function dxim_vehicleOrderBar($args = []) { return \DXIM\VehicleFilter::getInstance()->drawOrderBar($args); }

// zurück Button Url
function dxim_getBackButtonUrl() { \DXIM\Html::getBackButtonUrl(); }


/**
 * FAHRZEUGDATEN ABRUFEN
 */

// liefert das aktuelle Fahrzeug
function dxim_get_vehicle() { return \DXIM\VehicleData::getVehicle(); }

// liefert den wert eines Custom Fields zum aktuell angezeigten Fahrzeug
function dxim_get_vehicle_cf_value($key, \WP_Post $vehicle = null) {
    if($vehicle == null) $vehicle = dxim_get_vehicle();
    return \DXIM\VehicleCF::getInstance()->getValue($vehicle, $key);
}

/**
 * SINGLE
 */
function dxim_single_title() { return \DXIM\VehicleHtml::drawVehicleTitle(\DXIM\VehicleData::getVehicle()); }

function dxim_single_images($args) { return \DXIM\VehicleHtml::drawVehicleImages(\DXIM\VehicleData::getVehicle(),$args); }
function dxim_single_image($args) { return \DXIM\VehicleHtml::drawVehicleImage(\DXIM\VehicleData::getVehicle(), $args); }
function dxim_single_video($atts) { return \DXIM\VehicleHtml::drawVehicleVideo(\DXIM\VehicleData::getVehicle(),$atts); }

function dxim_single_buttons($args) { return \DXIM\VehicleHtml::drawVehicleButtons(\DXIM\VehicleData::getVehicle(),$args); }
function dxim_single_button($args) { return \DXIM\VehicleHtml::drawVehicleButton(\DXIM\VehicleData::getVehicle(),$args); }


function dxim_single_data($fields = []) {
    $fields = !empty($fields) ? $fields : 'single';
    return \DXIM\VehicleHtml::drawVehicleSpecifics(\DXIM\VehicleData::getVehicleFields(\DXIM\VehicleData::getVehicle(), $fields));
}

function dxim_single_features($args) { return \DXIM\VehicleHtml::drawVehicleFeatures(\DXIM\VehicleData::getVehicleFeatures(\DXIM\VehicleData::getVehicle()),$args); }

function dxim_single_contact() { return \DXIM\VehicleHtml::drawVehicleContact(\DXIM\VehicleData::getVehicle()); }

function dxim_single_form() { return \DXIM\VehicleHtml::drawVehicleForm(\DXIM\VehicleData::getVehicle()); }

function dxim_single_content() { return \DXIM\VehicleHtml::drawVehiclePostContent(\DXIM\VehicleData::getVehicle()); }

function dxim_single_emission($args = []) { return \DXIM\VehicleHtml::drawVehicleEmission(\DXIM\VehicleData::getVehicle(), $args); }

function dxim_single_emission_data($args = []) { return \DXIM\VehicleHtml::drawVehicleEmissionData(\DXIM\VehicleData::getVehicle(), $args); }

function dxim_single_eec_image($args = []) { return \DXIM\VehicleHtml::drawVehicleEecImage(\DXIM\VehicleData::getVehicle(), $args); }

function dxim_single_price() { return \DXIM\VehicleHtml::drawVehiclePrice(\DXIM\VehicleData::getVehicle()); }

function dxim_single_price_rating() { return \DXIM\VehicleHtml::drawVehiclePriceRating(\DXIM\VehicleData::getVehicle()); }

function dxim_single_financing() { return \DXIM\VehicleHtml::drawVehicleFinancing(\DXIM\VehicleData::getVehicle()); }

function dxim_single_leasing() { return \DXIM\VehicleHtml::drawVehicleLeasing(\DXIM\VehicleData::getVehicle()); }

function dxim_single_highlights() { return \DXIM\VehicleHtml::drawVehicleHighlights(\DXIM\VehicleData::getVehicle()); }

function dxim_single_compare_button($args) { return VehicleHtml::drawCompareButton($args); }

/**
 * Archive
 */
// link to vehicle
function dxim_archive_link() { return get_permalink(); }
// title
function dxim_archive_title() { return DXIM\VehicleHtml::drawVehicleArchiveTitle(\DXIM\VehicleData::getVehicle()); }
// image
function dxim_archive_image($args = []) { return \DXIM\VehicleHtml::drawVehicleArchiveImage(\DXIM\VehicleData::getVehicle(), $args); }
// data
function dxim_archive_data() { return \DXIM\VehicleHtml::drawVehicleArchiveSpecifics(\DXIM\VehicleData::getVehicle()); }
// emission
function dxim_archive_emission($args = []) { return \DXIM\VehicleHtml::drawVehicleArchiveEmission(\DXIM\VehicleData::getVehicle(),$args); }
// eec image
function dxim_archive_eec_image($args = []) { return \DXIM\VehicleHtml::drawVehicleEecImage(\DXIM\VehicleData::getVehicle(),$args); }
// price
function dxim_archive_price() { return \DXIM\VehicleHtml::drawVehicleArchivePrice(\DXIM\VehicleData::getVehicle()); }
// price rating
function dxim_archive_price_rating() { return \DXIM\VehicleHtml::drawVehiclePriceRating(\DXIM\VehicleData::getVehicle()); }
//highlights
function dxim_archive_highlights() { return \DXIM\VehicleHtml::drawVehicleHighlights(\DXIM\VehicleData::getVehicle()); }
// buttons
function dxim_archive_buttons() { return \DXIM\VehicleHtml::drawVehicleArchiveButtons(\DXIM\VehicleData::getVehicle()); }


/**
 * ContactForm API
 */
function wpcs_contactform_draw_fields() { return DXIM\Form::getInstance()->_draw_fields(); }
function wpcs_contactform_draw_field($key) { return DXIM\Form::getInstance()->_draw_field($key); }
//function wpcs_contactform_draw_vehicle($fields) {
//    $vehicle = dxim_get_vehicle();
//    return DXIM\Form::getInstance()->_draw_vehicle_fields($vehicle, $fields);
//}
function wpcs_contactform_draw_captcha() { return DXIM\Form::getInstance()->_draw_captcha(); }
function wpcs_contactform_draw_context() { return DXIM\Form::getInstance()->_draw_context(); }
function wpcs_contactform_draw_privacy() { return DXIM\Form::getInstance()->_draw_privacy(); }
function wpcs_contactform_draw_location() { return DXIM\Form::getInstance()->_draw_location(); }
function wpcs_contactform_draw_submit() { return DXIM\Form::getInstance()->_draw_submit(); }

/**
 * Footnotes API
 */
function wpcs_offer_footnotes($offer_id, $categories = []) {
    return \DXIM\theme\OfferTemplate::getInstance()->draw_footnotes($offer_id, $categories);
}