var wpcs_global_filters = null;
var wpcs_filters = null;
var wpcs_fields = null;
var wpcs_settings_page = null;
var wpcs_last_sync_check = null;

(function($) {

    $(function() {

        // settings page
        wpcs_settings_page = new WPCSSettingsPage();

        // init global filters
        wpcs_global_filters = new WPCSGlobalFilters();

        // init Filters
        wpcs_filters = new WPCSFilters();

        wpcs_fields = new WPCSFields();

        $('#wpcs_admin_menu .content_section').click(function(e) {
            e.stopPropagation();

            let section_slug = $(this).data('section');
            let slug = $(this).data('slug');
            if(slug == undefined) slug = section_slug;

            admin_menu_go_to(section_slug, slug);
        });

        $('#wpcs_admin_menu .menu_anchor').click(function(e) {
            let active = $(this).hasClass('active');
            $('#wpcs_admin_menu > li').removeClass('active');

            if(active) $(this).removeClass('active');
            else $(this).addClass('active');
        });

        $('.admin_menu_go_to').click(function(e) {
            e.preventDefault();
            let section_slug = $(this).data('section');
            let slug = $(this).data('slug');

            admin_menu_go_to(section_slug, slug);
        });

        function admin_menu_go_to(section_slug, slug) {
            let target = section_slug+"_"+slug;

            $('#wpcs_admin_settings section').hide();
            $('#wpcs_admin_menu li').removeClass('active');

            $('#wpcs_admin_menu li.is_section[data-section='+section_slug+']').addClass('active');
            $('#wpcs_admin_menu li.is_item[data-slug='+slug+']').addClass('active');
            $('#wpcs_admin_settings section.'+target).fadeIn();

            $('#wpcarsync_admin_form input[name=section_slug]').val(section_slug);
            $('#wpcarsync_admin_form input[name=slug]').val(slug);
        }


        window.setInterval(function() {
            jQuery.ajax({
                method : 'POST',
                url : wpcs_ajax_url,
                data : { action : 'checkSyncStatus' },
                success : function(data) {
                    var sync_active_div = jQuery('#wpcs_sync_status');
                    var sync_inactive_div = jQuery('#wpcs_last_sync_status');

                    if(data.sync_active == 1) {

                        var old_val = parseInt(jQuery('.wpcs_import_active_text',sync_active_div).html());
                        jQuery('.wpcs_import_active_account_text',sync_active_div).html(data.account);

                        wpcs_animate_counter(old_val, data.vehicles_left,9000);

                        sync_active_div.show();
                        sync_inactive_div.hide();
                    }
                    else {
                        sync_active_div.hide();

                        $('.value', sync_inactive_div).html(data.lastSyncHumanTime);
                        sync_inactive_div.show();
                    }

                    wpcs_last_sync_check = data.sync_active;
                }
            });
        },10000);

        window.setTimeout(function() {
            $('.wpcs_admin_feedback.feedback').fadeOut();
        },3000);

        jQuery('#toggle_wpcs_import_log').click(function(e) {
            e.preventDefault();
            jQuery('#wpcs_import_log').slideToggle();
        });

        jQuery('#wpcs_ext_log_btn').click(function(e) {
            e.preventDefault();
            jQuery('span.extLog, span.extLog + br', '#wpcs_import_log ').toggle();
        });


        /**
         * WPCS Vehicle Post Type List
         */
        $('.wpcs_toggle_sync').click(function(e) {
            e.preventDefault();

            let link = this;
            let vehicle_id = $(this).attr('data-vehicle-id');
            let mode = $(this).hasClass('active') ? 'deactivate' : 'activate';

            $.ajax({
                method : 'POST',
                url : wpcs_ajax_url,
                data : { action : 'wpcs_toggle_sync', vehicle_id : vehicle_id, mode : mode },
                success : function(data) {

                    if(mode == "deactivate") {
                        $(link).removeClass('active').addClass('inactive');
                        let span = $('span',link);
                        span.html('inaktiv');
                    }
                    else {
                        $(link).removeClass('inactive').addClass('active');
                        let span = $('span',link);
                        span.html('aktiv');
                    }

                }
            });
        });


        $('.wpcs_vehicle_list_csp_create_job').click(function(e) {
            e.preventDefault();
            let vehicle_id = $(this).attr('data-vehicle-id');
            let loader = $(this).next();
            let status = loader.next();

            loader.css('display','inline-block');

            $.ajax({
                method : 'POST',
                url : wpcs_ajax_url,
                data : { action : 'wpcs_csp_create_job', vehicle_id : vehicle_id },
                success : function(data) {
                    loader.hide();
                    if(data.error) {
                        status.html(data.error.msg);
                    } else {
                        status.html("Jobverarbeitung gestartet");
                    }
                    status.show();
                }
            });
        });


        /**
         *
         */
        $('#wpcs_filter_table_meta_box .item').each(function() {
            let container = this;
            let field = $(container).data('field');

            $('.wpcs_filter_table_save_btn', container).click(function(e) {
                e.preventDefault();
                let value = $('input', container).val();
                let post_id = $('#post_ID').val();
                $.ajax({
                    method : 'POST',
                    url : wpcs_ajax_url,
                    data : { action : 'wpcs_filter_table_save', post_id : post_id, value : value, field : field },
                    success : function(data) {
                    }
                });
            });

        });

        /**
         *
         */
        $('#wpcs_add_csv_extended_config_file_btn').click(function(e) {
            e.preventDefault();
            let path = $(this).data('path');
            $('#wpcs_new_csv_config_path').val(path);
        });


        $('a.opener').click(function(e) {
            e.preventDefault();
            var rel = $(this).attr('data-rel');
            $('#'+rel).toggle();
        });


        $( "#active_fields_single, #inactive_fields_single" ).sortable({
            connectWith: ".wpcarsync_connected_fields_single"
        }).disableSelection();

        $( "#active_fields_archive, #inactive_fields_archive" ).sortable({
            //connectWith: ".wpcarsync_connected_fields_archive"
        }).disableSelection();

        $('#active_fields_archive li, #active_fields_single li').each(function() {
            let li = this;
            $('.dashicons', li).click(function() {
                $(li).remove();
            })
        });

        $( ".dxim_filter_column").sortable({
            connectWith: ".dxim_filter_column, #dxim_available_filter"
        }).disableSelection();

        $('.address_config_toggle').click(function(e) {
            if($(this).val() == 'all') {
                $('#address_data_all_wrapper').show();
                $('#address_data_single_wrapper').hide();
            } else {
                $('#address_data_all_wrapper').hide();
                $('#address_data_single_wrapper').show();
            }
        });


        $('#wpcarsync_form_submit_check_license').click(function(e) {
            e.preventDefault();
            setFormData();
            $('#wpcs_check_license_field').val(1);
            // send form
            if(wpcs_filters.somethingChanged) {
                wpcs_settings_page._showLoading("Neuaufbau Filter-Tabelle erforderlich... Bitte warten.");
            }
            $('#wpcarsync_admin_form').submit();
        });

        $('#wpcarsync_form_submit_csp_token').click(function(e) {
            e.preventDefault();
            setFormData();
            $('#wpcs_check_csp_api').val(1);
            // send form
            if(wpcs_filters.somethingChanged) {
                wpcs_settings_page._showLoading("Neuaufbau Filter-Tabelle erforderlich... Bitte warten.");
            }
            $('#wpcarsync_admin_form').submit();
        });


        $('#wpcarsync_form_submit').click(function(e) {
            e.preventDefault();
            setFormData();
            // send form
            if(wpcs_filters.somethingChanged) {
                wpcs_settings_page._showLoading("Neuaufbau Filter-Tabelle erforderlich... Bitte warten.");
            }
            $('#wpcarsync_admin_form').submit();
        });

        function setFormData() {
            // Single Fields auswerten, als form element speichern
            $('.active_fields_single_form_values_wrapper').html('');
            $('#active_fields_single li').each(function() {
                var key = $(this).attr('data-key');
                var hiddenObj = $('<input type="hidden" name="dxim[active_fields_single][]" value="'+key+'" />');
                $('.active_fields_single_form_values_wrapper').append(hiddenObj);
            });

            // Archive Fields auswerten, als form element speichern
            $('.active_fields_archive_form_values_wrapper').html('');
            $('#active_fields_archive li').each(function() {
                var key = $(this).attr('data-key');
                var hiddenObj = $('<input type="hidden" name="dxim[active_fields_archive][]" value="'+key+'" />');
                $('.active_fields_archive_form_values_wrapper').append(hiddenObj);
            });

            // Save vehicle Filters
            $('#vehicle_filters_to_save').html('');
            $('.dxim_filter_column').each(function(e) {
                var nr = $(this).attr('data-column-nr');

                $('li.vehicle_filter',this).each(function() {
                    var filterKey = $(this).attr('data-filter-key');
                    var hiddenObj = $('<input type="hidden" name="dxim[vehicle_filter]['+nr+'][]" value="'+filterKey+'" />');
                    $('#vehicle_filters_to_save').append(hiddenObj);
                });
            });
        }

    });

    function WPCSFields() {

        var that = this;
        this.timeout_id = null;
        this.container = null;

        this._init = function() {

            $('.wpcs_admin_field_search').each(function() {
                let container = this;
                let text = $('input[type=text]', container);

                $(text).keyup(function() {
                    let val = $(this).val();
                    if(val.length < 3) return;

                    that.container = container;

                    if(that.timeout_id !== null) window.clearTimeout(that.timeout_id);
                    that.timeout_id = window.setTimeout(that._fetch_fields,700,val);
                });
            });
        }

        this._fetch_fields = function(string) {
            $('ul li',that.container).remove();
            $('.wpcs_ajax_loader', that.container).addClass('active');

            $.ajax({
                method : 'POST',
                url : wpcs_ajax_url,
                //data : { action : 'handleGlobalFilters', 'todo' : 'fetchFilters' ,val : string, limit : 'specific' },
                data : { action : 'handleGlobalFilters', 'todo' : 'fetchFilters' ,val : string },
                success : function(data) {

                    $.each(data,function(index,item) {
                        let li = $('<li data-key="'+item.key+'" data-label="'+item.label+'"><span class="dashicons dashicons-plus"></span> '+item.label+'</li>');
                        $('ul',that.container).append(li);
                    });

                    //
                    $('ul li', that.container).click(function() {
                        let li = $(this);
                        that._add_field($(this).data('key'), $(this).data('label'));
                        li.remove();
                    });

                    $('.wpcs_ajax_loader', that.container).removeClass('active');
                }
            });
        }

        this._add_field = function(key, label) {
            let li = $('<li data-key="'+key+'" data-value="'+label+'"><span class="dashicons dashicons-no-alt"></span> '+label+'</li>');
            that._init_field(li);
            let selector = $(that.container).data('target');
            $(selector).append(li);
        }

        this._init_field = function(li) {
            $('.dashicons', li).click(function() {
                li.remove();
            })
        }


        this._init();
    }


    /**
     *
     * @constructor
     */
    function WPCSFilters() {

        var that = this;
        this.somethingChanged = false;


        /**
         *
         * @private
         */
        this._init = function() {

            $('#wpcs_filter_search #wpcs_ajax_search_filter').keyup(function() {
                let val = $(this).val();
                if(val.length < 3) return;

                if(that.wpcs_live_search_timeout !== null) window.clearTimeout(that.wpcs_live_search_timeout);
                that.wpcs_live_search_timeout = window.setTimeout(that._fetch_filters,700,val);
            });

            this._initActiveFilters();

            this._initFilterColumns();

        }


        /**
         *
         * @param val
         * @private
         */
        this._fetch_filters = function(val) {

            $('#wpcs_ajax_search_filter_results li').remove();

            $('#wpcs_filter_search .wpcs_ajax_loader').addClass('active');

            $.ajax({
                method : 'POST',
                url : wpcs_ajax_url,
                data : { action : 'handleGlobalFilters', 'todo' : 'fetchFilters' ,val : val },
                success : function(data) {

                    $.each(data,function(index,item) {
                        if($('#wpcs_ajax_search_active_filters .filter_item[data-key='+item.key+']').length < 1) {
                            let li = $('<li data-key="'+item.key+'" data-label="'+item.label+'"><span class="dashicons dashicons-plus"></span> '+item.label+'</li>');
                            $('#wpcs_ajax_search_filter_results').append(li);
                        }
                    })

                    $('#wpcs_ajax_search_filter_results li').click(function() {
                        let li = $(this);
                        that._add_filter($(this).data('key'), $(this).data('label'));
                        li.remove();
                    });

                    $('#wpcs_filter_search .wpcs_ajax_loader').removeClass('active');

                }
            });
        }

        this._add_filter = function (key, label) {
            that.somethingChanged = true;

            var new_item = '<div class="wpcs_active_filter" data-key="'+key+'" data-label="'+label+'">'+
                '<span class="dashicons dashicons-no-alt"></span> '+
                '<span class="label">'+label+'</span>'+
                '<input type="hidden" name="dxim[active_filters][]" value="'+key+'" />'+
                '</div>'
            ;
            var new_filter = $(new_item);
            this._initActiveFilter(new_filter);
            $('#wpcs_filter_definition').append(new_filter);
        }

        this._initFilterColumns = function() {
            $('.dxim_filter_column .vehicle_filter').each(function() {
                that._initFilterColumnItem($(this));
            })
        }

        this._initFilterColumnItem = function(item) {
            $('span.dashicons',item).click(function() {
                item.remove();
            })
        }

        /**
         *
         * @private
         */
        this._initActiveFilters = function() {
            $('#wpcs_filter_definition .wpcs_active_filter').each(function() {
                that._initActiveFilter($(this));
            });
        }

        /**
         *
         * @param item
         * @private
         */
        this._initActiveFilter = function(item) {
            $('span.dashicons', item).click(function() {
                that.somethingChanged = true;
                item.remove();
            });

            $( item ).draggable({
                connectToSortable: ".dxim_filter_column",
                helper : function(e, ui) {
                    let key = $(this).data('key');
                    let label = $(this).data('label');
                    return $('<li class="vehicle_filter" data-filter-key="'+key+'"><span class="dashicons dashicons-no-alt"></span> '+label+'</li>');
                },
                stop : function(e, ui) {
                    ui.helper.css('width', 'auto');

                    that._initFilterColumnItem(ui.helper);
                },
                revert : "invalid"
            }).disableSelection();
        }


        this._init();
    }


    /**
     * Global Filters
     * @constructor
     */
    function WPCSGlobalFilters() {
        var that = this;

        this.wpcs_live_search_timeout = null;
        this.initialized = false;

        this.init = function(){

            if(this.initialized || $('#wpcs_ajax_search_filter').length < 1) return false;

            $('.wpcs_global_filters #wpcs_ajax_search_filter').keyup(function() {
                console.log('global');
                let val = $(this).val();
                if(val.length < 3) return;

                if(that.wpcs_live_search_timeout !== null) window.clearTimeout(that.wpcs_live_search_timeout);
                that.wpcs_live_search_timeout = window.setTimeout(that._fetch_filters,700,val);

            });

            // init global filter selectboxes on load
            $('.wpcsselect','#wpcs_query_meta_box').each(function() {
                that._init_filter($(this));
            });


            $('#wpcs_ajax_search_active_filters .filter_item',).each(function() {
                let filter = $(this);
                $('.delete_filter',filter).click(function() {
                    filter.remove();
                });
            });

            this.initialized = true;
        }

        /**
         *
         * @param val
         * @private
         */
        this._fetch_filters = function(val) {

            $('#wpcs_ajax_search_filter_results li').remove();

            $('.wpcs_global_filters .wpcs_ajax_loader').addClass('active');

            $.ajax({
                method : 'POST',
                url : wpcs_ajax_url,
                data : { action : 'handleGlobalFilters', 'todo' : 'fetchFilters' ,val : val },
                success : function(data) {

                    $.each(data,function(index,item) {
                        if($('#wpcs_ajax_search_active_filters .filter_item[data-key='+item.key+']').length < 1) {
                            let li = $('<li data-key="'+item.key+'"><span class="dashicons dashicons-plus"></span> '+item.label+'</li>');
                            $('#wpcs_ajax_search_filter_results').append(li);
                        }
                    })

                    $('#wpcs_ajax_search_filter_results li').click(function() {
                        let li = $(this);
                        let key = $(this).data('key');
                        that._load_filter(key);
                        li.remove();
                    });

                    $('.wpcs_global_filters .wpcs_ajax_loader').removeClass('active');

                }
            });
        }

        /**
         *
         * @param key
         * @private
         */
        this._load_filter = function(key) {
            $('.wpcs_global_filters .wpcs_ajax_loader').addClass('active');

            $.ajax({
                method : 'POST',
                url : wpcs_ajax_url,
                data : { action : 'handleGlobalFilters', todo : 'loadFilter', key : key, post_id : $('#post_ID').val() },
                success : function(data) {
                    let filter = $(data.html);
                    $('#wpcs_ajax_search_active_filters').append(filter);

                    $('.delete_filter',filter).click(function() {
                        filter.remove();
                    });

                    that._init_filter($('.wpcsselect',filter));

                    $('.wpcs_global_filters .wpcs_ajax_loader').removeClass('active');
                }
            });
        }

        /**
         *
         * @param select
         * @private
         */
        this._init_filter = function(select) {

            if(select.hasClass('ajax')) {
                var field = select.attr('data-field');
                select.wpcsselect({
                    ajax : {
                        url: wpcs_ajax_url,
                        dataType: 'json',
                        method: 'POST',
                        data: function () {
                            var query = {
                                action: 'getData',
                                field : field,
                                load : 'all',
                                filterFormData : that._get_dependents(),
                            };
                            return query;
                        }
                    }
                });
            }

            else {
                select.wpcsselect();
            }
        }

        /**
         *
         * @returns {string}
         * @private
         */
        this._get_dependents = function() {
            var query = '';
            var i = 0;
            $('#wpcs_query_meta_box div.wpcsselect').each(function(){

                let fieldname = $(this).attr('data-field') || null;
                // kein feld in abhängigkeit => ignorieren
                if(fieldname == null) return;

                let value = $('.wpcs_select_value',this).val();
                if(i != 0) query += '&';
                query += fieldname+'='+value;

                i++;
            });

            return query;
        }

        // constructor
        this.init();

    }


    /** ----------------------------------------------------------------------------------------------------------------
     *
     * @constructor
     */
    function WPCSSettingsPage() {

        var that = this;

        this.wrapper = '#address_data_single_wrapper';

        this.__construct = function() {

            $('#wpcs_add_new_location_btn').click(function(e){
                e.preventDefault();
                that.add_location();
            });


            $('.wpcs_location',that.wrapper).each(function() {
                that.init_location(this);
            });

            this._createLoading();

        };

        this._createLoading = function() {
            let loader = $('<div id="wpcs_admin_loading"><div class="wpcs_ajax_loader active"><div class="loading"></div></div><div class="message">Ich bin eine Testnachricht</div></div>');
            $('body').append(loader);
        }

        this._showLoading = function(msg) {
            let text = msg || null;
            $('#wpcs_admin_loading .message').html(text);
            $('#wpcs_admin_loading').show();
            $('.wpcs_ajax_loader', '#wpcs_admin_loading').addClass('active');
        }

        this._hideLoading = function() {
            $('#wpcs_admin_loading .message').html(" ");
            $('#wpcs_admin_loading').hide();
        }

        this.add_location = function() {
            $.ajax({
                method : 'POST',
                url : wpcs_ajax_url,
                data : { action : 'wpcs_add_location' },
                success : function(data){
                    var item = $(data);

                    // neues item hinzufügen
                    $('#address_data_single_wrapper').append(item);

                    // item initialisieren
                    that.init_location(item);
                }
            });
        };


        this.init_location = function(item) {
            $('.location_delete_btn',item).click(function(e) {
                e.preventDefault();
                var location_id = $(this).attr('rel');
                if(confirm('Diesen Standort wirklich löschen?')) { $('#wpcs_location_'+location_id).remove(); }
            });
        };

        this.__construct();
    }

})(jQuery);

/**
 *
 * @param url
 * @param msg
 */
function wpcs_confirm_action(url,msg) {
    if(confirm(msg)) window.location.href = url;
}

function wpcs_animate_counter(start, end, duration) {
    let obj = jQuery('#wpcs_sync_status .wpcs_import_active_text');
    let startTimestamp = null;
    const step = (timestamp) => {
        if (!startTimestamp) startTimestamp = timestamp;
        const progress = Math.min((timestamp - startTimestamp) / duration, 1);
        let value = Math.floor(progress * (end - start) + start);
        obj.html(value); // = value.toLocaleString('de-DE');
        if (progress < 1) {
            window.requestAnimationFrame(step);
        }
    };
    window.requestAnimationFrame(step);
}
