var wpcs_lightbox = null;
var wpcs_form = null;
var wpcs_orderbar = null;
var wpcs_contact_form = null;
var wpcs_compare = null;
var wpcs_park = null;
var wpcs_search_request = null;
var wpcs_infinite_scroll = null;
var wpcs_image_slideshow = null;
var wpcs_textsearch = null;
var wpcs_form_elements = null;

(function($) {

    $(function() {

        // init Filter Form
        wpcs_form = new WPCSForm();

        // init Order Bar
        if($('.dxim_ff_order_bar').length > 0) wpcs_orderbar = new WPCSOrderbar();

        // init Contact Form
        if($('.wpcs_contact_form').length > 0) wpcs_contact_form = new WPCSContactForm();

        // init compare table
        wpcs_compare = new WPCSCompare();

        // textsearch
        //wpcs_textsearch = new WPCSTextSearch();

        // init Search Request
        wpcs_search_request = new WPCSSearchRequest();

        // Vehicle Images Slideshow
        wpcs_image_slideshow = new WPCSImageSlideshow();

        // lightbox
        wpcs_lightbox = new WPCSLightbox();

        // Park
        wpcs_park = new WPCSPark();

        //
        wpcs_infinite_scroll = new WPCSInfiniteScroll();

        //
        wpcs_form_elements = new WPCSFormElements();

        $('.dxim_vehicle_carousel').each(function() {
            let carousel = this;
            let title = 0;
            let data = 0;

            $('.vehicle-on-archive',carousel).each(function() {
                if($('.dxim_archive_specifics',this).height() > data) data = $('.dxim_archive_specifics',this).height();
                if($('.title',this).height() > title) title = $('.title',this).height();
            });
            $('.vehicle-on-archive .title',carousel).css('height',title);
            $('.vehicle-on-archive .dxim_archive_specifics',carousel).css('height',data);

        });

        $('a.wpcs_toggle').click(function(e){
            e.preventDefault();
            let selector = $(this).data('div');
            $(selector).toggleClass('wpcs_hidden');
        });

        // init text searches
        $('.wpcs_textsearch').each(function() {
            new WPCSTextSearch(this);
        });

    }); // domready


    /**
     *
     * @constructor
     */
    function WPCSFormElements() {

        var that = this;

        this._construct = function() {
            this.initWPCSSelect();
        }

        this.initWPCSSelect = function() {
            $('.wpcsselect.custom').each(function() {
                let select = $(this);
                let name = select.data('name');
                console.log(name);
                select.wpcsselect({
                    //target:'#wpcs_select_value_'+name
                });
            });
        }

        this._construct();
    }


    function WPCSTextSearch(textsearch) {

        var that = this;

        this.textsearch = $(textsearch);
        this.timeout = null;
        this.loader = $('.wpcs_ajax_loader',this.textsearch);
        this.textinput = $('.searchInput',this.textsearch);
        this.close_btn = $('.wpcs_textsearch_reset_btn', this.textsearch);
        this.results_div = null;

        this._construct = function() {

            let h = this.loader.height();
            this.loader.css('margin-top',Math.round(h/2)*-1);

            let h2 = this.close_btn.height();
            this.close_btn.css('margin-top',Math.round(h2/2)*-1);

            let target = that.textsearch.data('target');

            // standard result div
            this.results_div = $('.'+target, that.textsearch);
            // target angabe für externen div => muss ID sein
            if(this.results_div.length < 1) this.results_div = $('#'+target);

            $(that.textinput).keyup(function() {
                if(that.timeout !== null) window.clearTimeout(that.timeout);

                let val = $(this).val();
                if(val.length < 3) return;

                that.setCloseBtnState();

                that.timeout = window.setTimeout(that._doSearch,700,val);
            });

            this.close_btn.click(function(e) {
                e.preventDefault();
                that.emptyList();
                that.textinput.val("");
                that.setCloseBtnState();

            });
        }

        /**
         *
         * @param val
         */
        this._doSearch = function(val) {
            that.loader.show();
            that.close_btn.hide();
            let action = that.textsearch.data('type');
            let args = that.textsearch.data('params');

            $.ajax({method : 'POST', url : wpcs_ajax_url,
                data : { action : action, searchstring : val, args : args },
                success : function(data) {
                    that.loader.hide();
                    that.setCloseBtnState();

                    if(data.status == "1") {
                        console.log(that.results_div);
                        that.results_div.html(data.html).fadeIn(100);
                    }
                    else if(data.status == "0") {
                        that.emptyList();
                    }
                }
            });
        }

        this.emptyList = function() {
            that.results_div.html(null).fadeOut(150);
        }

        this.setCloseBtnState = function() {
            let val = that.textinput.val();
            if(val != "") that.close_btn.show();
            else that.close_btn.hide();
        }

        this._construct();
    }


    /**
     *
     * @constructor
     */
    // function WPCSTextSearch() {
    //
    //     var that = this;
    //
    //     this.timeout = null;
    //     this.loader = $('.wpcs_ajax_loader[data-category=textSearch]');
    //     this.close_btn = $('#wpcs_textsearch_reset_btn');
    //     this.results_div = null;
    //
    //     this._construct = function() {
    //
    //         let h = this.loader.height();
    //         this.loader.css('margin-top',Math.round(h/2)*-1);
    //
    //         let h2 = this.close_btn.height();
    //         this.close_btn.css('margin-top',Math.round(h2/2)*-1);
    //
    //         $('#wpcs_textsearch').each(function() {
    //             let wrapper = this;
    //             let target = $(this).data('target');
    //             that.results_div = $('#'+target);
    //
    //             $('.searchInput',wrapper).keyup(function() {
    //                 if(that.timeout !== null) window.clearTimeout(that.timeout);
    //
    //                 let val = $(this).val();
    //                 if(val.length < 3) return;
    //
    //                 that.setCloseBtnState();
    //
    //                 that.timeout = window.setTimeout(that._doSearch,700,val);
    //             });
    //         });
    //
    //         this.close_btn.click(function(e) {
    //             e.preventDefault();
    //             that.emptyList();
    //             $('#wpcs_textsearch .searchInput').val("");
    //             that.setCloseBtnState();
    //
    //         });
    //     }
    //
    //     /**
    //      *
    //      * @param val
    //      */
    //     this._doSearch = function(val) {
    //         that.loader.show();
    //         that.close_btn.hide();
    //         $.ajax({method : 'POST', url : wpcs_ajax_url,
    //             data : { action : 'wpcs_textsearch', searchstring : val },
    //             success : function(data) {
    //                 that.loader.hide();
    //                 that.setCloseBtnState();
    //
    //                 if(data.status == "1") {
    //                     that.results_div.html(data.html).fadeIn(100);
    //                 }
    //                 else if(data.status == "0") {
    //                     that.emptyList();
    //                 }
    //             }
    //         });
    //     }
    //
    //     this.emptyList = function() {
    //         that.results_div.html(null).fadeOut(150);
    //     }
    //
    //     this.setCloseBtnState = function() {
    //         let val = $('#wpcs_textsearch .searchInput').val();
    //         if(val != "") that.close_btn.show();
    //         else that.close_btn.hide();
    //     }
    //
    //     this._construct();
    // }


    /**
     *
     * @constructor
     */
    function WPCSInfiniteScroll() {
        var that = this;

        this.__construct = function() {
            that._initButton();
            that._initInfiniteLoader();
            $( document ).on( "wpcs_ajax_form_submitted",that._checkButtonVisibility);
        }


        this._checkButtonVisibility = function() {
            if($('#wpcs_pagination_button').length < 1) return;

            if(that._canLoadMore()) $('#wpcs_pagination_button').show();
            else $('#wpcs_pagination_button').hide();
        }

        /**
         * prüft ob nachlade button angezeigt werden darf
         * @private
         */
        this._canLoadMore = function() {
            let current_page = parseInt($('#wpcs_hidden_wpcsp').val());
            if(current_page >= vehicle_list_properties.max_pages) return false;
            else return true;
        }


        /**
         * initialisiert button zum nachladen der ergebnisse
         * @private
         */
        this._initButton = function() {
            $('#wpcs_pagination_button').click(function(e) {
                e.preventDefault();
                that._loadVehicles();
            });
        }

        /**
         *
         * @private
         */
        this._initInfiniteLoader = function() {
            if($('#wpcs_vehicle_archive').data('infinite') != "1") return;

            let timeout = null;
            $(window).on("scroll", function() {
                if(timeout != null) window.clearTimeout(timeout);
                timeout = window.setTimeout(function() {
                    if($('#wpcs_vehicle_archive .vehicle-on-archive').length < 1) return;

                    let element_pos = parseInt($('#wpcs_vehicle_archive .vehicle-on-archive').last().offset().top);
                    if(wpcs_form.is_loading || !that._canLoadMore()) return;
                    var scrollHeight = $(document).height();
                    var scrollPos = $(window).height() + $(window).scrollTop();
                    if(scrollPos >= element_pos) that._loadVehicles();
                },400);
            });
        }

        /**
         *
         * @private
         */
        this._loadVehicles = function() {
            let current_page = parseInt($('#wpcs_hidden_wpcsp').val());
            let new_page = current_page + 1;
            $('#wpcs_hidden_wpcsp').val(new_page);

            wpcs_form.submitAjax(1);
        }

        this.__construct();
    }

    /**
     *
     * @constructor
     */
    function WPCSImageSlideshow() {

        var that = this;

        this.slider = null;

        this.__construct = function() {

            let align = $('#wpcs_vehicle_images_wrapper').data('align');
            let vertical = (align == "vertical") ? true : false;
            let per_slide = parseInt($('#wpcs_vehicle_images_wrapper').data('per-slide'));
            let per_slide_768 = per_slide > 3 ? 3 : per_slide;

            // Vehicle Single Slick Slider
            that.slider = jQuery('#vehicle_single_thumbnails').slick({
                slidesToShow: per_slide,
                vertical : vertical,
                prevArrow : '#vehicle_single_images_prev_btn',
                nextArrow : '#vehicle_single_images_next_btn',
                responsive: [
                    {
                        breakpoint: 768,
                        settings: {
                            arrows: false,
                            slidesToShow: per_slide_768
                        }
                    },
                    {
                        breakpoint: 480,
                        settings: {
                            vertical : false,
                            arrows: false,
                            slidesToShow: 1
                        }
                    }
                ]
            });

            that.slider.on('afterChange', function(slick, currentSlide) {
                let currentIndex = that.slider.slick('slickCurrentSlide');
                let dataSrc = jQuery('#vehicle_single_thumbnails .dxim_image_thumbnail[data-slick-index='+currentIndex+'] > a').attr('data-src');
                jQuery('#wpcs_vehicle_single_image').attr('src',dataSrc).attr('data-src',dataSrc);
            });

            that.slider.on('setPosition', function() {
                let w = $('.dxim_image_thumbnail',that.slider).eq(0).width();
                let h = Math.round((w / wpcs_image_ratio.w) * wpcs_image_ratio.h);
                $('.dxim_image_thumbnail img',that.slider).css({ width : w, height : h});
            });

            $('#vehicle_single_thumbnails .dxim_image_thumbnail').each(function() {
                let wrapper = $(this);
                $('a.dxim_image_thumbnail_link',wrapper).click(function(e) {
                    e.preventDefault();
                    let index = wrapper.data('slick-index');
                    that.slider.slick('slickGoTo',index);
                });
            })

        }

        this.__construct();
    }

    /**
     *
     * @constructor
     */
    function WPCSSearchRequest() {

        var that = this;

        this.loader = $('.wpcs_ajax_loader[data-category=searchRequest]');

        this.__construct = function() {
            this._initSaveSearch();
            this._initList();
        }

        /**
         *
         * @param wrapper
         * @private
         */
        this._initSearch = function(sid) {
            let wrapper = $('.wpcs_save_search_request_wrapper[data-sid="'+sid+'"]');
            $('.wpcs_save_search_request_btn',wrapper).click(function(e) {
                e.preventDefault();
                that.loader.css('display','inline-block');
                $('.wpcs_save_search_request_btn', wrapper).hide();

                let email = $('.wpcs_sr_email_input',wrapper);
                let email_val = email.val();
                let privacy = $('input[name=wpcs_sr_privacy]',wrapper).is(':checked') ? 1 : 0;

                $.ajax({method : 'POST', url : wpcs_ajax_url,
                    data : { action : 'wpcs_search_request', todo : 'addSearchRequest', email : email_val, privacy : privacy, formData : wpcs_form.serialize() },
                    success : function(data) {
                        that.loader.hide();
                        $('.wpcs_save_search_request_btn',wrapper).show();

                        if(data.error == "1") {
                            $('.status',wrapper).addClass('error').removeClass('success').html(data.msg);
                        } else {
                            $('.status',wrapper).addClass('success').removeClass('error').html(data.msg);
                            email.val('');
                        }
                    }
                });
            });

            $('.privacy_btn',wrapper).click(function(e) {
                e.preventDefault();
                $('.wpcs_vsr_privacy_text',wrapper).slideToggle();
            })
        }


        this._initSaveSearch = function() {
            $('.wpcs_save_search_request_wrapper').each(function() {
                let wrapper = this;
                let sid = $(wrapper).data('sid');
                that._initSearch(sid);
            });
        }

        this._initList = function() {
            $('#wpcs_vsq_list .wpcs_search_request').each(function() {
                let wrapper = this;
                $('.delete_btn',wrapper).click(function(e) {
                    e.preventDefault();
                    let button = this;
                    let hash = $('#wpcs_vsq_list').data('hash');
                    let time = $(wrapper).data('time');

                    that.loader.show();
                    $('.delete_icon',button).hide();

                    $.ajax({method : 'POST', url : wpcs_ajax_url,
                        data : { action : 'wpcs_search_request', todo : 'removeSearchRequest', hash : hash, time : time },
                        success : function(data) {
                            that.loader.hide();
                            $('.delete_icon',button).show();

                            if(data.error == "1") {
                                alert(data.msg);
                            } else {
                                $(wrapper).remove();
                            }
                        }
                    });
                });
            });
        }

        this.__construct();

    }

    /**
     *
     * @constructor
     */
    function WPCSPark() {

        var that = this;

        this.vehicles_list_html = null;
        this.vehicle_count = 0;

        this.__construct = function() {
            this._initToggleButtons()
            this._initList();
        }

        this._initList = function() {
            $('#wpcs_vehicle_parked .vehicle').each(function() {

                let vehicle = this;
                let vehicle_id = $(this).attr('data-vehicle-id');

                $('.wpcs_park_remove_btn',vehicle).click(function(e) {
                    e.preventDefault();
                    $('.wpcs_ajax_loader',vehicle).show();
                    $.ajax({method : 'POST', url : wpcs_ajax_url,
                        data : { action : 'wpcs_park', todo : 'removeFromList', vehicle_id : vehicle_id },
                        success : function(data){
                            if(!data.error) {
                                that.vehicles_list_html = data.list;
                                that.vehicle_count = data.count;
                                that._setList();
                            }
                        }
                    });
                });

            });
        }

        this._initToggleButtons = function() {
            $('.wpcs_park_toggle_btn').click(function(e) {
                e.preventDefault();
                var btn = $(this);
                var todo = $(this).hasClass('wpcs_is_parked') ? 'removeFromList' : 'addToList';
                var vehicle_id = $(this).attr('data-vehicle-id');
                var spinner = $('.wpcs_icon_spinner',btn);
                spinner.css('display','inline-block');
                $.ajax({method : 'POST', url : wpcs_ajax_url,
                    data : { action : 'wpcs_park', todo : todo, vehicle_id : vehicle_id},
                    success : function(data) {
                        spinner.hide();
                        if(!data.error) {
                            btn.toggleClass('wpcs_is_parked');
                            that.vehicles_list_html = data.list;
                            that.vehicle_count = data.count;
                            that._setList();
                        }
                    }
                });
            });
        }

        /**
         *
         * @param vehicles
         * @private
         */
        this._setList = function() {

            if(that.vehicles_list_html !== null) {
                $('#wpcs_vehicle_parked .vehicles_wrapper').html(that.vehicles_list_html);
            }

            that._setButtonState();
            that._refreshCounter();
            that._initList();

        }

        /**
         *
         * @param count
         */
        this._refreshCounter = function() {
            let element = $('.wpcs_count_vehicles_parked');
            element.html(that.vehicle_count);

            // animation
            element.each(function() {
                this.classList.remove("wpcs_animated");
                this.offsetWidth;
                this.classList.add('wpcs_animated');
            });

        }

        /**
         *
         * @private
         */
        this._setButtonState = function() {
            if($('#wpcs_vehicle_parked').length < 1) return;

            $('.wpcs_park_toggle_btn').each(function() {
                $(this).removeClass('wpcs_is_parked');
            });

            $('#wpcs_vehicle_parked .vehicle').each(function(){
                let id = $(this).data('vehicle-id');
                $('.wpcs_park_toggle_btn[data-vehicle-id='+id+']').addClass('wpcs_is_parked');
            });
        }

        /**
         *
         * @param vehicle_id
         * @private
         */
        this._removeFromList = function(vehicle_id) {
            $('#wpcs_vehicle_parked .vehicle[data-vehicle-id='+vehicle_id+']').remove();
        }

        this.__construct();
    }


    /**
     *
     * @constructor
     */
    function WPCSLightbox() {

        var that = this;
        this.gallery = $('#wpcs_vehicle_images_wrapper');
        this.current = 0;
        this.lightbox = null;

        /**
         *
         * @private
         */
        this.__construct = function() {

            if($('#wpcs_vehicle_images_wrapper.wpcs_lightbox_enabled').length < 1) return;


            $('#wpcs_vehicle_single_image_wrapper a.lightbox_opener').click(function(e) {
                e.preventDefault();
                e.stopPropagation();
                that._open($('#wpcs_vehicle_single_image').attr('src'));
            });
        };

        this._create = function() {
            var html = '';

            html += '<div id="wpcs_lightbox">';
            html += '<div class="close"><span class="wpcs_icon dashicons dashicons-no-alt"></span></div>';
                html += '<div class="image_wrapper">';
                    html += '<div class="arrow arrow_left"><span class="wpcs_icon dashicons dashicons-arrow-left-alt2"></span></div>';
                    html += '<img id="wpcs_lightbox_image" src="" />';
                    html += '<div class="arrow arrow_right"><span class="wpcs_icon dashicons dashicons-arrow-right-alt2"></span></div>';
                html += '</div>';
            html += '</div>';

            this.lightbox = $(html);

            $('body').prepend(this.lightbox);

            $('.arrow_right',this.lightbox).click(function() { that._next(); });
            $('.arrow_left',this.lightbox).click(function() { that._prev(); });
            $('.close',this.lightbox).click(function() { that._close(); });

        };


        this._next = function() {
            this.current++;
            if(this.current > wpcs_lightbox_sources.length - 1) this.current = 0;
            this._change(wpcs_lightbox_sources[this.current]);
        };

        this._prev = function() {
            this.current--;
            if(this.current < 0) this.current = wpcs_lightbox_sources.length - 1;
            this._change(wpcs_lightbox_sources[this.current]);
        };

        this._change = function(src) {
            $('#wpcs_lightbox_image',this.lightbox).attr('src',src);
        };


        this._open = function(src) {
            if(this.lightbox == null) this._create();
            this._change(src);
            this.lightbox.fadeIn();
        };


        this._close = function() {
            this.lightbox.fadeOut();
        };

        if(this.gallery.length > 0)
        this.__construct();

    }

    /**
     *
     * @constructor
     */
    function WPCSCompare() {

        var that = this;
        var table = null;

        /**
         *
         * @private
         */
        this.__construct = function() {
            this.table = $('#wpcs_compare_table');
            this.vehicle_count = null;

            // init compare table
            if(this.table.length > 0) {
                this.initSectionLinks();
                this.initRemoveBtn();
                //this._setWidth();
            }

            this._init_compare_buttons();
        };

        this._init_compare_buttons = function(collection) {
            $('.wpcs_compare_toggle_btn',collection).click(function(e) {
                e.preventDefault();
                var btn = $(this);
                var todo = $(this).hasClass('wpcs_in_comparison') ? 'removeFromList' : 'addToList';
                var vehicle_id = $(this).attr('data-vehicle-id');
                var spinner = $('.wpcs_icon_spinner',btn);
                spinner.css('display','inline-block');
                $.ajax({method : 'POST', url : wpcs_ajax_url,
                    data : { action : 'wpcs_compare', todo : todo, vehicle_id : vehicle_id},
                    success : function(data){
                        spinner.hide();
                        if(!data.error) {
                            btn.toggleClass('wpcs_in_comparison');
                            that.vehicle_count = data.count;
                            that._refreshCounter();
                        }
                    }
                });
            });
        }

        this._refreshCounter = function() {
            let element = $('.wpcs_count_vehicles_compared');
            element.html(that.vehicle_count);

            // animation
            element.each(function() {
                this.classList.remove("wpcs_animated");
                this.offsetWidth;
                this.classList.add('wpcs_animated');
            });
        }

        /**
         *
         */
        this.initSectionLinks = function() {
            $('a.section_link',that.table).click(function(e) {
                e.preventDefault();
                var rel = $(this).attr('rel');

                //$(this).parent().toggleClass('opened');
                $('tr[rel='+rel+']').toggleClass('wpcs_hidden');
                $(this).toggleClass('closed');
            });
        };

        /**
         *
         */
        this.initRemoveBtn = function() {
            $('.wpcs_compare_table_remove_btn').click(function(e) {
                e.preventDefault();
                var vehicle_id = $(this).attr('data-vehicle-id');
                var btn = this;
                var spinner = $('.fa-spinner',btn);
                spinner.css('display','inline-block');

                $.ajax({method : 'POST', url : wpcs_ajax_url,
                    data : { action : 'wpcs_compare', todo : 'removeFromList', vehicle_id : vehicle_id },
                    success : function(data){
                        spinner.hide();
                        if(!data.error) {
                            that._removeFromTable(vehicle_id);
                        }
                    }
                });

            });
        };

        /**
         *
         * @private
         */
        this._setWidth = function() {
            var count = this._countCars() + 1;
            var percent = 100 / count;
            $('td',this.table).not('.header').css('width',percent+'%');
        };

        /**
         *
         * @param vehicle_id
         * @private
         */
        this._removeFromTable = function(vehicle_id) {
            jQuery('td[data-vehicle-id='+vehicle_id+']',this.table).remove();

            var count = this._countCars();
            $('td.header',this.table).attr('colspan',count);

            //this._setWidth();

            if(count == 1) {
                //this.table.remove();
                $('#wpcs_vehicle_compare').html('<h3>Keine Fahrzeuge zum Vergleichen ausgewählt.</h3>');
            }
        };

        /**
         *
         * @returns {number}
         * @private
         */
        this._countCars = function() {
            var cars = $('td.header',this.table).first().attr('colspan') - 1;
            return cars;
        };

        /**
         *
         */
        this.__construct();
    }


    /**
     *
     * @constructor
     */
    function WPCSOrderbar() {

        var that = this;

        this.__construct = function() {
            this.initOrderBar();
        };

        this.initOrderBar = function() {
            $('.dxim_ff_order_bar a.dxim_set_order').click(function(e) {
                e.preventDefault();

                var orderby = $(this).attr('data-orderby');
                var order = $('.dxim_ff_order_bar').attr('data-order');
                var new_order = (order == 'asc') ? 'desc' : 'asc';


                $('#dxim_orderby_hidden').val(orderby);
                $('#dxim_order_hidden').val(new_order);

                that.refresh(new_order,orderby);

                wpcs_form.submit();
            });
        };

        this.refresh = function(order,orderby) {
            $('.dxim_ff_order_bar').each(function() {
                let bar = $(this);
                bar.attr('data-order',order);

                $('a.dxim_set_order',bar).each(function(){
                    var tmp_orderby = $(this).attr('data-orderby');
                    if(tmp_orderby == orderby) $(this).addClass('current');
                    else  $(this).removeClass('current');
                });
            });

        }

        this.__construct();

    }

    function animateValue(obj, start, end, duration) {
        let startTimestamp = null;
        const step = (timestamp) => {
            if (!startTimestamp) startTimestamp = timestamp;
            const progress = Math.min((timestamp - startTimestamp) / duration, 1);
            let value = Math.floor(progress * (end - start) + start);
            $(obj).attr('data-value', value);
            obj.innerHTML = value.toLocaleString('de-DE');
            if (progress < 1) {
                window.requestAnimationFrame(step);
            }
        };
        window.requestAnimationFrame(step);
    }

    /** ----------------------------------------------------------------------------------
     * Filterform
     * @constructor
     */
    function WPCSForm() {
        var that = this;
        var ajax = false;

        this.is_loading = false;
        this.preFilterTimeout = null;
        this.scrollTopAfterSubmit = false;

        this.keyUpDelay = null;

        /**
         *
         * @returns {*|jQuery}
         */
        this.serialize = function() {
            that._serializeMultipleCheckbox();
            let formdata = $('.dxim_filter :input').serialize();
            return formdata;
        }

        /**
         *
         * @private
         */
        this.__construct = function() {

            if($('#wpcs_vehicle_archive[data-ajax="1"]').length > 0) this.ajax = 1;

            this.initWpcsSelect();
            this.initCheckboxes();
            this.initSlider();
            this.initActiveFilters();
            this.initRange();
            this.initSubmit();
            this.initColorSelect();
            this.initPagination();
            this.initMultipleCheckbox();
            this.initTextField();
            this.initLayoutSelector();

            $(document).on('wpcs_ajax_form_submitted',this.scrollTop);
        };

        this.scrollTop = function() {
            if(!that.scrollTopAfterSubmit) return;
            $([document.documentElement, document.body]).animate({
                scrollTop: $(".wpcs_vehicles").offset().top
            }, 1000);
            that.scrollTopAfterSubmit = false;
        }

        this._serializeMultipleCheckbox = function() {
            $('.wpcs_multiple_checkbox').each(function() {
                let wrapper = this;
                let hidden = $('.wpcs_element_value',wrapper);

                let valueStr = '';
                $('.wpcs_selectable.selected',wrapper).each(function(z) {
                    if(z != 0) valueStr +=',';
                    valueStr += $(this).data('value');
                });
                hidden.val(valueStr);
            });
        }

        this.resetMultipleCheckbox = function(filter) {
            $('.wpcs_multiple_checkbox[data-filter="'+filter+'"] .wpcs_selectable.selected').removeClass('selected');
        }

        this.initMultipleCheckbox = function() {
            $('.wpcs_multiple_checkbox').each(function() {
                let wrapper = this;
                $('.wpcs_selectable',wrapper).click(function() {
                    $(this).toggleClass('selected');
                    that._preFilterAmount();
                });
            });
        }

        this.initSlider = function() {
            $('.dxim_filter_slider').each(function() {

                let slider_wrapper = $(this);
                let key = slider_wrapper.attr('data-key');
                let start_val = slider_wrapper.attr('data-start');
                let default_value = slider_wrapper.data('default');
                let unit = slider_wrapper.data('unit');
                let formatting = parseInt(slider_wrapper.data('formatting'));
                let step = slider_wrapper.data('step');
                let slider = document.getElementById('wpcs_fs_'+key);
                let range = wpcs_slider_ranges[key];
                let input = jQuery('#wpcs_fv_'+key);
                let label_current = jQuery('#wpcs_fl_'+key+'_current');

                noUiSlider.create(slider, {
                    start: [start_val],
                    connect: 'lower',
                    range: range,
                    step : step,
                });

                slider.noUiSlider.on('update',function(value) {
                    let val = Math.round(value);
                    let label = val;
                    if(value == default_value) { val = '#'; label = default_value; }

                    if(formatting > 0) {
                        label = label.toLocaleString('de-DE');
                    }

                    input.val(val);
                    label_current.html(label+" "+unit);
                });

                slider.noUiSlider.on('set',function(value) {
                    that._preFilterAmount();
                });
            });
        };

        this.initColorSelect = function() {
            $('.wpcs_color_select').each(function() {
                let c = this;
                $('.color',c).click(function(){
                    let i = 0;
                    let values = []
                    $(this).toggleClass('active');
                    $('.color',c).each(function() {
                        if($(this).hasClass('active')) {
                            values[i] = $(this).data('key');
                            i++;
                        }
                    });

                    $('.color_value',c).val(values.join(","));
                    that._preFilterAmount();

                });
            });
        }


        this.initTextField = function() {
            $('.dxim_filter input[type=text]').keyup(function() {
                if(that.keyUpDelay !== null) window.clearTimeout(that.keyUpDelay);
                that.keyUpDelay = window.setTimeout(function(){
                    that._preFilterAmount();
                },800);
            });
        }


        this.initLayoutSelector = function() {
            $('#wpcs_archive_layout_selector .button').click(function() {
                $('#wpcs_archive_layout_selector .button').removeClass('active');

                let mode = $(this).data('type');

                $('#wpcs_archive_layout_selector input').val(mode);
                vehicle_list_properties.layout = mode;

                $(this).addClass('active');
                that.submit();
            });
        }


        this.initPagination = function() {
            $('.dxim_pagination').each(function() {
                let p = this;
                $('a',p).click(function(e) {
                    e.preventDefault();
                    let a = this;
                    let wpcsp = $(a).data('wpcsp');
                    $('#wpcs_hidden_wpcsp').val(wpcsp);

                    that.scrollTopAfterSubmit = true;
                    that.submit();
                });
            });
        }

        this.initRange = function(){

            $('.dxim_filter_range').each(function() {
                let slider_wrapper = $(this);
                let key = slider_wrapper.data('key');
                let filter_1 = slider_wrapper.data('filter-1');
                let filter_2 = slider_wrapper.data('filter-2');
                let start_val = slider_wrapper.data('start');
                let step = slider_wrapper.data('step');
                let end_val = slider_wrapper.data('end');
                let slider = document.getElementById('wpcs_fs_'+key);
                let range = wpcs_slider_ranges[key];
                let unit = slider_wrapper.data('unit');
                let formatting = parseInt(slider_wrapper.data('formatting'));

                let input_1 = jQuery('#wpcs_fv_'+filter_1);
                let label_1 = jQuery('#wpcs_fl_'+filter_1);
                let input_2 = jQuery('#wpcs_fv_'+filter_2);
                let label_2 = jQuery('#wpcs_fl_'+filter_2);

                noUiSlider.create(slider, {
                    start: [start_val, end_val],
                    format: {
                        to : function(value) {  return Math.round(value); },
                        from : function(value) { return Math.round(value); }
                    },
                    step : step,
                    connect: true,
                    range: range
                });

                slider.noUiSlider.on('update',function(values) {
                    let val_min = values[0];
                    let val_max = values[1];
                    let html_min = val_min;
                    let html_max = val_max;

                    if(val_min == range.min && val_max == range.max) {
                        val_min = val_max = '#';
                        html_min = range.min;
                        html_max = range.max;
                    }
                    //if(val_max < 1 || val_max == range.max) { val_max = '#'; html_max = range.max; }

                    if(val_min == '#' && val_max == '#') slider_wrapper.addClass('inactive');
                    else slider_wrapper.removeClass('inactive');


                    input_1.val(val_min);
                    input_2.val(val_max);

                    if(formatting > 0) {
                        html_min = html_min.toLocaleString('de-DE');
                        html_max = html_max.toLocaleString('de-DE');
                    }

                    label_1.html(html_min+" "+unit);
                    label_2.html(html_max+" "+unit);
                });

                slider.noUiSlider.on('set',function() {
                    that._preFilterAmount();
                });
            });

        };

        /**
         *
         */
        this.initWpcsSelect = function(){
            $('.wpcsselect','.dxim_filter').each(function() {
                let select = $(this);
                let field = select.data('field');
                let dxim_filter = $('.dxim_filter[data-filter-name="'+field+'"]');
                let load = dxim_filter.data('load');
                let values = dxim_filter.data('values');

                if(select.hasClass('dxim_order_select')) {
                    select.wpcsselect({
                        onSelect : function(){
                            let val = $('.wpcs_select_value',select).val();
                            $('#dxim_order_hidden').val(val);
                            if(that.ajax) that._preFilterAmount();
                        }
                    });
                }
                else if(select.hasClass('dxim_orderby_select')) {
                    select.wpcsselect({
                        onSelect : function(){
                            let val = $('.wpcs_select_value',select).val();
                            $('#dxim_orderby_hidden').val(val);
                            if(that.ajax) that._preFilterAmount();
                        }
                    });
                }
                else {
                    select.wpcsselect({
                        ajax : {
                            url: wpcs_ajax_url,
                            dataType: 'json',
                            method: 'POST',
                            data: function () {
                                var query = {
                                    action: 'getData',
                                    field : field,
                                    load : load,
                                    values : values,
                                    init_ajax_data : 1,
                                    filterFormData : that.serialize(),
                                };
                                return query;
                            },
                        },
                        onSelect : function() {
                            if(that.preFilterTimeout !== null) window.clearTimeout(that.preFilterTimeout);
                            that.preFilterTimeout = window.setTimeout(that._preFilterAmount,800);
                        }
                    });
                }

            });
        };

        this.initActiveFilters = function() {
            $('.wpcs_filterform_active_filters .active_filter').each(function(){
                let filter = this;
                let key = $(filter).data('key');
                let type = $(filter).data('type');

                $('.reset',filter).click(function() {

                    if(type == "select") { that.resetSelect(key); that._resetPageNr(); that.submit(); }
                    if(type == "checkbox") { that.resetCheckbox(key); that._resetPageNr(); that.submit(); }
                    if(type == "multiple_checkbox") { that.resetMultipleCheckbox(key); that._resetPageNr(); that.submit(); }
                    if(type == "text") { that.resetText(key); that._resetPageNr(); that.submit(); }
                    if(type == "slider") { that.resetSlider(key); that._resetPageNr(); that.submit(); }
                    if(type == "color") { that.resetColor(key); that._resetPageNr(); that.submit(); }

                    if(type == "custom") { $( document ).trigger( "wpcs_ajax_remove_filter", [ key ] ); }

                    filter.remove();
                });

            });
        }


        /**
         * Vorschau beim Klick der Checkbox aktivieren
         */
        this.initCheckboxes = function() {
            $('.dxim_filter input[type=checkbox]').click(function() {
                that._preFilterAmount();
            });
        };

        /**
         * Anzahl der Treffer Vorschau
         * @private
         */
        this._preFilterAmount = function() {
            that._resetPageNr();

            if(that.ajax) {
                that.submitAjax();
            }
            else {
                $.ajax({method : 'POST', url : wpcs_ajax_url,
                    data : { action : 'getPreFilteredAmount', filterFormData : that.serialize(), init_ajax_data : 1 },
                    success : function(data){
                        that._refreshCounterValues(data);
                    }
                });
            }

        };

        //
        this._refreshCounterValues = function(data) {
            let old_val = Math.round($('.wpcs_search_count').eq(0).attr('data-value'));
            $('.wpcs_search_count').each(function() {
                animateValue(this, old_val, data, 500);
            });
        }

        /**
         * Submit Form
         */
        this.initSubmit = function() {

            $('.dxim_filter_form_submit').click(function(e) {
                e.preventDefault();

                let target = $('#wpcs_vehicle_archive');
                let redirect_url = $(this).attr('data-redirect');
                let url = '';

                if(redirect_url != undefined && redirect_url != "") {
                    url = redirect_url;
                    that.ajax = false;
                }
                else {
                    // zum archiv umleiten
                    if(target.length < 1) url = wpcs_archive_url;
                    // aktuelle Seite reload
                    else url = wpcs_current_url;
                }

                that.submit(url);
            });

        };

        /**
         *
         */
        this.submit = function(force_url) {

            if(that.ajax) {
                that.submitAjax();
                return;
            }

            let url = '';
            if(!force_url) {
                //let target = $('.wpcs_vehicle_list.wpcs_vehicles');
                let target = $('#wpcs_vehicle_archive');
                // zum archiv umleiten
                if(target.length < 1) url = wpcs_archive_url;
                // aktuelle Seite reload
                else url = wpcs_current_url;
            }
            else url = force_url;

            let data = that.serialize();
            url += "?"+data;
            url += '#wpcs_vehicles';
            window.location.href = url;
        }

        /**
         *
         * @private
         */
        this._resetPageNr = function() {
            // reset page id to 1
            console.log('reset now');
            $('#wpcs_hidden_wpcsp').val(1);
        }

        /**
         *
         */
        this.submitAjax = function(append = 0) {

            vehicle_list_properties.append = append;

            that.setLoadingState();

            $.ajax({
                method : 'POST', url : wpcs_ajax_url,
                data : { action : 'wpcs_fetchResults', filterFormData : that.serialize(), init_ajax_data : 1, vehicle_list_data : vehicle_list_properties },
                success : function(json) {

                    let new_vehicles = $(json.vehicle_list_html);

                    // vehicles
                    if(append > 0) {
                        $('#wpcs_vehicle_archive .wpcs_vehicles_wrapper').append(new_vehicles);
                    }
                    else {
                        $('#wpcs_vehicle_archive').replaceWith(new_vehicles);

                        // pagination
                        $('.dxim_pagination').replaceWith(json.pagination);
                        that.initPagination();

                        // active filters
                        $('.wpcs_filterform_active_filters').replaceWith(json.active_filters);
                        that.initActiveFilters();

                        // refresh counters
                        $('.vehicle_count').html(json.count);
                        that._refreshCounterValues(json.count);
                    }

                    // disable loading state
                    that.hideLoadingState();

                    //
                    wpcs_compare._init_compare_buttons(new_vehicles);

                    //
                    wpcs_park._initToggleButtons(new_vehicles);

                    $( document ).trigger( "wpcs_ajax_form_submitted");
                }
            });

        }

        this.setLoadingState = function() {
            this.is_loading = true;
            $('.wpcs_ajax_loader[data-category=sync]').addClass('active');
        }

        this.hideLoadingState = function() {
            this.is_loading = false;
            $('.wpcs_ajax_loader[data-category=sync]').removeClass('active');
        }


        this.resetSelect = function(key) {
            let obj = $('.wpcsselect[data-field='+key+']');
            if(obj.length < 1) return;
            $('.wpcs_select_handle',obj).html(obj.data('nothing-selected'));
            $('.wpcs_select_value',obj).val('');
        }

        this.resetCheckbox = function(key) {
            let input = $('input[name='+key+']');
            input.prop('checked',false);
        }


        this.resetText = function(key) {
            $('input[name='+key+']').val('');
        }

        this.resetSlider = function(key) {
            let obj = $('#wpcs_fs_'+key);
            if(obj.length < 1) {

                // reset range
                let key2 = key.replace("_max",'');
                key2 = key2.replace("_min",'');
                let obj2 = $('#wpcs_fs_'+key2);
                if(obj2.length < 1) return;

                obj2[0].noUiSlider.reset();
                return;
            }
            // reset slider
            obj[0].noUiSlider.reset();
        }

        this.resetColor = function(key) {
            let obj = $('.dxim_filter[data-filter-name='+key+'] .wpcs_color_select');
            $('.color_value',obj).val('');
            $('.color.active',obj).removeClass('active');

        }

        this.__construct();
    }



    /**
     * -----------------------------------------------------------
     * Kontaktform
     * @constructor
     */
    function WPCSContactForm() {

        var that = this;
        this.form = null;
        this.spinner = null;

        /**
         *
         * @private
         */
        this.__construct = function() {

            $('.wpcs_contact_form').each(function() {
                let form = this;
                that._initSubmit(form);
            });

        };


        /**
         *
         * @param form
         * @private
         */
        this._setForm = function(form) {
            this.form = $(form);
            this.spinner = $('.wpcs_form_submit .wpcs_icon_spin',form);
        }

        /**
         *
         * @param form
         * @private
         */
        this._initSubmit = function(form) {
            $('.wpcs_form_submit',form).click(function(e) {
                e.preventDefault();
                that._setForm(form);

                if($(this).hasClass('ga')) {
                    grecaptcha.execute(wpcs_ga_public_key, {action: "submit"}).then(function(token) {
                        that.sendForm(token);
                    });
                }
                else {
                    that.sendForm();
                }
            });
        }

        this.sendForm = function(token) {
            this.spinner.css('display','inline-block');
            let redirect = $(this.form).data('redirect');

            $.ajax({method : 'POST', url : wpcs_ajax_url,
                data : { action : 'wpcs_contactform', post : that.form.serialize(), token : token },
                success : function(data){
                    that.spinner.hide();
                    that.unhighlightFormFields();
                    if(data.status === -1) that.highlightFormFields(data);
                    else {
                        that.form.parent().html(data.msg);
                        if(redirect != "") window.location.href = redirect;
                    }
                }
            });
        };

        /**
         *
         */
        this.unhighlightFormFields = function() {
            $('label',this.form).removeClass('required');
            $('.wpcs-error-msg',this.form).hide();
        };

        /**
         *
         * @param data
         */
        this.highlightFormFields = function(data) {
            $('.wpcs-error-msg',this.form).fadeIn();
            $(data.error).each(function() {
                $('label[rel='+this+']',this.form).addClass('required');
            });
        };

        this.__construct();
    }

})(jQuery);