var wpcs_theme_division = null;
var wpcs_theme_tabs = null;
var wpcs_theme_accordion = null;
var wpcs_theme_model = null;
var wpcs_theme = null;
var wpcs_theme_person = null;

(function($) {

    $(function() {

        wpcs_theme_division = new WPCSThemeDivision();

        wpcs_theme_tabs = new WPCSThemeTabs();

        wpcs_theme_accordion = new WPCSThemeAccordion();

        wpcs_theme_model = new WPCSThemeModel();

        wpcs_theme = new WPCSTheme();

        wpcs_theme_person = new WPCSThemePerson();

    }); // domready


    function WPCSTheme() {

        var that = this;
        this.footnotesDiv = $('#wpcs_footnotes');
        this.generated_footnotes_div = $('#wpcs_generated_footnotes');

        this._construct = function() {
            that._initForm();
            that._initFootnotes();
        }

        this._initForm = function() {
            $('.theme_filter input').click(function() {
                that._submitForm();
            });
        }

        this._initFootnotes = function() {
            let html = that.generated_footnotes_div.html();
            if(this.footnotesDiv.length < 1 && html != "") {
                that.generated_footnotes_div.removeClass('wpcs_hidden');
            }
            else {
                this.footnotesDiv.html(html);
            }

        }

        this._submitForm = function() {
            let data = $('.theme_filter input').serialize();
            window.location.href = wpcs_current_url+'?'+data;
        }

        this._construct();
    }


    /**
     *
     * @constructor
     */
    function WPCSThemeModel() {

        var that = this;

        this._construct = function() {
            $('.wpcsselect.model_single_model_select').wpcsselect({
                target:'#wpcs_select_value_wpcs_model',
                onSelect : function(){
                    let val = $('#wpcs_select_value_wpcs_model').val();
                    window.location.href = val;
                }
            });
        }

        this.load = function(target_selector, settings) {
            $.ajax({method : 'POST', url : wpcs_ajax_url,
                data : { action : 'wpcs_theme_load', 'do' : 'load_models', settings : settings },
                success : function(data) {
                    if(data.code == 1) $(target_selector).html(data.result);
                }
            });
        }

        this._construct();
    }


    /**
     *
     * @constructor
     */
    function WPCSThemePerson() {

        var that = this;
        this.person_search_timout_id = null;

        this._construct = function() {
            this.initWPCSSelect();
            // this.initPersonSearch();
        }

        this.initWPCSSelect = function() {

            $('.wpcsselect.locations_persons_select').wpcsselect({
                //target:'#wpcs_select_value_wpcs_location',
                onSelect : function(){
                    let val = $('.wpcsselect.locations_persons_select input').val();
                    $('#wpcs_locations_persons_select .location_wrapper').addClass('wpcs_hidden');
                    let current = $('#wpcs_locations_persons_select .location_wrapper[data-location='+val+']');
                    current.removeClass('wpcs_hidden');
                    $('.dxim_vehicle_carousel.slick-slider',current).slick('refresh');
                }
            });
        }

        this._construct();
    }


    /**
     *
     * @constructor
     */
    function WPCSThemeDivision() {

        var that = this;

        this._construct = function() {
            this.initWPCSSelect();
        }

        this.initWPCSSelect = function() {
            $('.wpcsselect.division_select').wpcsselect({
                //target:'#wpcs_select_value_wpcs_division',
                onSelect : function(){
                    let division_id = jQuery('.wpcsselect.division_select input').val();
                    jQuery('#location_team .wpcs_team').addClass('wpcs_hidden');
                    jQuery('#location_team .wpcs_team[data-division='+division_id+']').removeClass('wpcs_hidden');
                }
            });
        }

        this._construct();
    }

    /**
     *
     * @constructor
     */
    function WPCSThemeTabs() {
        var that = this;

        this._construct = function() {
            this.init();
        }

        this.init = function() {
            $('.wpcs_tabs').each(function() {
                let wrapper = this;
                $('.wpcs_tab_control', wrapper).each(function(index) {
                    $(this).click(function(e) {
                        e.preventDefault();
                        that.changeTab(index, wrapper);
                    })
                });
            });
        }

        this.changeTab = function(index, tabObj) {
            $('.wpcs_tab_control', tabObj).removeClass('active');
            $('.wpcs_tab_control', tabObj).eq(index).addClass('active');

            $('.wpcs_tab_content', tabObj).removeClass('active');
            $('.wpcs_tab_content', tabObj).eq(index).addClass('active');
        }

        this._construct();
    }

    /**
     *
     * @constructor
     */
    function WPCSThemeAccordion() {
        var that = this;

        this._construct = function() {
            this.init();
        }

        this.init = function() {
            $('.wpcs_accordion').each(function() {
                let wrapper = this;
                $('.wpcs_accordion_control', wrapper).each(function(index) {
                    $(this).click(function(e) {
                        e.preventDefault();
                        that.changeTab(index, wrapper);
                    })
                });
            });
        }

        this.changeTab = function(index, tabObj) {
            let target = $('.wpcs_accordion_control', tabObj).eq(index);
            let target_is_active = target.hasClass('active');

            $('.wpcs_accordion_control', tabObj).removeClass('active');
            if(!target_is_active) $('.wpcs_accordion_control', tabObj).eq(index).addClass('active');

            $('.wpcs_accordion_content', tabObj).removeClass('active');
            if(!target_is_active) $('.wpcs_accordion_content', tabObj).eq(index).addClass('active');
        }

        this._construct();
    }

})(jQuery);