<?php
$job = $data['job'];
$meta = get_post_meta($job->ID);

$jd = new \DXIM\theme\JobData();
$locations = $jd->get_locations($job->ID);

$tags = $jd->get_tags($job->ID);
$employment_types = get_post_meta($job->ID, "employmentType");
$home_office = get_post_meta($job->ID, "homeoffice", true);
$excerpt = get_post_meta($job->ID, "excerpt", true);

$all_types = \DXIM\theme\Job::getInstance()->get_employment_types();
$link = get_permalink($job->ID);

print '<div class="wpcs_job wpcs_list_item">';

    print '<div class="job_top_row">';
        // title
        print '<a href="'.$link.'"><h2 class="title">'.$job->post_title."</h2></a>";

        // Location Logo
        if(!empty($locations)) {
            $id = $locations[0]->parent > 0 ? $locations[0]->parent : $locations[0]->term_id;
            $image_id = get_term_meta($id, "logo", true);
            $src = wp_get_attachment_image_url($image_id, "medium");
            if(!empty($src)) print '<img class="company_logo" src="'.$src.'" alt="Logo Standort" />';
        }

    print '</div>';

    // Infos
    print '<div class="infos">';

        // Art
        if(is_array($employment_types)) {
            $label = "";
            $z = 0;
            foreach($employment_types as $key) {
                if($z != 0) $label .= ", ";
                $label .= $all_types[$key];
                $z++;
            }
            print '<div class="types"><span class="dashicons dashicons-clock"></span> '.$label.'</div>';
        }

        // HomeOffice
        if($home_office > 0) {
            $label = $home_office == 1 ? "Homeoffice möglich" : "nur Homeoffice";
            print '<div class="homeoffice"><span class="dashicons dashicons-admin-home"></span> '.$label.'</div>';
        }

        // standorte
        if(!empty($locations)) {
            print '<div class="locations">';
                print '<span class="dashicons dashicons-location"></span> ';
                print 'Standorte: ';
                $z = 0;
                foreach($locations as $location) {
                    $term_link = get_term_link($location);
                    if($z != 0) print ", ";
                    print '<a href="'.$term_link.'">'.$location->name.'</a>';
                    $z++;
                }
            print '</div>';
        }

    print '</div>'; // info

    print '<div class="wpcs_element_spacer_small"></div>';

    // TAGS
    if(!empty($tags)) {
        print '<div class="wpcs_job_tags">';
        foreach($tags as $tag) {
            print '<span class="wpcs_job_tag wpcs_tag">'.$tag->name.'</span>';
        }
        print '</div>';
        print '<div class="wpcs_element_spacer_small"></div>';
    }

    // auszug
    if(!empty($meta['excerpt'])) {
        print '<div class="excerpt">'.nl2br($excerpt).'</div>';
        print '<div class="wpcs_element_spacer_small"></div>';
    }

    // Button
    print '<p><a class="dxim_button dxim_button_light" href="'.$link.'">Ausschreibung ansehen</a></p>';

print '</div>';