<?php
$location = $data['location'];
$args = $data['args'];
if(empty($location)) return null;

$ld = new \DXIM\theme\LocationData();
$opening_hours_text = get_term_meta($location->term_id,'opening_hours_'.$args['type'], true);
if(empty($opening_hours_text)) {
    $opening_hours_text = get_term_meta($location->parent,'opening_hours_'.$args['type'], true);
}
if(empty($opening_hours_text)) return null;

$opening_hours = $ld->parse_opening_hours($opening_hours_text);
$status = $ld->is_location_open($opening_hours);

print '<div id="wpcs_location_opening_hours_'.$args['type'].'" class="wpcs_location_opening_hours">';

    // Status Anzeige
    if($args['show_status']) {
        print '<div class="status">';


            if($status['is_open']) {
                print '<span class="open">geöffnet</span> - ';

                if($args['link_days'] && $args['show_days']) print '<a href="#" class="wpcs_toggle" data-div="#opening_days_'.$args['type'].'">';

                print 'schließt um '.substr($status['closes_at'],0,2).':'.substr($status['closes_at'],2)." Uhr";

                if($args['link_days'] && $args['show_days']) print '</a>';
            }
            else {
                print '<span class="closed">geschlossen</span>';
                if(isset($status['opens_at']['nr'])) {
                    print " - ";

                    if($args['link_days'] && $args['show_days']) print '<a href="#" class="wpcs_toggle" data-div="#opening_days_'.$args['type'].'">';

                    print "öffnet ";

                    if($status['opens_at']['nr'] != $status['current_day']) print $status['opens_at']['label']." ";

                    print "um ".substr($status['opens_at']['time'],0,2).':'.substr($status['opens_at']['time'],2)." Uhr";

                    if($args['link_days'] && $args['show_days']) print '</a>';
                }
            }


        print '</div>';
    }

    // Öffnungszeiten
    if($args['show_days']) {
        $hidden_class = $args['link_days'] ? "wpcs_hidden" : '';
        print '<dl class="days '.$hidden_class.'" id="opening_days_'.$args['type'].'">';
        foreach($opening_hours as $day) {
            $current_day_class = $day['nr'] == $status['current_day'] ? "current_day" : "";
            print '<dt class="'.$current_day_class.'">'.$day['label'].'</dt>';
            $times = null;

            foreach($day['times'] as $time) {
                $times .= substr($time[0],0,2).':'.substr($time[0],2)."-".substr($time[1],0,2).':'.substr($time[1],2)."<br />";
            }
            if(empty($times)) $times = "geschlossen";
            print '<dd class="'.$current_day_class.'">'.$times.'</dd>';
        }
        print '</dl>';
    }

print '</div>';