<?php

/**
 * Template for WPCS Custom Post Types
 */

if (!defined('ABSPATH')) {
    exit; // Exit if accessed directly.
}
get_header();
?>

<main id="wpcs_template_content" class="single location">
    <?php
    $location = \DXIM\theme\Location::getInstance()->get_current();
    ?>

    <?php print do_shortcode('[WPCS_location_image]'); ?>

    <div class="wpcs_element_spacer"></div>

    <div class="dxim_clearfix">

        <div id="wpcs_template_main">

            <?php
            $logo = get_term_meta($location->term_id, 'logo', true);
            if ($logo > 0) {
                $url = wp_get_attachment_image_url($logo, 'full');
                if (!empty($url)) print '<img class="location_logo" src="' . $url . '" alt="Logo" />';
            }
            ?>
            <?php print do_shortcode('[WPCS_location_title]'); ?>

            <?php print do_shortcode('[WPCS_location_description]') ?>
            <?php print do_shortcode('[WPCS_location_offers]') ?>

            <div class="wpcs_element_spacer_big"></div>

            <h2>Das Team an diesem Standort</h2>

            <div style="max-width:300px;"><?php print do_shortcode('[WPCS_person_search]'); ?></div>

            <div class="wpcs_element_spacer_small"></div>
            <?php print do_shortcode('[WPCS_location_team]'); ?>

            <div class="wpcs_element_spacer_big"></div>
            <?php
            $gallery = get_term_meta($location->term_id, 'gallery', true);
            if (!empty($gallery['text'][0])) {
                print '<h2>Eindrücke vom Standort</h2>';
                print do_shortcode('[WPCS_location_gallery]');
            }
            ?>

            <div class="wpcs_element_spacer_big"></div>
            <h2>Unsere Services</h2>
            <?php print do_shortcode('[WPCS_location_services grid="2"]'); ?>

            <div class="wpcs_element_spacer_big"></div>
            <h2>Stellenangebote an diesem Standort</h2>
            <?php print do_shortcode('[WPCS_location_jobs]'); ?>

            <div class="wpcs_element_spacer_big"></div>
            <h2>Anfrage an Standort</h2>
            <?php print do_shortcode('[WPCS_form]'); ?>

        </div>

        <div id="wpcs_template_sidebar">
            <h4>Marken an diesem Standort:</h4>
            <?php print do_shortcode('[WPCS_location_brands]'); ?>

            <div class="wpcs_element_spacer_big"></div>

            <h4>Adresse</h4>
            <?php print do_shortcode('[WPCS_location_address]'); ?>
            <div class="wpcs_element_spacer_big"></div>

            <h4>Öffnungszeiten</h4>
            <strong>Verkauf</strong>
            <?php print do_shortcode('[WPCS_location_opening_hours]'); ?>
            <div class="wpcs_element_spacer"></div>
            <strong>Service</strong>
            <?php print do_shortcode('[WPCS_location_opening_hours type="service"]'); ?>
        </div>

    </div>

</main>

<?php get_footer();
