<?php
/**
 * Template for WPCS Custom Post Types
 */

if ( ! defined( 'ABSPATH' ) ) {
	exit; // Exit if accessed directly.
}

get_header();

while ( have_posts() ) : the_post(); ?>

<?php
    global $post;
?>

<main id="wpcs_template_content">

    <?php print do_shortcode('[WPCS_offer_image]'); ?>

    <div class="wpcs_element_spacer_big"></div>

    <?php
    the_title('<h1>', '</h1>');

    $emission = get_post_meta($post->ID,'emission_info', true);
    if($emission !== "") {
        print '<div class="wpcs_emission_info">'.nl2br($emission).'</div>';
        print '<div class="wpcs_element_spacer_big"></div>';
    }
    ?>

    <div class="dxim_clearfix">

        <div id="wpcs_template_main" class="full_width">
            <div class="page-content">
                <?php the_content(); ?>
            </div>

            <div class="wpcs_element_spacer_big"></div>

            <div class="wpcs_grid wpcs_grid_3">
                <?php

                /**
                 * Price
                 */
                $price = get_post_meta($post->ID, "price", true);
                if(!empty($price)){
                    print '<div class="price_wrapper">';
                        print '<h3>Barpreis</h3>';
                        print do_shortcode('[WPCS_offer_price]');
                    print '</div>';
                }

                /**
                 * Leasing
                 */
                $leasing_price = get_post_meta($post->ID, "leasing_price", true);
                if(!empty($leasing_price)) {
                    print '<div class="leasing_price_wrapper">';
                        print '<h3>Leasing</h3>';
                        print do_shortcode('[WPCS_offer_leasing]');
                    print '</div>';
                }

                /**
                 * financing
                 */
                $financing_price = get_post_meta($post->ID, "financing_price", true);
                if(!empty($financing_price)) {
                    print '<div class="financing_price_wrapper">';
                        print '<h3>Finanzierung</h3>';
                        print do_shortcode('[WPCS_offer_financing]');
                    print '</div>';
                }

                ?>

            </div>

            <div class="wpcs_element_spacer_big"></div>

            <h3>Ansprechpartner</h3>
            <?php print do_shortcode('[WPCS_offer_team]'); ?>

            <div class="wpcs_element_spacer_big"></div>

            <h3>Angebot anfragen</h3>
            <?php print do_shortcode('[WPCS_form]'); ?>

            <div class="wpcs_element_spacer_big"></div>

            <?php #print do_shortcode('[WPCS_offer_mandatory_text]'); ?>
        </div>

    </div>

</main>

	<?php
endwhile;

get_footer();