<?php
$term = $data['term'];
$offers = $data['offers'] ?? [];

$image_id = get_term_meta($term->term_id, "teaser_image", true);
$excerpt = get_term_meta($term->term_id, "excerpt", true);
$src = wp_get_attachment_image_url($image_id, 'full');
$link = get_term_link($term->term_id);

?>
<article class="wpcs_offer_group wpcs_grid_item">

    <div class="wpcs_fitted_image">
        <a href="<?php print $link; ?>"><img src="<?php print $src; ?>" loading="lazy" alt="Aktion <?php print $term->name; ?>" /></a>
    </div>

    <div class="info">
        <h3 class="title"><a href="<?php print $link; ?>"><?php print $term->name; ?></a></h3>
        <?php if(!empty($excerpt)) print '<div class="excerpt">'.nl2br($excerpt).'</div>'; ?>
        <div class="offers">
            <?php
                $count = count($offers);
                if($count == 1) print '<strong>1</strong> enthaltenes Angebot';
                elseif($count > 1) print '<strong>'.$count.'</strong> enthaltene Angebote';
                else print 'Keine Angebote vorhanden';
            ?>
        </div>

        <a class="dxim_button dxim_button_light wpcs_align_right" href="<?php print $link; ?>">Aktion anzeigen</a>

    </div>
</article>